#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "cipcfg.h"
#include "syscall.h"
#include "id.h"

ITEM_LIST *set_rfcard_roles(char* itemvalue)
{
    ITEM_LIST *tmp=NULL;

    if(!strcmp(itemvalue, "AP")) {
	tmp = append_cfg_item(NULL, GID_RF1, "roles", "ap");
	tmp = append_cfg_item(tmp, GID_WAN_IP, "addr", "192.168.1.1");
	tmp = append_cfg_item(tmp, GID_WAN_IP, "gateway", "192.168.1.254");
	tmp = append_cfg_item(tmp, GID_WAN_IP, "dns1", "192.168.1.254");
    }
    else if(!strcmp(itemvalue, "CPE")) {
	tmp = append_cfg_item(NULL, GID_RF1, "roles", "sta");
    }
    return tmp;
}

int under_wireless(void)
{
    return 1;
}

ITEM_LIST *set_rep_related(void)
{
    int vap_gid_list[8] = {GID_RF1_VAP1, GID_RF1_VAP2, GID_RF1_VAP3, GID_RF1_VAP4, GID_RF1_VAP5, GID_RF1_VAP6, GID_RF1_VAP7, GID_RF1_VAP8};
    ITEM_LIST *tmp = NULL;
    int i;
    FILE *fp = NULL;

    tmp = append_cfg_item(NULL, vap_gid_list[1], "state", "disable");
    for(i = 2; i < 8; i++) {
	tmp = append_cfg_item(tmp, vap_gid_list[i], "state", "disable");
    }

    fp = fopen(PATH_SYNC_CFG, "a");
    if (fp != NULL) {
	fwrite("100\n", 1, strlen("100\n"), fp);
	fclose(fp);
    }
    return tmp;
}

void leave_rep(void)
{
    FILE *fp = NULL;
    CIPCFG *cipcfg = NULL;
    char roles[256];

    cipcfg = init_cipcfg();
    get_cfg_item_by_str(cipcfg, "rf1", "roles", roles);
    if(!strcmp(roles, "ap,rep")) {
	fp = fopen(PATH_SYNC_CFG, "a");
	if (fp != NULL) {
	    fwrite("100\n", 1, strlen("100\n"), fp);
	    fclose(fp);
	}
    }
    close_cipcfg(cipcfg);
}
