#ifndef _AC_PROTOCOL_USER_H_
#define _AC_PROTOCOL_USER_H_

#include "CWAC.h"

#define MAX_MOD_NAME	64
struct ACProtocol_User {
    char name[MAX_MOD_NAME];
    char *(*get_name)(void);
    int (*get_stations)(void);
    int (*get_limit)(void);
    int (*get_active_WTPs)(void);
    int (*get_max_WTPs)(void);
    int (*get_security)(void);
    int (*get_RMAC_field)(void);
    int (*get_DTLS_policy)(void);
    int (*get_HW_version)(void);
    int (*get_SW_version)(void);
    int (*get_interface_count)(void);
    int (*get_ipv4_address_at_index)(int i);
    char *(*get_ipv6_address_at_index)(int i);
    int (*get_WTP_count_at_index)(int i);
    CWBool (*get_vendor_infos)(CWACVendorInfos *valPtr);
    void (*get_destory_vendor_infos)(CWACVendorInfos *valPtr);
    CWBool (*get_ac_ipv4_list)(int **listPtr, int *countPtr);
    CWBool (*get_ac_ipv6_list)(struct in6_addr **listPtr, int *countPtr);
    CWBool (*get_discovery_timer)(int *timer);
    CWBool (*get_echo_request_timer)(int *timer);
    CWBool (*get_idle_timeout)(int *timer);
    CWBool (*get_radio_admin_state)(CWRadiosAdminInfo *valPtr);
    CWBool (*get_radio_operational_state)(int radioID, CWRadiosOperationalInfo *valPtr);

    int (*add_wtp)(CWWTPProtocolManager *WTPProtocolManager);
    int (*lib_init)(void);
    
    CWBool (*get_vsp_gre_conf)(VSPGreConf *greConf, CWWTPProtocolManager *WTPProtocolManager);
    CWBool (*get_vsp_acct_conf)(VSPAcctConf *acctConf, CWWTPProtocolManager *WTPProtocolManager);
    CWBool (*get_vsp_snmp_conf)(VSPSnmpConf *snmpConf, CWWTPProtocolManager *WTPProtocolManager);
    CWBool (*get_vsp_vap_conf)(VSPVapConf *vapConf, CWWTPProtocolManager *WTPProtocolManager);

    CWBool (*get_nat_check)(CWProtocolJoinRequestValues *joinRequest, CWWTPProtocolManager *WTPProtocolManager);
    CWBool (*check_wtp_hw)(CWWTPProtocolManager *WTPProtocolManager);
    int (*open_data_channel)(CWWTPProtocolManager *WTPProtocolManager);
    int (*close_data_channel)(CWWTPProtocolManager *WTPProtocolManager);
};


extern CWBool ACRegisterModule(struct ACProtocol_User *mod);
extern CWBool ACUnregisterModule(struct ACProtocol_User *mod);

#if 0
#define AC_MOD_INIT(f)	static void (f)(void) __attribute__((constructor))
#define AC_MOD_EXIT(f)	static void (f)(void) __attribute__((destructor))
#endif

#define MOD_INIT_FUNC	mod_init
#define MOD_EXIT_FUNC	mod_exit

#define _(x) #x
#define _QUOTE(x) _(x)
#define MOD_INIT_SYM	_QUOTE(MOD_INIT_FUNC)
#define MOD_EXIT_SYM	_QUOTE(MOD_EXIT_FUNC)

#define ALIAS_FUNC(n, f)    void n(void) __attribute__((alias(#f)))
#define AC_MOD_INIT(f)	    ALIAS_FUNC(MOD_INIT_FUNC, f)
#define AC_MOD_EXIT(f)	    ALIAS_FUNC(MOD_EXIT_FUNC, f)

#endif
