#include <dlfcn.h>
#include "CWAC.h"
#include "ACProtocol_User.h"

static void *ACModuleHandle = NULL;

CWBool ACRegisterModule(struct ACProtocol_User *mod)
{
	gACProtocolUser = mod;
	return CW_TRUE;
}

CWBool ACUnregisterModule(struct ACProtocol_User *mod)
{
	gACProtocolUser = NULL;
	return CW_TRUE;
}

CWBool CWACLoadUserModule(void)
{
	void (*init_func)(void);

	if (!gACUserModPath) {
		return CWErrorRaise(CW_ERROR_NEED_RESOURCE, 
				"No User Module defined");
	}
	else { 
	    if ((ACModuleHandle = dlopen(gACUserModPath, RTLD_LAZY)) == NULL)
		return CWErrorRaise(CW_ERROR_NEED_RESOURCE, dlerror());
	}

	*(void**)(&init_func) = dlsym(ACModuleHandle, MOD_INIT_SYM);
	if (!init_func) {
		dlclose(ACModuleHandle);
		return CWErrorRaise(CW_ERROR_NEED_RESOURCE, dlerror());
	}
	init_func();

	return CW_TRUE;
}

void CWACUnloadUserModule(void)
{
	if (ACModuleHandle)
		dlclose(ACModuleHandle);
}
