#include <dlfcn.h>
#include "CWWTP.h"
#include "WTPProtocol_User.h"

static void *WTPModuleHandle = NULL;

CWBool WTPRegisterModule(struct WTPProtocol_User *mod)
{
	gWTPProtocolUser = mod;
	return CW_TRUE;
}

CWBool WTPUnregisterModule(struct WTPProtocol_User *mod)
{
	gWTPProtocolUser = NULL;
	return CW_TRUE;
}

CWBool CWWTPLoadUserModule(void)
{
	void (*init_func)(void);

	if (!gWTPUserModPath)
		return CWErrorRaise(CW_ERROR_NEED_RESOURCE, 
				"No User Module defined");
	else if ((WTPModuleHandle = 
		    dlopen(gWTPUserModPath, RTLD_LAZY|RTLD_GLOBAL)) == NULL)
		return CWErrorRaise(CW_ERROR_NEED_RESOURCE, dlerror());

	*(void**)(&init_func) = dlsym(WTPModuleHandle, MOD_INIT_SYM);
	if (!init_func) {
		dlclose(WTPModuleHandle);
		return CWErrorRaise(CW_ERROR_NEED_RESOURCE, dlerror());
	}
	init_func();

	return CW_TRUE;
}

void CWWTPUnloadUserModule(void)
{
	if (WTPModuleHandle)
		dlclose(WTPModuleHandle);
}
