#include "WTPInterface.h"

CW_THREAD_RETURN_TYPE CWWTPReceiveStatus(void *arg)
{
	
	int sock,rlen,len,fromlen;
        struct  sockaddr_un servaddr; 
        struct  sockaddr_un from;
	unsigned char cmd_msg;

	CWThreadSetSignals(SIG_BLOCK, 1, SIGALRM);
	
	  /*      Create a UNIX datagram socket for this thread        */
        if ((sock = socket(AF_UNIX, SOCK_DGRAM, 0)) < 0) 
	{
                CWDebugLog("THR STATS: Error creating socket");
		CWExitThread();
        }
        
	/*      Set up address structure for server socket      */
        bzero(&servaddr, sizeof(servaddr));
	bzero(&from, sizeof(from));
        servaddr.sun_family = AF_UNIX;
        strcpy(servaddr.sun_path, WTP_STATUS_SOCKET_PATH);

        unlink(WTP_STATUS_SOCKET_PATH);

	len = sizeof(servaddr.sun_family) + strlen(servaddr.sun_path);

        if (bind(sock, (const struct sockaddr *) &servaddr,len) < 0) 
	{
                CWDebugLog("THR STATS: Error binding socket");
		CWExitThread();
        }

        fromlen = sizeof(from);

/*      Receive data */
	CW_REPEAT_FOREVER 
	{
		rlen = recvfrom(sock, &cmd_msg , CMD_TYPE_SIZE, 0, (struct sockaddr *)&from,(socklen_t *)&fromlen);
        	if (rlen == -1) 
		{
        		CWDebugLog("THR STATS: Error receiving from unix socket");
			CWExitThread();   
        	} 
		else 
		{
			if (cmd_msg == CMD_GET_STATUS) {
				CWWTPStatus status;
				CWProtocolMessage msg;
				if (CWThreadMutexTryLock(&gWTPStatusMutex)) {
					status.cur_state = gWTPStatus.cur_state;
					CW_COPY_NET_ADDR_PTR(&status.address, &gWTPStatus.address);
					CWThreadMutexUnlock(&gWTPStatusMutex);
					
					/*
					 * WTP Status Output format:
					 * +-+-+-+-+-+-+-+-+
					 * | State |  Addr |
					 * +-+-+-+-+-+-+-+-+
					 */
					CW_CREATE_PROTOCOL_MESSAGE(msg, 8, continue;);
					CWProtocolStore32(&msg, status.cur_state);
					CWProtocolStore32(&msg, ntohl(((struct sockaddr_in *)&status.address)->sin_addr.s_addr));
					sendto(sock, msg.msg, msg.offset, 0, (struct sockaddr *)&from, fromlen);
					CW_FREE_PROTOCOL_MESSAGE(msg);
				} else {
					/* TODO */
				}
			}
		}	
	} 
	
	close(sock);
	return(NULL);
}








