#ifndef _WTP_PROTOCOL_USER_H_
#define _WTP_PROTOCOL_USER_H_

#include "CWWTP.h"

#define MAX_MOD_NAME	64

struct WTPProtocol_User {
    char name[MAX_MOD_NAME];
    int (*get_discovery_type)(void);
    int (*get_max_radios)(void);
    int (*get_radio_in_use)(void);
    int (*get_enc_capabilities)(void);
    CWBool (*get_board_data)(CWWTPVendorInfos *valPtr);
    CWBool (*get_vendor_infos)(CWWTPVendorInfos *valPtr);
    void (*destroy_vendor_infos)(CWWTPVendorInfos *valPtr);
    int (*get_frame_tunnel_mode)(void);
    int (*get_mac_type)(void);
    char *(*get_location)(void);
    int *(*get_session_id)(unsigned int *session_id);
    int (*get_ipv4_address)(void);
    void (*get_ipv6_address)(struct sockaddr_in6 *myAddr);
    int (*get_ipv4_status_duplicate)(void);
    int (*get_ipv6_status_duplicate)(void);
    char *(*get_name)(void);
    CWBool (*get_radio_admin_state)(CWRadiosAdminInfo *valPtr);
    CWBool (*get_radio_operational_state)(int radioID, CWRadiosOperationalInfo *valPtr);
    CWBool (*get_decrypt_error_report)(int radioID, CWDecryptErrorReportInfo *valPtr);
    int (*get_ac_index)(void);
    char *(*get_ac_name)(void);
    int (*get_statistics_timer)(void);
    CWBool (*get_ac_name_with_index)(CWACNamesWithIndex *ACsInfo);
    int (*save_ac_info)(CWACInfoValues *ACInfoPtr);
    int (*save_aclist)(CWACInfoValues *ACInfoPtr);
    CWBool (*get_vsp_gre_conf)(VSPGreConf *greConf);
    CWBool (*get_vsp_acct_conf)(VSPAcctConf *acctConf);
    CWBool (*get_vsp_snmp_conf)(VSPSnmpConf *snmpConf);
    CWBool (*get_vsp_vap_conf)(VSPVapConf *vapConf);
    int (*save_vsp_conf)(VSP4IPConf *vsp4ipConf);
    int (*open_data_channel)(CWACInfoValues *ACInfoPtr);
    int (*close_data_channel)(CWACInfoValues *ACInfoPtr);
};

extern CWBool WTPRegisterModule(struct WTPProtocol_User *mod);
extern CWBool WTPUnregisterModule(struct WTPProtocol_User *mod);

#if 0  /* uClibc not support constructor/destructor */
#define WTP_MOD_INIT(f)	static void (f)(void) __attribute__((constructor))
#define WTP_MOD_EXIT(f)	static void (f)(void) __attribute__((destructor))
#endif

#define MOD_INIT_FUNC	mod_init
#define MOD_EXIT_FUNC	mod_exit

#define _(x) #x
#define _QUOTE(x) _(x)
#define MOD_INIT_SYM	_QUOTE(MOD_INIT_FUNC)
#define MOD_EXIT_SYM	_QUOTE(MOD_EXIT_FUNC)

#define ALIAS_FUNC(n, f)    void n(void) __attribute__((alias(#f)))
#define WTP_MOD_INIT(f)	    ALIAS_FUNC(MOD_INIT_FUNC, f)
#define WTP_MOD_EXIT(f)	    ALIAS_FUNC(MOD_EXIT_FUNC, f)

#endif
