<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
    <% include /include/chk_permission.inc.esp %>
    <% include /include/deny_operator.inc.esp %>
    <% include /include/deny_manager.inc.esp %>
    <title><%getTitle();%></title> 
    <meta content="no-cache" http-equiv="Pragma">
    <meta content="no-cache" http-equiv="Cache-Control">
    <meta content="text/html; charset=utf-8" http-equiv="Content-Type">
    <link href="/css/inner_main.css" rel="stylesheet" type="text/css" media="screen,print">
    <style>
	<% include /include/customize.css.esp %>
    </style>
    <script language="javascript" src="../utils.js"></script> 
    <script type="text/javascript">
<%
    gid = "capwap";
%>

$(document).ready(function () {
	$("#capwap_state_disable,#capwap_state_enable").change(function () {
		var value = $(this).val();
		$(".capwap_input").each(function () {
			this.disabled = (value == "disable" ? true : false);
		});
	});
	$(".capwap_srv").change(function () {
		var value = $(this).val();
		if (value == "enable") {
			$("#srv_suffix").show();
		} else if (value == "disable") {
			$("#srv_suffix").hide();
		}
	});
	$(".capwap_broadcast").change(changeBroadcast);
	$(".capwap_multicast").change(changeMulticast);
        $(".capwap_unicast").change(function () {
	        var value = $(this).val();
		if (value == "enable") {
			$("#acList").show();
		} else if (value == "disable") {
			$("#acList").hide();
		}
	});
	$("#save_btn").click(SaveClick);
	formLoad();
});

function setValues()
{
    var form = document.forms[0];
    var state, check_cert, dns_srv, dhcp_opt, unicast;

    state = '<%write(getCfg(gid, "state"));%>';
    check_cert = '<%write(getCfg(gid, "check_cert"));%>';
    dns_srv = '<%write(getCfg(gid, "discovery.dns_srv"));%>';
    dns_srv_suffix = '<%write(getCfg(gid, "discovery.srv_suffix"));%>';
    dhcp_opt = '<%write(getCfg(gid, "discovery.dhcp_opt"));%>';
    unicast = '<%write(getCfg(gid, "discovery.unicast"));%>';

    /* Generate AP/WDS interface list */
    var ifJsonStr = '<% genTunInterfaceList(); %>';

    jQuery.each(jQuery.parseJSON(ifJsonStr), function (iftype, interfaces) {
	$('#tun_if_list').append('<li id="'+iftype+'_if_list"></li>');
	jQuery.each(interfaces, function (idx, elm) {
	    if(elm == undefined) return true;
	    var $ap = $('<label style="margin-right:3px">' + 
		'<input type="checkbox" id="'+iftype+idx+'" name="'+iftype+idx+'">' + 
		(elm['desc'] == undefined ? iftype.toUpperCase()+(idx+1) : elm['desc']) + 
		'</label>');
	    if (elm['state'] == true) {
		$ap.find(":checkbox").first().addClass("capwap_input");
	    } else {
		$ap.find(":checkbox").get(0).disabled = true;
	    }
	    if (elm['tun_state'] == true) {
		$ap.find(":checkbox").get(0).checked = true;
	    }
	    $ap.appendTo($("#"+iftype+"_if_list"));
	});
    });

    if (check_cert == "disable") {
	form.check_cert[0].checked = true;
    } else if (check_cert == "enable") {
	form.check_cert[1].checked = true;
    }
    if (dns_srv == "disable") {
	form.dns_srv[0].checked = true;
	$("#dns_srv_disable").trigger("change");
    } else if (dns_srv == "enable") {
	form.dns_srv[1].checked = true;
	form.srv_suffix.value = dns_srv_suffix;
	$("#dns_srv_enable").trigger("change");
    }
    if (dhcp_opt == "disable") {
	form.dhcp_opt[0].checked = true;
    } else if (dhcp_opt == "enable") {
	form.dhcp_opt[1].checked = true;
    }
    form.broadcast.value = '<%write(getCfg(gid, "discovery.broadcast"));%>';
    if (form.broadcast.value == "") {
	form.broadcast_state[0].checked = true;
    } else {
	form.broadcast_state[1].checked = true;
    }
    form.multicast.value = '<%write(getCfg(gid, "discovery.multicast"));%>';
    if (form.multicast.value == "") {
	form.multicast_state[0].checked = true;
    } else {
	form.multicast_state[1].checked = true;
    }
    if (unicast == "disable") {
	form.unicast[0].checked = true;
	$("#unicast_disable").trigger("change");
    } else if (unicast == "enable") {
	form.unicast[1].checked = true;
	$("#unicast_enable").trigger("change");
    }

    if (state == "disable") {
	    $('#capwap_state_disable').get(0).checked = true;
	    $('#capwap_state_disable').trigger("change");
    } 
    else if (state == "enable") {
	    $('#capwap_state_enable').get(0).checked = true;
	    $('#capwap_state_enable').trigger("change");
    }
}

function checkPermission()
{
    var form = document.forms[0];
    var capwap_perm = '<% write(getAccessRight(gid)); %>';
    var tbl_size = <% write(getCfg(gid, "aclist.table_size")); %>;

    if (capwap_perm == "R") {
	    $("#capwap_state_disable,#capwap_state_enable,.capwap_input").each(function () {
		    this.disabled = true;
	    });
    }
}

function changeBroadcast()
{
    var form = document.forms[0];

    if (form.broadcast_state[0].checked == true) {
	form.broadcast.value = "";
    } else if (form.broadcast_state[1].checked == true) {
	form.broadcast.value = "255.255.255.255";
    }
}

function changeMulticast()
{
    var form = document.forms[0];

    if (form.multicast_state[0].checked == true) {
	form.multicast.value = "";
    } else if (form.multicast_state[1].checked == true) {
	form.multicast.value = "224.0.1.140";
    }
}

function formLoad()
{
    var form = document.forms[0];
    
    isConfigSync(<%write(getStatus("sync_cfg"));%>);

    checkPermission();
    setValues();
}

function inputCheck()
{
    var form = document.forms[0];
    var i;

    /*
    if (form.broadcast.value != "") {
	if (isValidIpAddr(form.broadcast.value) == false) {
	    alert("Invalid IP address :" + form.broadcast.value);
	    form.broadcast.focus();
	    form.broadcast.select();
	    return false;
	}
    }

    if (form.multicast.value != "") {
	if (isValidIpAddr(form.multicast.value) == false) {
	    alert("Invalid IP address :" + form.multicast.value);
	    form.multicast.focus();
	    form.multicast.select();
	    return false;
	}
    }
    */

    if (form.srv_suffix.value != "") {
	    if (isValidDomain(form.srv_suffix.value, 2) == false) {
		    alert("Invalid Domain Name suffix :" + form.srv_suffix.value);
		    form.srv_suffix.focus();
		    form.srv_suffix.select();
		    return false;
	    }
    }

    var tbl_size = <%write(getCfg(gid, "aclist.table_size")); %>;
    for (i = 0; i < tbl_size; i++) {
	acname = document.getElementById('acname'+i);
	acaddr = document.getElementById('acaddr'+i);
	if (acaddr.value != "") {
	    if (isValidIpAddr(acaddr.value) == false) {
		alert("Invalid IP address :" + acaddr.value);
		acaddr.focus();
		acaddr.select();
		return false;
	    }
	}
    }
    return true;
}

function applyClick()
{
    if (inputCheck() == true) {
        document.forms[0].apply.value = true;
        document.forms[0].submit();
    }
}

function SaveClick()
{
    if (inputCheck() == true) {
        document.forms[0].apply.value = false;
        document.forms[0].submit();
    }
}
    </script>
</head>
<body>
<!-- Begin top button -->
<div class="primary_menu">
    <iframe frameborder="no" marginheight="0" marginwidth="0" name="top" scrolling="no" src="/top.asp?selected=system"></iframe>
</div>
<!-- End top button -->
<div class="middle_part">
    <!-- Begin 2nd menu -->
    <div class="secondary_menu">
        <iframe frameborder="no" marginheight="0" marginwidth="0" name="top" scrolling="no" src="tag_capwap.htm"></iframe>
    </div>
    <!-- Begin main content -->
    <div class="main">
        <div class="toppath"><a href="../home.asp">Home</a> &gt; <a href="./sysinfo.asp">System</a> &gt; CAPWAP</div>
        <div id="reboot_message" name="reboot_message" style="display:none" class="red_msg">*Some modifications have been saved and will take effect after <a href="/utilities/reboot.asp">REBOOT</a>.</div>
        <form action="/goform/applyCapwap" method="post" name="sysmgnt">
	    <input name="apply" type="hidden" value=""/>
<div class="fb">
    <div class="fb_title">CAPWAP Configuration</div>
    <div class="fb_row">
	<span class="item_name">CAPWAP :</span>
	<span class="item_value">
	    <label><input id="capwap_state_disable" name="state" type="radio" value="disable" />Disable</label>
	    <label><input id="capwap_state_enable" name="state" type="radio" value="enable" />Enable</label>
	</span>
    </div>
    <div class="fb_row" id="tun_if_row">
	<span class="item_name">Tunnel Interface :</span>
	<span class="item_value">
	    <ul id="tun_if_list">
		<!-- interface list will be created here by javascript -->
	    </ul>
	</span>
    </div>
    <div class="fb_row">
	<span class="item_name">Certificate Date Check:</span>
	<span class="item_value">
	    <label><input class="capwap_input" name="check_cert" type="radio" value="disable" />Disable</label>
	    <label><input class="capwap_input" name="check_cert" type="radio" value="enable" />Enable</label>
	    <input type="button" value="Manage Certificates" onclick="window.location.href='/utilities/upload_cert.asp';" />
	</span>
    </div>
    <div class="fb_row">
	<span class="item_name">DNS SRV Discovery :</span>
	<span class="item_value">
		<label><input class="capwap_input capwap_srv" id="dns_srv_disable" name="dns_srv" type="radio" value="disable" />Disable</label>
		<label><input class="capwap_input capwap_srv" id="dns_srv_enable" name="dns_srv" type="radio" value="enable" />Enable</label>
		<ul id="srv_suffix">
			<li>Domain Name Suffix :<input class="capwap_input" name="srv_suffix" type="text"></li>
		</ul>
	</span>
    </div>
    <div class="fb_row">
	<span class="item_name">DHCP Option Discovery :</span>
	<span class="item_value">
	    <label><input class="capwap_input" name="dhcp_opt" type="radio" value="disable" />Disable</label>
	    <label><input class="capwap_input" name="dhcp_opt" type="radio" value="enable" />Enable</label>
	</span>
    </div>
    <div class="fb_row">
	<span class="item_name">Broadcast Discovery :</span>
	<span class="item_value">
	    <label><input class="capwap_input capwap_broadcast" name="broadcast_state" type="radio" value="disable" />Disable</label>
	    <label><input class="capwap_input capwap_broadcast" name="broadcast_state" type="radio" value="enable" />Enable</label>
	    <input class="capwap_input" name="broadcast" type="hidden" maxlength="16" size="20" value="" />
	</span>
    </div>
    <div class="fb_row">
	<span class="item_name">Multicast Discovery :</span>
	<span class="item_value">
	    <label><input class="capwap_input capwap_multicast" name="multicast_state" type="radio" value="disable" />Disable</label>
	    <label><input class="capwap_input capwap_multicast" name="multicast_state" type="radio" value="enable" />Enable</label>
	    <input class="capwap_input" name="multicast" type="hidden" maxlength="16" size="20" value="" />
	</span>
    </div>
    <div class="fb_row">
	<span class="item_name">Static Discovery :</span>
	<span class="item_value">
	    <label><input class="capwap_input capwap_unicast" id="unicast_disable" name="unicast" type="radio" value="disable" />Disable</label>
	    <label><input class="capwap_input capwap_unicast" id="unicast_enable" name="unicast" type="radio" value="enable" />Enable</label>
	</span>
    </div>	
    <div style="padding:6px">
	<table id="acList" class="list_table" style="width:600px">
	    <tr class="tbl_title">
		<td width="50">Pri.</td>
		<td width="250">AC Address</td>
		<td width="250">Remark</td>
	    </tr>
	    <script>
		var acJsonStr = '<% getACList(); %>';
		var acList = jQuery.parseJSON(acJsonStr);
		acList.sort(function (a, b) { return a.priority > b.priority; });
		for (i = 0; i < acList.length; i++) {
		    document.write('\
		    <tr class="tbl_value"> \
			<td>'+(i+1)+'</td> \
			<td> \
			    <input type="text" class="textinput capwap_input" id="acaddr'+i+'" name="acaddr'+i+'" size="20" maxlength="17" value="'+acList[i].ip+'" /> \
			</td> \
			<td> \
			    <input type="text" class="textinput capwap_input" id="acname'+i+'" name="acname'+i+'" size="20" maxlength="16" value="'+acList[i].name+'" /> \
			</td> \
		    </tr>');
		}
	    </script>
	</table>
    </div>
</div>
</form>
        <ul class="chk_2_button">
            <li><a href="#" id="save_btn"><span>SAVE</span></a></li>
<!--            <li><a href="#" onclick="applyClick();"><span>APPLY</span></a></li> -->
            <li><a href="javascript:document.forms[0].reset();window.location.reload()"><span>CLEAR</span></a></li>
        </ul>
    </div>
    <!-- End main content -->
</div><!-- End middle_part -->
<div id="footer"><%getFooter();%></div>
</body>
</html>
