<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN""
"http://www.w3.org/TR/html4/loose.dtd">
<html>
    <head>
	<% include /include/chk_permission.inc.esp %>
	<% include /include/deny_operator.inc.esp %>
	<% include /include/deny_manager.inc.esp %>
	<title><%getTitle();%></title> 
	<meta content="no-cache" http-equiv="Pragma">
	<meta content="no-cache" http-equiv="Cache-Control">
	<meta content="text/html; charset=utf-8" http-equiv="Content-Type">
	<link href="/css/inner_main.css" rel="stylesheet" type="text/css" media="screen,print">
	<style>
	    <% include /include/customize.css.esp %>
	</style>
	<script language="javascript" src="../utils.js"></script> 
	<script language="javascript">
	    $(document).ready(function () {
		$("#gre_state_disable,#gre_state_enable").change(function () {
		    var value = $(this).val();
		    $('.gre_input').each(function() {
			this.disabled = (value == "disable" ? true : false);
		    });
		});
		$("#save_btn").click(SaveClick);
		formLoad();
	    });

	    function formLoad()
	    {
		var state = '<%write(getCfg("gre", "state"));%>';

		isConfigSync(<%write(getStatus("sync_cfg"));%>);

		/* Generate AP/WDS interface list */
		var ifJosonStr = '<% genGreInterfaceList(); %>';

		jQuery.each(jQuery.parseJSON(ifJosonStr), function (iftype, interfaces) {
		    $('#gre_if_list').append('<li id="'+iftype+'_if_list"></li>');
		    jQuery.each(interfaces, function (idx, elm) {
			if(elm == undefined) return true;
			var $ap = $('<label style="margin-right:3px">' + 
			    '<input type="checkbox" id="'+iftype+idx+'" name="'+iftype+idx+'">' + 
			    iftype.toUpperCase()+(idx+1)+ 
			    '</label>');
			if (elm['state'] == true) {
			    $ap.find(":checkbox").first().addClass("gre_input");
			} else {
			    $ap.find(":checkbox").get(0).disabled = true;
			}
			if (elm['gre_state'] == true) {
			    $ap.find(":checkbox").get(0).checked = true;
			}
			$ap.appendTo($("#"+iftype+"_if_list"));
		    });
		});

		if (state == "disable") {
		    $('#gre_state_disable').get(0).checked = true;
		    $('.gre_input').each(function() {this.disabled = true;});
		} 
		else if (state == "enable") {
		    $('#gre_state_enable').get(0).checked = true;
		    $('.gre_input').each(function() {this.disabled = false;});
		}
		$('#gre_remote').val('<%write(getCfg("gre", "remote"));%>');
		$('#gre_key').val('<%write(getCfg("gre", "key"));%>');
	    }

	    function inputCheck()
	    {
		if ($("#gre_state_enable").get(0).checked == true) {
		    if ($("#gre_remote").val() != "") {
			if (isValidIpAddr($("#gre_remote").val()) == false) {
			    alert("Invalid GRE remote IP address : " + $("#gre_remote").val());
			    $("#gre_remote").focus();
			    $("#gre_remote").select();
			    return false;
			}
		    }
		    else {
			alert("Please enter IP address.");
			$("#gre_remote").focus();
			return false;
		    }

		    if ($("#gre_key").val() != "") {
			if (isValidNumRange($("#gre_key").val(), 0, 4294967295) == false) {
			    alert("Invalid key value, the range should be 0 - 4294967295.");
			    $("#gre_key").focus();
			    $("#gre_key").select();
			    return false;
			}
		    }
		}
		return true;
	    }

	    function SaveClick()
	    {
		if (inputCheck() == true) {
		    $("#apply").val(false);
		    $("#gremgnt").submit();
		}
	    }
	</script>
    </head>
    <body>
	<!-- Begin top button -->
	<div class="primary_menu">
	    <iframe frameborder="no" marginheight="0" marginwidth="0" name="top" scrolling="no" src="/top.asp?selected=system"></iframe>
	</div>
	<!-- End top button -->

	<div class="middle_part">
	    <!-- Begin 2nd menu -->
	    <div class="secondary_menu">
		<iframe frameborder="no" marginheight="0" marginwidth="0" name="top" scrolling="no" src="tag_gre.htm"></iframe>
	    </div>
	    <!-- End 2nd menu -->
	    <!-- Begin main content -->
	    <div class="main">
		<div class="toppath"><a href="../home.asp">Home</a> &gt; <a href="./sysinfo.asp">System</a> &gt; Management Services</div>
		<div id="reboot_message" name="reboot_message" style="display:none" class="red_msg">*Some modifications have been saved and will take effect after <a href="/utilities/reboot.asp">REBOOT</a>.</div>
		<form action="/goform/applyGre" method="post" name="gremgnt" id="gremgnt">
		    <input name="apply" id="apply" type="hidden" value="">
		    <div class="fb">
			<div class="fb_title">GRE Tunnel Configuration</div>
			<div class="fb_row" id="gre_row">
			    <span class="item_name">GRE Tunnel :</span>
			    <span class="item_value">
				<ul>
				    <li><label><input name="gre_state" id="gre_state_disable" type="radio" value="disable"> Disable&nbsp;&nbsp;&nbsp;&nbsp;</label><label><input name="gre_state" id="gre_state_enable" type="radio" value="enable"> Enable</label></li>
				    <li>Remote IP :&nbsp;<input class="textinput gre_input" maxlength="16" name="gre_remote" id="gre_remote" size="20" type="text" value=""></li> 
				    <li>Key :&nbsp;<input class="textinput gre_input" maxlength="16" name="gre_key" id="gre_key" size="20" type="text" value=""></li> 
				</ul>
			    </span>
			</div>
			<div class="fb_row" id="gre_if_row">
			    <span class="item_name">Interface :</span>
			    <span class="item_value">
				<ul id="gre_if_list">
				    <!-- interface list will be created here by javascript -->
				</ul>
			    </span>
			</div>
		    </div>
		</form>
		<ul class="chk_2_button">
		    <li><a href="#" id="save_btn"><span>SAVE</span></a></li>
		    <!--            <li><a href="#" onclick="applyClick();"><span>APPLY</span></a></li> -->
		    <!--li><a href="#" id="clear_btn"><span>CLEAR</span></a></li-->
		    <li><a href="javascript:document.forms[0].reset();window.location.reload()"><span>CLEAR</span></a></li>
		</ul>
	    </div> <!-- End main content -->
	</div><!-- End middle_part -->
	<div id="footer"><%getFooter();%></div>
    </body>
</html>
