<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN""
"http://www.w3.org/TR/html4/loose.dtd">
<html>
    <head>
	<% include /include/chk_permission.inc.esp %>
	<% include /include/deny_operator.inc.esp %>
	<% include /include/deny_manager.inc.esp %>
	<title><%getTitle();%></title> 
	<meta content="no-cache" http-equiv="Pragma">
	<meta content="no-cache" http-equiv="Cache-Control">
	<meta content="text/html; charset=utf-8" http-equiv="Content-Type">
	<link href="/css/inner_main.css" rel="stylesheet" type="text/css" media="screen,print">
	<style>
	    <% include /include/customize.css.esp %>
	</style>
	<script language="javascript" src="../utils.js"></script> 
	<script language="javascript">
	    $(document).ready(function () {
		$("#ipv6_state_disable,#ipv6_state_enable").change(function () {
		    var value = $(this).val();
		    $('.ipv6_input').each(function() {
			this.disabled = (value == "disable" ? true : false);
		    });
		});

		$("#ipv6_mode_static,#ipv6_mode_dhcp").change(function () {
		    var value = $(this).val();
		    $("#fixed")[0].style.display = (value == "dhcp" ? "none" : "");
		});

		$("#save_btn").click(SaveClick);
		formLoad();
	    });

	    function formLoad()
	    {
		var state = '<%write(getCfg("ipv6", "state"));%>';
		var mode = '<%write(getCfg("ipv6", "mode"));%>';

		isConfigSync(<%write(getStatus("sync_cfg"));%>);

		if (state == "disable") {
		    $('#ipv6_state_disable').get(0).checked = true;
		    $('.ipv6_input').each(function() {this.disabled = true;});
		} 
		else if (state == "enable") {
		    $('#ipv6_state_enable').get(0).checked = true;
		    $('.ipv6_input').each(function() {this.disabled = false;});
		}
		if (mode == "static") {
		    $('#ipv6_mode_static').get(0).checked = true;
		} 
		else if (mode == "dhcp") {
		    $('#ipv6_mode_dhcp').get(0).checked = true;
		}

		$("#fixed")[0].style.display = ($("#ipv6_mode_static").get(0).checked == true ? "" : "none");

		$('#addr').val('<%write(getCfg("ipv6", "addr"));%>');
		$('#prefix').val('<%write(getCfg("ipv6", "prefix"));%>');
		$('#gateway').val('<%write(getCfg("ipv6", "gateway"));%>');
		$('#dns1').val('<%write(getCfg("ipv6", "dns1"));%>');
		$('#dns2').val('<%write(getCfg("ipv6", "dns2"));%>');
	    }

	    function inputCheck()
	    {
		if ($("#ipv6_state_enable").get(0).checked == true) {
		    if ($("#ipv6_mode_static").get(0).checked == true) {
			if(!Validate_IP6($("#addr")[0], "0"))
			    return false;
			
			if ($("#prefix").val() == "") {
		            alert("Please fill in the Prefix Length!");
		            $("#prefix").focus();
		            $("#prefix").select();
		            return false;
		        }
		        if($("#prefix").val() < 0 || $("#prefix").val() > 128) {
		            alert("The valid range of Prefix Length is between 0 and 128.");
		            $("#prefix").focus();
		            $("#prefix").select();
		            return false;
		        }

			if(!Validate_IP6($("#gateway")[0], "0"))
			    return false;

			if(!Validate_IP6($("#dns1")[0], "1"))
			    return false;

			if(!Validate_IP6($("#dns2")[0], "1"))
			    return false;

		    }
		}
		return true;
	    }

	    function SaveClick()
	    {
		if (inputCheck() == true) {
		    $("#apply").val(false);
		    $("#ipv6mgnt").submit();
		}
	    }
	</script>
    </head>
    <body>
	<!-- Begin top button -->
	<div class="primary_menu">
	    <iframe frameborder="no" marginheight="0" marginwidth="0" name="top" scrolling="no" src="/top.asp?selected=system"></iframe>
	</div>
	<!-- End top button -->

	<div class="middle_part">
	    <!-- Begin 2nd menu -->
	    <div class="secondary_menu">
		<iframe frameborder="no" marginheight="0" marginwidth="0" name="top" scrolling="no" src="tag_ipv6.htm"></iframe>
	    </div>
	    <!-- End 2nd menu -->
	    <!-- Begin main content -->
	    <div class="main">
		<div class="toppath"><a href="../home.asp">Home</a> &gt; <a href="./sysinfo.asp">System</a> &gt;IPv6 Configuration</div>
		<div id="reboot_message" name="reboot_message" style="display:none" class="red_msg">*Some modifications have been saved and will take effect after <a href="/utilities/reboot.asp">REBOOT</a>.</div>
		<form action="/goform/applyIPv6" method="post" name="ipv6mgnt" id="ipv6mgnt">
		    <input name="apply" id="apply" type="hidden" value="">
		    <div class="fb">
			<div class="fb_title">IPv6 Configuration</div>
			<div class="fb_row" id="status_div">
			    <span class="item_name">Status :</span>
			    <span class="item_value">
				<ul>
				    <li><label><input name="ipv6_state" id="ipv6_state_disable" type="radio" value="disable"> Disable&nbsp;&nbsp;&nbsp;&nbsp;</label><label><input name="ipv6_state" id="ipv6_state_enable" type="radio" value="enable"> Enable</label></li>
				</ul>
			    </span>
			</div>

			<div class="fb_row" id="mode_div">
			    <span class="item_name">Mode :</span>
			    <span class="item_value">
				<ul>
				    <li><label><input class="ipv6_input" name="ipv6_mode" id="ipv6_mode_static" type="radio" value="static"> Static&nbsp;&nbsp;&nbsp;&nbsp;</label><label><input class="ipv6_input" name="ipv6_mode" id="ipv6_mode_dhcp" type="radio" value="dhcp"> DHCP</label></li>
				</ul>
			    </span>
			</div>

			<div id="fixed" name="fixed" style="display:none">
			    <div class="fb_row">
		                <span class="item_name"></span>
		                <span class="item_value">
		                <ul>
		                <li>IPv6 Address : <input class="textinput ipv6_input" maxlength="39" id="addr"  name="addr" size="42" type="text" value=""><span class="red">*</span></li>
		                <li>Prefix Length : <input class="textinput ipv6_input" maxlength="3" id="prefix" name="prefix" size="5" type="text" value=""><span class="red">*</span></li>
				<li>Default Gateway : <input class="textinput ipv6_input" maxlength="39" id="gateway" name="gateway" size="42" type="text" value=""><span class="red">*</span></li>
		                <li>Primary DNS Server : <input class="textinput ipv6_input" maxlength="39" id="dns1" name="dns1" size="42" type="text" value=""></li>
				<li>Alternate DNS Server : <input class="textinput ipv6_input" maxlength="39" id="dns2" name="dns2" size="42" type="text" value=""></li>
				</ul>
				</span>
		            </div>
		        </div>

		    </div>
		</form>
		<ul class="chk_2_button">
		    <li><a href="#" id="save_btn"><span>SAVE</span></a></li>
		    <!--            <li><a href="#" onclick="applyClick();"><span>APPLY</span></a></li> -->
		    <!--li><a href="#" id="clear_btn"><span>CLEAR</span></a></li-->
		    <li><a href="javascript:document.forms[0].reset();window.location.reload()"><span>CLEAR</span></a></li>
		</ul>
	    </div> <!-- End main content -->
	</div><!-- End middle_part -->
	<div id="footer"><%getFooter();%></div>
    </body>
</html>
