<!DOCTYPE HTML PUBLIC "-//W3C//Dtd HTML 4.01 transitional//EN"
"http://www.w3.org/tr/html4/loose.dtd"> 
<html> 
    <head>
	<% include /include/chk_permission.inc.esp %>
	<% include /include/deny_operator.inc.esp %>
	<% include /include/deny_manager.inc.esp %>
	<title><%getTitle();%></title> 
	<meta content="no-cache" http-equiv="Pragma">
	<meta content="no-cache" http-equiv="Cache-Control">
	<meta content="text/html; charset=utf-8" http-equiv="Content-Type">
	<link href="/css/inner_main.css" rel="stylesheet" type="text/css" media="screen,print">
	<style>
	    <% include /include/customize.css.esp %>
	</style>
	<script language="javascript" src="/utils.js"></script> 
	<script language="javascript">
	    <!-- hide

	    <%
		var max_port = getCfg("network_L2", "lan_num");
		var port_no = 0;
		var found = -1;
		for (i = max_port-1; i >= 0; i--) {
		    var controllable = getCfg("network_L2", "lan:"+i+".controllable");
		    if (controllable == "enable")
			port_no = i;
		    if (form['port'] != undefined && form['port'] == i)
			found = i;
		}
		if (found >= 0)
		    port_no = found;
	    %>

	    $(document).ready(function () {
		var lanJsonStr= '<% genLanPortList(); %>';
		jQuery.each(jQuery.parseJSON(lanJsonStr), function (idx, elm) {
		    $("#port").append('<option value="'+elm+'">LAN'+elm+'</option>');
		});
		$("#port").change(function () {
		    location.assign(location.pathname +'?port='+$(this).val());
		});
		$("#vlan_enable,#vlan_disable").change(function () {
		    $("#vid").attr("disabled",($(this).val() == "disable" ? true : false));
		});
		$("#save_btn").click(function () {
		    if (inputCheck() == true) {
			$("#port_config_form").submit();
		    }
		});
		$("#clear_btn").click(function () {
		    $("#port_config_form").trigger("reset");
		    window.location.reload();
		});
		isConfigSync(<%write(getStatus("sync_cfg"));%>);
		setValues();
	    });

	    function setValues()
	    {
		var port = <%=port_no%>;
		var vid = "<%write(getCfg("network_L2", "lan:"+port_no+".vid"));%>";

		$("#port > option[value="+port+"]").attr('selected', true);
		if (isValidNumRange(vid, 1, 4094)) {
		    $("#vlan_enable").attr("checked", true).change();
		    $("#vid").val(vid);
		}
		else {
		    $("#vlan_disable").attr("checked", true).change();
		}
	    }

	    function inputCheck()
	    {
		var checked = $("#vlan_enable").attr("checked");
		if ( checked == true || checked == "checked") {
		    $vid = $("#vid");
		    if ($vid.val() == "" || isNaN($vid.val())) {
			alert("Please enter VLAN ID ( 1 - 4094 ).");
			$vid.select();
			return false;
		    }
		    else if (parseInt($vid.val(),10) > 4094 || parseInt($vid.val(),10) < 1) {
			alert("The range of VLAN ID is ( 1 - 4094 ).");
			$vid.select();
			return false;
		    }
		    else{
			$vid.val(parseInt($vid.val(), 10));
		    }
		}
		return true;
	    }

	    //hide-->
	</script> 
    </head>
    <body>
	<!-- Begin top button -->
	<div class="primary_menu">
	    <iframe frameborder="no" marginheight="0" marginwidth="0" name="top" scrolling="no" src="/top.asp?selected=system"></iframe>
	</div>
	<!-- End top button -->

	<div class="middle_part">
	    <!-- Begin 2nd menu -->
	    <div class="secondary_menu">
		<iframe frameborder="no" marginheight="0" marginwidth="0" name="top" scrolling="no" src="tag_port.htm"></iframe>
	    </div>
	    <!-- End 2nd menu -->

	    <!-- Begin main content -->
	    <div class="main">
		<div class="toppath"><a href="../home.asp">Home</a> &gt; <a href="./overview.asp">System</a> &gt; Port Config</div>
		<div id="reboot_message" name="reboot_message" style="display:none" class="red_msg">*Some modifications have been saved and will take effect after <a href="/utilities/reboot.asp">REBOOT</a>.</div>
		<form action="/goform/applyPort" method="post" name="port_config" id="port_config_form">
		    <div class="fb">
			<div class="fb_title">Port Configuration</div>
			<div id="profile_name">Port : 
			    <select class="textinput" name="port" id="port">
				<!-- LAN port list will be created here by javascript -->
			    </select>
			</div>
			<div class="fb_row">
			    <span class="item_name">VLAN ID :</span>
			    <span class="item_value">
				<label><input name="vlan" id="vlan_disable" type="radio" value="disable"> Disable&nbsp;&nbsp;</label>
				<label><input name="vlan" id="vlan_enable" type="radio" value="enable"> Enable &nbsp;&nbsp;</label><br>
				VLAN ID :&nbsp;<input class="textinput" maxlength="4" name="vid" id="vid" size="6" type="text" value="">
				<span class="red_msg">*( 1 - 4094 )</span>
			    </span>
			</div>
		    </div>
		    <div id="tip" style="width:50%; padding-left:25%;">
			    <span class="red_msg">TIP:
			    <br/>*For tunneled LAN ports, Service Zones to VLAN ID Mappings are: Default Zone = 1000, SZ1 = 1001, SZ2 = 1002, SZ3 = 1003, SZ4 = 1004, SZ5 = 1005, SZ6 = 1006, SZ7 = 1007, SZ8 = 1008.
			    <br/>*LAN port traffic tunneled back to a WHG Controller without a VLAN ID will be suspended from access to any network service.
			    </span>
		    </div>
		</form>
		<ul class="chk_2_button">
		    <li><a href="#" id="save_btn"><span>SAVE</span></a></li>
		    <li><a href="#" id="clear_btn"><span>CLEAR</span></a></li>
		</ul>
	    </div>
	    <!-- End main content -->
	</div>
	<!-- End middle_part -->
	<div id="footer"><%getFooter();%></div>
    </body>
</html> 
