#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "cipcfg.h"
#include "syscall.h"

void usage(void)
{
    printf("decrypt_cipcfg <file>\n");
}

int main(int argc, char *argv[])
{
    int fd, len, ret;
    char *filename;
    unsigned char *buf, *cfg;
    struct stat st;
    CFG_HEADER *cfg_hdr;

    if (argc < 2) {
	usage();
	exit(EXIT_FAILURE);
    }

    /* Read data from file */
    filename = argv[1];
    if ((fd = open(filename, O_RDONLY)) < 0) {
	printf("Can't open %s\n", filename);
	goto fail;
    }
    if (fstat(fd, &st) < 0) {
	printf("Can't get stat of %s\n", filename);
	goto fail;
    }
    len = st.st_size;
    buf = (unsigned char *)malloc(len);
    if (read(fd, buf, len) != len) {
	printf("Can't read data from %s\n", filename);
	goto fail;
    }
    close(fd);

    /* Decrypt data */
    if (decrypt_uploaded_cipcfg(buf, len) != SYS_UPLOAD_SUCCESS) {
	printf("Can't decrypt cipcfg file\n");
	goto fail;
    }

    /* Write to file */
    cfg_hdr = (CFG_HEADER *)buf;
    cfg = buf + sizeof(CFG_HEADER);
    if ((fd = open(filename, O_WRONLY|O_TRUNC)) < 0) {
	printf("Can't open %s\n", filename);
	goto fail;
    }
    if (write(fd, cfg, cfg_hdr->cfg_len) != cfg_hdr->cfg_len) {
	printf("Can't write to %s\n", filename);
	goto fail;
    }
    close(fd);
    free(buf);
    exit(EXIT_SUCCESS);

fail:
    close(fd);
    if (buf != NULL)
	free(buf);
    exit(EXIT_FAILURE);
}
