#include "id.h"
#include "cipcfg.h"
#include "syscall.h"
#include "webfunc.h"
#include "string.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <sys/wait.h>

#include "web_login.h"
#include "accmgmt_user.h"
#include "accmgmt_curusr.h"
#include "web_permission.h"

#define		NULL_OPT	T("NULL")
#define 	DECODE_IP	1
#define		DECODE_MAC	2
#define		DECODE_TIME	3
#define		DECODE_URL	4
extern const int gid_radius_map[];
int logout(char *session);

/**
 * Validate the Session/IP/MAC and postfix 
 *
 * @param  wp:
 * @param  path:
 * @param  query:
 * @resturn none:
 */
void validateUser(webs_t wp, char_t *path, char_t *query)
{
    char_t *username, *password;
    char timeStr[50], btype[10] = "TIME", session[MAX_VALUE_LEN], returnURL[MAX_VALUE_LEN], *ptr;
    char tmp[MAX_VALUE_LEN], ipAddr[256], passwd[256], macAddr[256], HPageURL[128], client_ip[20];
    char idletimeout[MAX_VALUE_LEN], mgmtInd[MAX_VALUE_LEN];
    char authpfix[MAX_VALUE_LEN], multilogin[MAX_VALUE_LEN], blacklist[MAX_VALUE_LEN];
    char *userid, *postfix=NULL;
    char *pch = NULL;
    char utype[MAX_VALUE_LEN], myusername[1024], buf[MAX_VALUE_LEN], fullname[1024];
    int  vlanNo, policyInd, mgmtIndex, aStatus = 0, logged = 0, i, j, ret, srv_index = -1;
    int interim = 0, idle = 0;
    unsigned long sessiontime = 0, curr_time, byteamount = 0;
    struct tm *now;
    time_t t;
    CIPCFG *cipcfg = NULL;
    ONDEMAND_USER *user ;
    MaRequest *rq = (MaRequest*)wp;
    FILE *fp = NULL, *fmap = NULL;

    memset(session , 0x0, MAX_VALUE_LEN);
    username = websGetVar(wp, T("myusername"), NULL_OPT);
    password = websGetVar(wp, T("mypassword"), NULL_OPT);
    printf("Username %s\n", username);
    printf("password %s\n", password);

    getCookieByName(rq, "session", session);
    getCookieByName(rq, "ReturnUrl", returnURL);
    printf("Session Cookie : %s\n", session);
    if( !strlen(username) || !strlen(password) ) {
	 websRedirect( wp, "/loginpages/default_login.asp" );
	 return ;
    }

    if( !strlen(session) ) {
	sprintf(tmp, "/loginpages/error_user.asp?uname=%s&errMsg=%s",username, "Invalid Session!.");
   	websRedirect( wp, tmp );
	return ;
    }

    printf("checking Session IP\n");
    checkSession(session , ipAddr, macAddr);
    strcpy(client_ip, ipAddr);
    /*if( validateIP(ipAddr) )
    { 
	sprintf(tmp, "/loginpages/error_user.asp?uname=%s&msg=%s",username, "Invalid IP Address!");
	websRedirect( wp, tmp );
	return ;
    }*/

    printf("checking session MAC address\n");

    printf("MAC is %s\n", macAddr);
/*   if( validateMAC(macAddr) ) // Validate and Format MAC
    {
        sprintf(tmp, "/loginpages/error_user.asp?uname=%s&errMsg=%s",username, "Invalid MAC Address!.");
        websRedirect( wp, tmp );
        return ;
    } */

    dec(returnURL, HPageURL);
    printf("HomePage URL : %s\n", HPageURL);
 
    // Determine the VLAN No.
    printf("Getting VLAN no..\n");
    vlanNo=getVlanbyIP(client_ip);
    if(vlanNo < 0) {
        sprintf(tmp, "/loginpages/error_user.asp?uname=%s&errMsg=%s", 
		 username, "Invalid IP Address!.");
        websRedirect(wp, tmp);
        return;
    }
    printf("VLAN No. : %d\n", vlanNo); 
    strcpy(myusername, username);
    strcpy(passwd, password); 

    userid = strtok_r(myusername, "@", &ptr);
    postfix = strtok_r(NULL, "@", &ptr);

    /* Find the Mgmt Index using Postfix */
    printf("Find Mgmt Index..\n");
    cipcfg=init_cipcfg();
    if(!cipcfg){
	printf("initial cipcfg error.\n");
	return ;
    }

    memset(fullname , '\0', 1024);
    strcpy(fullname, username);
    printf("Checking Auth Server..");
    if ( postfix == NULL ) {
        sprintf(tmp, "vlan%d%s", vlanNo, "_policy");
   	ret=get_cfg_item_by_str(cipcfg, tmp, "defauth", mgmtInd);
        /* Get Postfix */
        sprintf(tmp, "auth%s", mgmtInd);
        get_cfg_item_by_str(cipcfg, tmp, "postfix", authpfix);
        sprintf(fullname , "%s@%s", userid, authpfix);
    } else {
	for(i=1; i <= TOT_AUTH_SERVERS; i++) {
	    sprintf(tmp, "auth%d", i);
	    ret=get_cfg_item_by_str(cipcfg, tmp, "postfix", authpfix);
            if(!strcmp(postfix, authpfix)){
		sprintf(mgmtInd, "%d", i);
		break;
            }
        }
    }

    printf("Auth Server : %d\n", atoi(mgmtInd));
    if( !strcmp(mgmtInd, "0") ) {
	close_cipcfg(cipcfg);
        sprintf(tmp, "/loginpages/error_user.asp?uname=%s&errMsg=%s", fullname, "Invalid Postfix!.");
        websRedirect( wp, tmp );
        return;
    }

    //Find the Policy No.
    mgmtIndex = atoi(mgmtInd);
    policyInd = get_group_index( vlanNo, mgmtIndex);
   
    sprintf(tmp, "auth%d", mgmtIndex);
    printf("Checking Auth type of server : %s\n", tmp);
    ret = get_cfg_item_by_str(cipcfg, tmp, "utype", utype);
    printf("Utype : %s\n", utype);

    if( policyInd < 0 ) {
	close_cipcfg(cipcfg);
        sprintf(tmp, "/loginpages/error_user.asp?uname=%s&errMsg=%s",
		 fullname, "Account is not allowed in this VLAN.");
        websRedirect( wp, tmp );
        return;
    }
    printf("Policy Index is : %d\n", policyInd); 

    ret = get_cfg_item_by_str(cipcfg, tmp, "blacklist", blacklist);
    if (atoi(blacklist) > 0) {
	int blacklist_max;
	char item_value[MAX_VALUE_LEN];
	sprintf(tmp, "blacklist%d", atoi(blacklist));
	get_cfg_item_by_str(cipcfg, tmp, "max", item_value);
	blacklist_max = atoi(item_value);
	for (i = 0; i < blacklist_max; i++) {
	    sprintf(buf, "entry:%d.name", i);
	    get_cfg_item_by_str(cipcfg, tmp, buf, item_value);
	    if (!strcmp(item_value, userid)) {
		close_cipcfg(cipcfg);
		sprintf(tmp, "/loginpages/error_user.asp?uname=%s&errMsg=%s",
			fullname, "Account is in the Black List.");
		websRedirect( wp, tmp );
		return;
	    }
	}
    }

    ret = get_cfg_item_by_str(cipcfg, "auth", "idletimeout", idletimeout);

    *multilogin = '\0';
     //Check whether the User logged already
    if(!strncmp(utype, "LOCAL", 5)) {
        get_cfg_item_by_str(cipcfg, tmp, "multilogin", multilogin);
    }

    //TODO -- Filterring should be done here - BlackList, VLAN based 

    // Call the RADIUS client to start AUTH
    if( (!strncmp(utype, "LOCAL", 5)) || (!strncmp(utype, "ONDEMAND", 8)) ) {
   	sprintf(tmp, "/ramfs/bin/auth_start.sh %s %s %s %s %d %d", 
		fullname, passwd, ipAddr, macAddr, mgmtIndex, policyInd);
	printf("%s\n", tmp);
  	//cip_system(tmp);
    } else { 
	sprintf(tmp, "/ramfs/bin/radius_auth.sh %s %s %s %s %d %d 2>/dev/null", 
		userid, passwd, ipAddr, macAddr, mgmtIndex, policyInd);
	printf("%s\n", tmp);
	/*ret = cip_system(tmp);
	srv_index = WEXITSTATUS(ret);
	*/
    }

    fp = popen(tmp, "r");
    if (fp != NULL) {
	// First echo is nonsense.
	fgets(buf, MAX_VALUE_LEN, fp);
	// Second echo is authentication status.
	fgets(buf, MAX_VALUE_LEN, fp);
	strtok_r(buf, "\r\n", &ptr);
	if (strcmp(buf, "ACCEPT") != 0)
	    aStatus = 0;
	else {
	    aStatus = 1;
	    // Third echo is service index.
	    fgets(buf, MAX_VALUE_LEN, fp);
	    srv_index = atoi(buf);
	    // After the third echo is returned value that radius server responsed.
	    while (fgets(buf, MAX_VALUE_LEN, fp) != NULL) {
		if (strstr(buf, "Acct-Interim-Interval") != NULL) {
		    pch = strtok_r(buf, "=", &ptr);
		    pch = strtok_r(NULL, "=", &ptr);
		    interim = atoi(pch);
		}
		else if (strstr(buf, "Idle-Timeout") != NULL) {
		    pch = strtok_r(buf, "=", &ptr);
		    pch = strtok_r(NULL, "=", &ptr);
		    idle = atoi(pch);
		}
		else if (strstr(buf, "Session-Timeout") != NULL) {
		    pch = strtok_r(buf, "=", &ptr);
		    pch = strtok_r(NULL, "=", &ptr);
		    sessiontime = strtoul(pch, NULL, 10);
		}
		else if (strstr(buf, "Class") != NULL) {
		    pch = strtok_r(buf, "=", &ptr);
		    pch = strtok_r(NULL, "=", &ptr);
		    trim(pch);
		    sprintf(tmp, "/tmp/radius/auth%dmap", mgmtIndex);
		    fmap = fopen(tmp, "r");
		    if (fmap != NULL) {
			while (fgets(tmp, MAX_VALUE_LEN, fmap) != NULL) {
			    ptr = strchr(tmp, ' ');
			    if (!ptr)
				continue;
			    *ptr = '\0';
			    if (strcmp(tmp, pch) == 0) {
				ptr++;
				policyInd = atoi(ptr);
				break;
			    }
			}
			fclose(fmap);
		    }
		}
	    }
	}
	pclose(fp);
    }
    close_cipcfg(cipcfg);

    idle = (idle > 0) ? idle : atoi(idletimeout);
    /* get the current time */
    now = malloc(sizeof(struct tm));
    time(&t);

    curr_time = t;
    if(localtime_r(&t, now) != NULL)
	strftime(timeStr , 50, "%H:%M:%S %d/%m/%Y", now);
    free(now); 

    // Read the Status and redirect to Error or Login Success Page
    //aStatus = getAuthStatus(macAddr);

    printf("Status --> %d : Userid: %s\n", aStatus, userid);
    if( aStatus ) {
	if(!strncmp(utype, "LOCAL", 5)) {
	    LOCAL_USER *user = getLocalUserbyName(userid);
	    if (user != NULL && user->gpidx > 0) {
		    policyInd = user->gpidx;
	    }
	    free(user);
	}
        else if (!strncmp(utype, "ONDEMAND", 8)) {
	    user = (ONDEMAND_USER *) malloc(sizeof(ONDEMAND_USER));
	    user = searchOnDemandUserbyName(userid);
	    if (user != NULL) {
		if (user->validatetime != 0) {
		    if (user->validatetime != -1 && user->validatetime < curr_time) {
			user->status = -1;
			updateOnDemandUser(user);
			sprintf(tmp, "/loginpages/error_user.asp?uname=%s&errMsg=%s",
				fullname, "Account has been expired.");
			free(user);
			websRedirect( wp, tmp );
			return;
		    }
		    if (user->acttype == 0) {
			if (user->validatetime == -1) {
			    user->status = -1;
			    updateOnDemandUser(user);
			    sprintf(tmp, "/loginpages/error_user.asp?uname=%s&errMsg=%s",
				fullname, "Account Type is not valid.");
			    free(user);
			    websRedirect( wp, tmp );
			    return;
			}
			user->expiretime = user->validatetime;
		    }
		    else if (user->durationdays > 0)
			user->expiretime = curr_time + user->durationdays * 86400;
		    user->validatetime = 0;
		}
		if (user->status < 0) {
		    sprintf(tmp, "/loginpages/error_user.asp?uname=%s&errMsg=%s",
				fullname, "Account has been expired.");
		    free(user);
		    websRedirect( wp, tmp );
		    return;
		}
		if (user->availableunit <= 0) {
		    user->status = -1;
		    updateOnDemandUser(user);
		    sprintf(tmp, "/loginpages/error_user.asp?uname=%s&errMsg=%s",
				fullname, "You have run out of your quota.");
		    free(user);
		    websRedirect( wp, tmp );
		    return;
		}
		if (user->expiretime != 0 && user->expiretime < curr_time) {
		    user->status = -1;
		    updateOnDemandUser(user);
		    sprintf(tmp, "/loginpages/error_user.asp?uname=%s&errMsg=%s",
			fullname, "Account has been expired.");
		    free(user);
		    websRedirect( wp, tmp );
		    return;
		}
		if (user->acttype == 0)
		    user->availableunit = user->expiretime - curr_time;
		user->status = 1;
		updateOnDemandUser(user);
		sessiontime = user->availableunit;
	 	if(user->type == 0) {
		    strcpy(btype, "TIME");
		    byteamount = 0;
		} else {
		    strcpy(btype, "DATA");
		    sessiontime = 0;
		}
		free(user);
	    }	
	}

        /* Args - Auth Status, MacAddr, IPAddr, Uname, Fullname, Password, PolicyId, MgmtIndex,
	          Utype, srvidx,  Bill Type, Idle Timeout, Session Length, ByteAmount, LoginTime, Interim Time
	*/ 
	printf("Open User : %s\n", fullname); 
        //if(aStatus == 1) {
            DIR *pDIR;
            struct dirent *pDirEnt;

            /* Check if there is any MAC the same as current login user, if duplicated
               MAC exists, kick the older one.
	     */
            if ((pDIR = opendir(LOGIN_USER_DIR))!= NULL) {
                while ((pDirEnt = readdir( pDIR )) != NULL) {
                    if( !strcmp(pDirEnt->d_name, macAddr) ) {
                        sprintf(tmp, "/ramfs/bin/nam_kick %s %s", macAddr, "Force Logout");
                        cip_system(tmp);
                        break;
                    }
                    pDirEnt = readdir( pDIR );
                }
                closedir(pDIR);
            }
            /* Check user login or not */
            if (strcmp(multilogin, "enable")) {
                printf("Checking user status..\n");
                logged = userStatus(fullname, 1);

                if(logged == 1) {
                    sprintf(tmp, "/loginpages/error_user.asp?uname=%s&errMsg=%s", 
			fullname, "User Already Logged in!.");
                    websRedirect( wp, tmp );
	            return;
                }
            }
            sprintf(tmp, "/ramfs/bin/openUser.sh \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\""
			" \"%d\" \"%d\" \"%s\" \"%d\" \"%s\" \"%d\" \"%lu\" \"%lu\" \"%lu\" \"%d\"", 
			"ACCEPT", macAddr, ipAddr, userid, fullname, passwd, policyInd, mgmtIndex,
			utype, srv_index, btype, idle, sessiontime, byteamount, curr_time, interim); 
        /*} else
            sprintf(tmp, "/ramfs/bin/openUser.sh \"%s\" \"%s\" \"%s\" \"%s\" \"%s\" \"%s\""
			" \"%d\" \"%d\" \"%s\" \"%d\" \"%s\" \"%d\" \"%lu\" \"%lu\" \"%lu\" \"%d\"", 
			"REJECT", macAddr, ipAddr, userid, fullname, passwd, policyInd, mgmtIndex,
			utype, srv_index, btype, idle, sessiontime, byteamount, curr_time, interim); 
	*/
	printf("%s\n",tmp);    
	cip_system(tmp);

	if (!strncmp(utype, "ONDEMAND", 8)) 
        	sprintf(tmp, "/loginpages/default_popup11.asp?uname=%s&umac=%s&timeStr=%s&"
			"session=%s&hpageURL=%s",fullname, macAddr, timeStr, session, HPageURL);
	else
		sprintf(tmp, "/loginpages/login_success.asp?uname=%s&timeStr=%s&hpageURL=%s",
			fullname, timeStr, HPageURL);
	printf("%s\n",tmp);
		
    } else
       sprintf(tmp, "/loginpages/error_user.asp?uname=%s&errMsg=%s",fullname, "Login Failed"); 
   
    websRedirect( wp, tmp );    
}

void logoutUser(webs_t wp, char_t *path, char_t *query)
{
   char ipAddr[256], macAddr[256], session[MAX_VALUE_LEN];
   char tmp[256];
   int ret;
   MaRequest *rq = (MaRequest*)wp;

   memset(session , 0x0, MAX_VALUE_LEN);
   getCookieByName(rq, "session", session);

   ret = logout(session); 
   if(ret == 0) 
        sprintf(tmp, "/loginpages/logout.asp");
   else if(ret == 1)
        sprintf(tmp, "/loginpages/error_user.asp?errMsg=%s","Invalid Session!.");
   else if(ret == 2)
	sprintf(tmp, "/loginpages/error_user.asp?errMsg=%s","You have been logged out already!.");
   
   websRedirect( wp, tmp );
   return ;
}

int logoff(int eid, webs_t wp, int argc, char_t **argv)
{
    char ipAddr[256], macAddr[256], tmp[256], session[MAX_VALUE_LEN];
    int ret;
    MaRequest *rq = (MaRequest*)wp;

    memset(session , 0x0, MAX_VALUE_LEN);
    getCookieByName(rq, "session", session);
 
    ret = logout(session);
    if(ret == 0) 
        sprintf(tmp, "/loginpages/logout.asp");
    else if(ret == 1)
        sprintf(tmp, "/loginpages/error_user.asp?errMsg=%s", "Invalid Session!.");
    else if(ret == 2)
        sprintf(tmp, "/loginpages/error_user.asp?errMsg=%s", "You have been logged out already!.");

    websRedirect( wp, tmp );
    return 1;
}
     
int logout(char *session)
{
   char tmp[256],ipAddr[256], macAddr[256];
   CUR_USER *user = NULL;

   if( !strlen(session) )
	return 1; /* Invalid Session */

   checkSession(session , ipAddr, macAddr);

   user = get_all_cur_user( macAddr );
   if( user == NULL )
           return 2; /* User loggedout already */

   printf("Call NAM_KICK..\n");
   sprintf(tmp, "/ramfs/bin/nam_kick %s %s", macAddr, "Out of quota");
   cip_system(tmp);

   free_cur_user_list(user);
   return 0;
}

void trim(char *s){
    int i=0, j, k, l=0;

    while((s[i]==' ')||(s[i]=='\t')||(s[i]=='\n'))
        i++;

    j = strlen(s)-1;
    while((s[j]==' ')||(s[j]=='\t')||(s[j]=='\n'))
        j--;

    if(i==0 && j==strlen(s)-1) { }
    else if(i==0) s[j+1] = '\0';
    else {
        for(k=i; k<=j; k++) s[l++] = s[k];
        s[l] = '\0';
    }
}  	

/*
 * Define the form action for system releated function
 *
 * @param  none:
 * @return none
 */

void initUserValidateForm(void)
{
        websFormDefine(T("validateUser"), validateUser);
	websFormDefine(T("logoutUser"), logoutUser);
	websAspDefine(T("logoff"), logoff);
}
