#!/bin/sh

MAXRETRY=10
local count=0
local run=yes

while [ "$run" = "yes" ]; do
    ./webs "$@" > /dev/null 2>&1
    local RET=$?
    if [ "$RET" = "0" ]; then
	# 0 for successful exit
	run=no
    elif [ -f "/tmp/fail" ];then
        run=no
    elif [ "$RET" = "1" ]; then
	# 1 for failure exit 
	# It may be caused by WAN interface doesn't exist, we re-try to run.
	if [ "$count" -lt "$MAXRETRY" ]; then
	    run=yes
	    let "count+=1"
	    sleep 1
	else
	    run=no
	fi
    else
	# Ohter exit value may be caused by signal (SIGSEGV etc...).
	# We try to restart this program.
	run=yes
    fi
done
