
#define ATH_MAX_MAC_ADDR_STR 17
#define ATH_GET_TX_ERR_CNT 1
#define ATH_GET_TX_OK_CNT  2
#define ATH_GET_RX_ERR_CNT 3
#define ATH_GET_RX_OK_CNT 4
#define ATH_GET_RX_BYTE 5
#define ATH_GET_TX_BYTE 6

#define ATH_GET_TX_CNT_ERROR -11
#define ATH_IDLE_TIME_SHIFT 120

// from madwifi
#define IEEE80211_RATE_BASIC            0x80
#define IEEE80211_RATE_VAL              0x7f
#define IEEE80211_ADDR_LEN 6
#ifdef LSDK_9_1_0_214
#define IEEE80211_RATE_MAXSIZE  36
#else
#define IEEE80211_RATE_MAXSIZE  30
#endif

#define SIOCG80211STATS		        (SIOCDEVPRIVATE+2)
#define IEEE80211_IOCTL_GETKEY          (SIOCDEVPRIVATE+3)
#define IEEE80211_IOCTL_GETWPAIE        (SIOCDEVPRIVATE+4)
#define IEEE80211_IOCTL_STA_STATS       (SIOCDEVPRIVATE+5)
#define IEEE80211_IOCTL_STA_INFO        (SIOCDEVPRIVATE+6)
#define SIOC80211IFCREATE               (SIOCDEVPRIVATE+7)
#define SIOC80211IFDESTROY              (SIOCDEVPRIVATE+8)
#define IEEE80211_IOCTL_SCAN_RESULTS    (SIOCDEVPRIVATE+9)
#define IEEE80211_IOCTL_GETWSCIE        (SIOCDEVPRIVATE+10)

/*
 * Station information block; the mac address is used
 * to retrieve other data like stats, unicast key, etc.
 */
#ifdef AP83FUS
struct ieee80211req_sta_info {
    u_int16_t       isi_len;                /* length (mult of 4) */
    u_int16_t       isi_freq;               /* MHz */
    u_int32_t       isi_flags;              /* channel flags */
    u_int16_t       isi_state;              /* state flags */
    u_int8_t        isi_authmode;           /* authentication algorithm */
    int8_t          isi_rssi;
    u_int16_t       isi_capinfo;            /* capabilities */
    u_int8_t        isi_athflags;           /* Atheros capabilities */
    u_int8_t        isi_erp;                /* ERP element */
    u_int8_t        isi_macaddr[IEEE80211_ADDR_LEN];
    u_int8_t        isi_nrates;
                                            /* negotiated rates */
    u_int8_t        isi_rates[IEEE80211_RATE_MAXSIZE];
    u_int8_t        isi_txrate;             /* index to isi_rates[] */
    u_int16_t       isi_ie_len;             /* IE length */
    u_int16_t       isi_associd;            /* assoc response */
    u_int16_t       isi_txpower;            /* current tx power */
    u_int16_t       isi_vlan;               /* vlan tag */
    u_int16_t       isi_txseqs[17];         /* seq to be transmitted */
    u_int16_t       isi_rxseqs[17];         /* seq previous for qos frames*/
    u_int16_t       isi_inact;              /* inactivity timer */
    u_int8_t        isi_uapsd;              /* UAPSD queues */
    u_int8_t        isi_opmode;             /* sta operating mode */
    u_int8_t        isi_cipher;
    u_int32_t       isi_assoc_time;         /* sta association time */
    u_int16_t       isi_htcap;      	    /* HT capabilities */
};
#endif // AP83FUS
#ifdef AP93FUS
struct ieee80211req_sta_info {
	u_int16_t	isi_len;		/* length (mult of 4) */
	u_int16_t	isi_freq;		/* MHz */
    u_int32_t   isi_flags;      /* channel flags */
	u_int16_t	isi_state;		/* state flags */
	u_int8_t	isi_authmode;		/* authentication algorithm */
	int8_t	    	isi_rssi;
	u_int16_t	isi_capinfo;		/* capabilities */
	u_int8_t	isi_athflags;		/* Atheros capabilities */
	u_int8_t	isi_erp;		/* ERP element */
	u_int8_t	isi_macaddr[IEEE80211_ADDR_LEN];
	u_int8_t	isi_nrates;             /* negotiated rates */
	u_int8_t	isi_rates[IEEE80211_RATE_MAXSIZE]; 
	u_int8_t	isi_txrate;             /* index to isi_rates[] */
	u_int32_t	isi_txratekbps;         /* tx rate in kbps */
	u_int32_t	isi_rxratekbps;         /* rx rate in kbps */
	u_int16_t	isi_ie_len;		/* IE length */
	u_int16_t	isi_associd;		/* assoc response */
	u_int16_t	isi_txpower;		/* current tx power */
	u_int16_t	isi_vlan;		/* vlan tag */
	u_int16_t	isi_txseqs[17];		/* seq to be transmitted */
	u_int16_t	isi_rxseqs[17];		/* seq previous for qos frames*/
	u_int16_t	isi_inact;		/* inactivity timer */
	u_int8_t	isi_uapsd;		/* UAPSD queues */
	u_int8_t	isi_opmode;		/* sta operating mode */
	u_int8_t	isi_cipher;
        u_int32_t       isi_assoc_time;         /* sta association time */


    u_int16_t   isi_htcap;      /* HT capabilities */
	/* XXX frag state? */
	/* variable length IE data */
};
#endif // AP93FUS
#ifdef LSDK_9_1_0_214
struct ieee80211req_sta_info {
	u_int16_t	isi_len;		/* length (mult of 4) */
	u_int16_t	isi_freq;		/* MHz */
    u_int32_t   isi_flags;      /* channel flags */
	u_int16_t	isi_state;		/* state flags */
	u_int8_t	isi_authmode;		/* authentication algorithm */
	int8_t	    	isi_rssi;
	u_int16_t	isi_capinfo;		/* capabilities */
	u_int8_t	isi_athflags;		/* Atheros capabilities */
	u_int8_t	isi_erp;		/* ERP element */
	u_int8_t	isi_macaddr[IEEE80211_ADDR_LEN];
	u_int8_t	isi_nrates;
						/* negotiated rates */
	u_int8_t	isi_rates[IEEE80211_RATE_MAXSIZE];
	u_int8_t	isi_txrate;		/* index to isi_rates[] */
    u_int32_t   isi_txratekbps; /* rate in Kbps, for 11n */
	u_int16_t	isi_ie_len;		/* IE length */
	u_int16_t	isi_associd;		/* assoc response */
	u_int16_t	isi_txpower;		/* current tx power */
	u_int16_t	isi_vlan;		/* vlan tag */
	u_int16_t	isi_txseqs[17];		/* seq to be transmitted */
	u_int16_t	isi_rxseqs[17];		/* seq previous for qos frames*/
	u_int16_t	isi_inact;		/* inactivity timer */
	u_int8_t	isi_uapsd;		/* UAPSD queues */
	u_int8_t	isi_opmode;		/* sta operating mode */
	u_int8_t	isi_cipher;
        u_int32_t       isi_assoc_time;         /* sta association time */


    u_int16_t   isi_htcap;      /* HT capabilities */
	/* XXX frag state? */
	/* variable length IE data */
};
#endif //LSDK_9_1_0_214

/*
 * Per/node (station) statistics available when operating as an AP.
 */
#ifdef AP83FUS
struct ieee80211_nodestats {
        u_int32_t       ns_rx_data;             /* rx data frames */
        u_int32_t       ns_rx_mgmt;             /* rx management frames */
        u_int32_t       ns_rx_ctrl;             /* rx control frames */
        u_int32_t       ns_rx_ucast;            /* rx unicast frames */
        u_int32_t       ns_rx_mcast;            /* rx multi/broadcast frames */
        u_int64_t       ns_rx_bytes;            /* rx data count (bytes) */
        u_int64_t       ns_rx_beacons;          /* rx beacon frames */
        u_int32_t       ns_rx_proberesp;        /* rx probe response frames */

        u_int32_t       ns_rx_dup;              /* rx discard 'cuz dup */
        u_int32_t       ns_rx_noprivacy;        /* rx w/ wep but privacy off */
        u_int32_t       ns_rx_wepfail;          /* rx wep processing failed */
        u_int32_t       ns_rx_demicfail;        /* rx demic failed */
        u_int32_t       ns_rx_decap;            /* rx decapsulation failed */
        u_int32_t       ns_rx_defrag;           /* rx defragmentation failed */
        u_int32_t       ns_rx_disassoc;         /* rx disassociation */
        u_int32_t       ns_rx_deauth;           /* rx deauthentication */
        u_int32_t       ns_rx_action;           /* rx action */
        u_int32_t       ns_rx_decryptcrc;       /* rx decrypt failed on crc */
        u_int32_t       ns_rx_unauth;           /* rx on unauthorized port */
        u_int32_t       ns_rx_unencrypted;      /* rx unecrypted w/ privacy */

        u_int32_t       ns_tx_data;             /* tx data frames */
        u_int32_t       ns_tx_mgmt;             /* tx management frames */
        u_int32_t       ns_tx_ucast;            /* tx unicast frames */
        u_int32_t       ns_tx_mcast;            /* tx multi/broadcast frames */
        u_int64_t       ns_tx_bytes;            /* tx data count (bytes) */
        u_int32_t       ns_tx_probereq;         /* tx probe request frames */
        u_int32_t       ns_tx_uapsd;            /* tx on uapsd queue */

        u_int32_t       ns_tx_novlantag;        /* tx discard 'cuz no tag */
        u_int32_t       ns_tx_vlanmismatch;     /* tx discard 'cuz bad tag */

        u_int32_t       ns_tx_eosplost;         /* uapsd EOSP retried out */

        u_int32_t       ns_ps_discard;          /* ps discard 'cuz of age */

        u_int32_t       ns_uapsd_triggers;      /* uapsd triggers */

        /* MIB-related state */
        u_int32_t       ns_tx_assoc;            /* [re]associations */
        u_int32_t       ns_tx_assoc_fail;       /* [re]association failures */
        u_int32_t       ns_tx_auth;             /* [re]authentications */
        u_int32_t       ns_tx_auth_fail;        /* [re]authentication failures*/
        u_int32_t       ns_tx_deauth;           /* deauthentications */
        u_int32_t       ns_tx_deauth_code;      /* last deauth reason */
        u_int32_t       ns_tx_disassoc;         /* disassociations */
        u_int32_t       ns_tx_disassoc_code;    /* last disassociation reason */
        u_int32_t       ns_psq_drops;           /* power save queue drops */

        u_int32_t       ns_tx_okcnt;            /* tx frame successful */
        u_int32_t       ns_tx_errcnt;           /* tx frame failed */
        u_int32_t       ns_rx_okcnt;           /* rx frame successful */
        u_int32_t       ns_rx_errcnt;           /* rx frame failed */

};
#endif // AP83FUS
#ifdef AP93FUS
#define ATH_SUPPORT_IQUE
struct ieee80211_nodestats {
	u_int32_t	ns_rx_data;		/* rx data frames */
	u_int32_t	ns_rx_mgmt;		/* rx management frames */
	u_int32_t	ns_rx_ctrl;		/* rx control frames */
	u_int32_t	ns_rx_ucast;		/* rx unicast frames */
	u_int32_t	ns_rx_mcast;		/* rx multi/broadcast frames */
	u_int64_t	ns_rx_bytes;		/* rx data count (bytes) */
	u_int64_t	ns_rx_beacons;		/* rx beacon frames */
	u_int32_t	ns_rx_proberesp;	/* rx probe response frames */

	u_int32_t	ns_rx_dup;		/* rx discard 'cuz dup */
	u_int32_t	ns_rx_noprivacy;	/* rx w/ wep but privacy off */
	u_int32_t	ns_rx_wepfail;		/* rx wep processing failed */
	u_int32_t	ns_rx_demicfail;	/* rx demic failed */
	u_int32_t	ns_rx_decap;		/* rx decapsulation failed */
	u_int32_t	ns_rx_defrag;		/* rx defragmentation failed */
	u_int32_t	ns_rx_disassoc;		/* rx disassociation */
	u_int32_t	ns_rx_deauth;		/* rx deauthentication */
    u_int32_t   ns_rx_action;       /* rx action */
	u_int32_t	ns_rx_decryptcrc;	/* rx decrypt failed on crc */
	u_int32_t	ns_rx_unauth;		/* rx on unauthorized port */
	u_int32_t	ns_rx_unencrypted;	/* rx unecrypted w/ privacy */

	u_int32_t	ns_tx_data;		/* tx data frames */
	u_int32_t	ns_tx_mgmt;		/* tx management frames */
	u_int32_t	ns_tx_ucast;		/* tx unicast frames */
	u_int32_t	ns_tx_mcast;		/* tx multi/broadcast frames */
	u_int64_t	ns_tx_bytes;		/* tx data count (bytes) */
	u_int32_t	ns_tx_probereq;		/* tx probe request frames */
	u_int32_t	ns_tx_uapsd;		/* tx on uapsd queue */

	u_int32_t	ns_tx_novlantag;	/* tx discard 'cuz no tag */
	u_int32_t	ns_tx_vlanmismatch;	/* tx discard 'cuz bad tag */
#ifdef ATH_SUPPORT_IQUE
	u_int32_t	ns_tx_dropblock;	/* tx discard 'cuz headline block */
#endif

	u_int32_t	ns_tx_eosplost;		/* uapsd EOSP retried out */

	u_int32_t	ns_ps_discard;		/* ps discard 'cuz of age */

	u_int32_t	ns_uapsd_triggers;	     /* uapsd triggers */
	u_int32_t	ns_uapsd_duptriggers;	 /* uapsd duplicate triggers */
	u_int32_t	ns_uapsd_ignoretriggers; /* uapsd duplicate triggers */
	u_int32_t	ns_uapsd_active;         /* uapsd duplicate triggers */
	u_int32_t	ns_uapsd_triggerenabled; /* uapsd duplicate triggers */

	/* MIB-related state */
	u_int32_t	ns_tx_assoc;		/* [re]associations */
	u_int32_t	ns_tx_assoc_fail;	/* [re]association failures */
	u_int32_t	ns_tx_auth;		/* [re]authentications */
	u_int32_t	ns_tx_auth_fail;	/* [re]authentication failures*/
	u_int32_t	ns_tx_deauth;		/* deauthentications */
	u_int32_t	ns_tx_deauth_code;	/* last deauth reason */
	u_int32_t	ns_tx_disassoc;		/* disassociations */
	u_int32_t	ns_tx_disassoc_code;	/* last disassociation reason */
	u_int32_t	ns_psq_drops;		/* power save queue drops */

        u_int32_t 	ns_tx_okcnt;            /* tx frame successful */
        u_int32_t 	ns_tx_errcnt;           /* tx frame failed */
        u_int32_t       ns_rx_okcnt;            /* rx frame successful */
        u_int32_t       ns_rx_errcnt;           /* rx frame failed */
};
#endif // AP93FUS
#ifdef LSDK_9_1_0_214
#define ATH_SUPPORT_IQUE
struct ieee80211_nodestats {
    u_int32_t    ns_rx_data;             /* rx data frames */
    u_int32_t    ns_rx_mgmt;             /* rx management frames */
    u_int32_t    ns_rx_ctrl;             /* rx control frames */
    u_int32_t    ns_rx_ucast;            /* rx unicast frames */
    u_int32_t    ns_rx_mcast;            /* rx multi/broadcast frames */
    u_int64_t    ns_rx_bytes;            /* rx data count (bytes) */
    u_int64_t    ns_rx_beacons;          /* rx beacon frames */
    u_int32_t    ns_rx_proberesp;        /* rx probe response frames */

    u_int32_t    ns_rx_dup;              /* rx discard 'cuz dup */
    u_int32_t    ns_rx_noprivacy;        /* rx w/ wep but privacy off */
    u_int32_t    ns_rx_wepfail;          /* rx wep processing failed */
    u_int32_t    ns_rx_demicfail;        /* rx demic failed */
    u_int32_t    ns_rx_decap;            /* rx decapsulation failed */
    u_int32_t    ns_rx_defrag;           /* rx defragmentation failed */
    u_int32_t    ns_rx_disassoc;         /* rx disassociation */
    u_int32_t    ns_rx_deauth;           /* rx deauthentication */
    u_int32_t    ns_rx_action;           /* rx action */
    u_int32_t    ns_rx_decryptcrc;       /* rx decrypt failed on crc */
    u_int32_t    ns_rx_unauth;           /* rx on unauthorized port */
    u_int32_t    ns_rx_unencrypted;      /* rx unecrypted w/ privacy */

    u_int32_t    ns_tx_data;             /* tx data frames */
    u_int32_t    ns_tx_mgmt;             /* tx management frames */
    u_int32_t    ns_tx_ucast;            /* tx unicast frames */
    u_int32_t    ns_tx_mcast;            /* tx multi/broadcast frames */
    u_int64_t    ns_tx_bytes;            /* tx data count (bytes) */
    u_int32_t    ns_tx_probereq;         /* tx probe request frames */
    u_int32_t    ns_tx_uapsd;            /* tx on uapsd queue */

    u_int32_t    ns_tx_novlantag;        /* tx discard 'cuz no tag */
    u_int32_t    ns_tx_vlanmismatch;     /* tx discard 'cuz bad tag */

    u_int32_t    ns_tx_eosplost;         /* uapsd EOSP retried out */

    u_int32_t    ns_ps_discard;          /* ps discard 'cuz of age */

    u_int32_t    ns_uapsd_triggers;      /* uapsd triggers */
    u_int32_t    ns_uapsd_duptriggers;    /* uapsd duplicate triggers */
    u_int32_t    ns_uapsd_ignoretriggers; /* uapsd duplicate triggers */
    u_int32_t    ns_uapsd_active;         /* uapsd duplicate triggers */
    u_int32_t    ns_uapsd_triggerenabled; /* uapsd duplicate triggers */


    /* MIB-related state */
    u_int32_t    ns_tx_assoc;            /* [re]associations */
    u_int32_t    ns_tx_assoc_fail;       /* [re]association failures */
    u_int32_t    ns_tx_auth;             /* [re]authentications */
    u_int32_t    ns_tx_auth_fail;        /* [re]authentication failures*/
    u_int32_t    ns_tx_deauth;           /* deauthentications */
    u_int32_t    ns_tx_deauth_code;      /* last deauth reason */
    u_int32_t    ns_tx_disassoc;         /* disassociations */
    u_int32_t    ns_tx_disassoc_code;    /* last disassociation reason */
    u_int32_t    ns_psq_drops;           /* power save queue drops */
    
    u_int32_t    ns_tx_okcnt;            /* tx frame successful */
    u_int32_t 	 ns_tx_errcnt;           /* tx frame failed */
    u_int32_t    ns_rx_okcnt;            /* rx frame successful */
    u_int32_t    ns_rx_errcnt;           /* rx frame failed */

    /* IQUE-HBR related state */
#ifdef ATH_SUPPORT_IQUE
	u_int32_t	ns_tx_dropblock;	/* tx discard 'cuz headline block */
#endif
};
#endif //LSDK_9_1_0_214

struct ieee80211req_sta_stats {
        union {
                /* NB: explicitly force 64-bit alignment */
                u_int8_t        macaddr[IEEE80211_ADDR_LEN];
                u_int64_t       pad;
        } is_u;
        struct ieee80211_nodestats is_stats;
};

ASSOC_STA_LIST *ath_get_sta_info(const char *);
