#include "cipcfg.h"

#define CLI_CHK_TYPE_SUCCESS 0
#define CLI_CHK_TYPE_FAILURE -1
#define CLI_CHK_TYPE_RESTRICT -2

#define CLI_IP_LEN 15
#define CLI_MAX_DEP_ITEM 10
#define IP_MAX_NUM 255
#define MAX_DOMAIN_LEN 256

/* regular expression rule of mac, ip, domain name, password, date, and wep key */
#define CFG_ITEM_MAC_RULE1 "[0-9a-fA-F]{2}[:][0-9a-fA-F]{2}[:][0-9a-fA-F]{2}[:][0-9a-fA-F]{2}[:][0-9a-fA-F]{2}[:][0-9a-fA-F]{2}"
#define CFG_ITEM_MAC_RULE2 "[0-9a-fA-F]{2}[-][0-9a-fA-F]{2}[-][0-9a-fA-F]{2}[-][0-9a-fA-F]{2}[-][0-9a-fA-F]{2}[-][0-9a-fA-F]{2}"
#define CFG_ITEM_MAC_RULE3 "[0-9a-fA-F]{12}"
#define CFG_ITEM_IP_RULE "^[0-9]{1,3}[.][0-9]{1,3}[.][0-9]{1,3}[.][0-9]{1,3}$"
#define CFG_ITEM_DOMAIN_RULE "^[^][\"()<>@,; \\]+([.][^][\"()<>@,; \\]+)+$"
#define CFG_ITEM_DATE_RULE "^[0-9]{4}[.][0-9]{2}[.][0-9]{2}[-][0-9]{2}[:][0-9]{2}[:][0-9]{2}$" 
#define CFG_ITEM_WEP_RULE "^[\x21-\x7e]{5}$|^[\x21-\x7e]{13}$|^[\x21-\x7e]{16}$|^[0-9A-Fa-f]{10}$|^[0-9A-Fa-f]{26}$|^[0-9A-Fa-f]{32}$"

extern int get_allowed_ch(COUNTRY_CHANNEL *);

int verifySystemDevice(ITEM_LIST *items);
int verifySystemSystime(ITEM_LIST *items);
int verifyNetworkWan_ip(ITEM_LIST *items);
int verifyNetworkL2(ITEM_LIST *items);
int verifyNetworkL2Stp(ITEM_LIST *items);
int verifyNetworkL2Proxy_arp(ITEM_LIST *items);
int verifyNetworkL2Igmp_snooping(ITEM_LIST *items);
int verifyNetworkL2Port_trunk(ITEM_LIST *items);
int verifyNetworkVlan(ITEM_LIST *items);
int verifyMgmtAccounts(ITEM_LIST *items);
int verifyMgmtSnmp(ITEM_LIST *items);
int verifyMgmtSyslog(ITEM_LIST *items);
int verifyMgmtRmt_srv(ITEM_LIST *items);
int verifyMgmtRmt_srvHttp(ITEM_LIST *items);
int verifyMgmtRmt_acc(ITEM_LIST *items);
int verifyWlanMacacl(ITEM_LIST *items);
int verifyWlanRfcard(ITEM_LIST *items);
int verifyWlanRfcardWds(ITEM_LIST *items);
int verifyWlanRfcardVap(ITEM_LIST *items);
#ifdef CIPCFG_ITEM_VALIDATION
int validate_input(ITEM_LIST *items);
int type_pre_check(int type, char *item_value);
int cipcfg_item_regex_check(const char *regex, char *string);
int cipcfg_item_ip_check(char *input);
int cipcfg_item_mac_check(char *input);
int cipcfg_item_int_check(char *rule, char *input);
int cipcfg_band_check(char *input, char *rule);
int cipcfg_channel_check(char *input, char *rule);
int input_validation_by_item(char *item_name, char *item_value, char *group_name);
int cipcfg_item_domain_check(char *input);
#endif
