#ifndef _ID_H
#define _ID_H

#define GID_CATEGORY(x) ((x) << 27)
#define GID_GROUP(x) ((x) << 10)
#define SET_ID(c, g, x) ( GID_CATEGORY(c) | GID_GROUP(g) | (x) )
#define GROUP_ID(c, g) SET_ID( c, g, 0 )

/*
 *
 * 31 cate 27     group-id 17 bits      10    item-id 10 bits   0
 *  |-------|----------------------------|----------------------|
 *
 */
enum group_id {
    GID_CIPCONFIG               = 1, 
    // SYSTEM
    GID_DEVICE                  = GROUP_ID(1, (1<<9)|0 ),
    GID_SYSTIME                 = GROUP_ID(1, (2<<9)|0 ),
    GID_OPMODE                  = GROUP_ID(1, (3<<9)|0 ),
    GID_AUTO_REBOOT             = GROUP_ID(1, (4<<9)|0 ),
    GID_DEV_NAME		= GROUP_ID(1, (5<<9)|0 ),
    // NETWORK
    GID_NETWORK                 = GROUP_ID(2, (0<<9)|0 ),
    GID_WAN_IP                  = GROUP_ID(2, (1<<9)|0 ),
    GID_NET_L2                  = GROUP_ID(2, (2<<9)|0 ),
        GID_STP                 = GROUP_ID(2, (2<<9)|1 ),
        GID_PROXY_ARP           = GROUP_ID(2, (2<<9)|2 ),
        GID_IGMP                = GROUP_ID(2, (2<<9)|3 ),
        GID_PORT_TRUNK          = GROUP_ID(2, (2<<9)|4 ),
    GID_VLAN_QOS_MAP		= GROUP_ID(2, (3<<9)|0 ),
    GID_LAN                     = GROUP_ID(2, (4<<9)|0 ),
    GID_LAN_DHCP                = GROUP_ID(2, (4<<9)|1 ),
        // FIREWALL
        GID_URL_FILTER          = GROUP_ID(2, (5<<9)|1 ),
        GID_DMZ                 = GROUP_ID(2, (5<<9)|2 ),
        GID_IP_REDIRECT         = GROUP_ID(2, (5<<9)|3 ),
    GID_UPNP                    = GROUP_ID(2, (6<<9)|0 ),
    GID_DDNS                    = GROUP_ID(2, (7<<9)|0 ),
    GID_FAILACT                 = GROUP_ID(2, (8<<9)|0 ),
    GID_FAILURL                 = GROUP_ID(2, (9<<9)|0 ),
    GID_BFW                     = GROUP_ID(2, (10<<9)|0 ),
    GID_BFW_SERVICE             = GROUP_ID(2, (11<<9)|0 ),
    GID_BFW_DAI                 = GROUP_ID(2, (12<<9)|0 ),
    GID_BONDING 		= GROUP_ID(2, (13<<9)|0 ),
    GID_GRE			= GROUP_ID(2, (14<<9)|0 ),
    GID_IPV6			= GROUP_ID(2, (15<<9)|0 ),

    // MANAGEMENT
    GID_ACCOUNT                 = GROUP_ID(3, (1<<9)|0 ),
        GID_USER1               = GROUP_ID(3, (1<<9)|1 ),
        GID_USER2               = GROUP_ID(3, (1<<9)|2 ),
        GID_USER3               = GROUP_ID(3, (1<<9)|3 ),
    GID_SYSLOG                  = GROUP_ID(3, (2<<9)|0 ),
    GID_REMOTE_PROTOCOL         = GROUP_ID(3, (3<<9)|0 ),
        GID_SNMP                = GROUP_ID(3, (3<<9)|1 ),
        GID_HTTP                = GROUP_ID(3, (3<<9)|2 ),
        GID_HTTPS               = GROUP_ID(3, (3<<9)|3 ),
        GID_TELNET		= GROUP_ID(3, (3<<9)|4 ),
        GID_SSH			= GROUP_ID(3, (3<<9)|5 ),
    GID_REMOTE_ACCESS           = GROUP_ID(3, (4<<9)|0 ),
    GID_REPORT_AGENT		= GROUP_ID(3, (5<<9)|0 ),
    GID_USERLOG			= GROUP_ID(3, (6<<9)|0 ),
	GID_USERLOG_SYSLOG	= GROUP_ID(3, (6<<9)|1 ),
    GID_SESSIONLOG		= GROUP_ID(3, (7<<9)|0 ),
	GID_SESSIONLOG_SYSLOG	= GROUP_ID(3, (7<<9)|1 ),
    GID_HOMEPAGE_REDIR		= GROUP_ID(3, (8<<9)|0 ),
    GID_IPPNP			= GROUP_ID(3, (9<<9)|0 ),
    GID_SMTP_REDIR		= GROUP_ID(3, (10<<9)|0 ),
    GID_REMOTE_MANAGE		= GROUP_ID(3, (11<<9)|0 ),
    GID_WES			= GROUP_ID(3, (12<<9)|0 ),
    GID_CAPWAP			= GROUP_ID(3, (13<<9)|0 ),

        // russell version ,     add by Leo
    GID_RF1                     = GROUP_ID(4, (1<<13)|0 ),
        GID_RF1_VAP1            = GROUP_ID(4, (1<<13)|(1<<9)|(1<<4)|0 ),
            GID_RF1_VAP1_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(1<<4)|1 ),
            GID_RF1_VAP1_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(1<<4)|2 ),
            GID_RF1_VAP1_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(1<<4)|3 ),
        GID_RF1_VAP2            = GROUP_ID(4, (1<<13)|(1<<9)|(2<<4)|0 ),
            GID_RF1_VAP2_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(2<<4)|1 ),
            GID_RF1_VAP2_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(2<<4)|2 ),
            GID_RF1_VAP2_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(2<<4)|3 ),
        GID_RF1_VAP3            = GROUP_ID(4, (1<<13)|(1<<9)|(3<<4)|0 ),
            GID_RF1_VAP3_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(3<<4)|1 ),
            GID_RF1_VAP3_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(3<<4)|2 ),
            GID_RF1_VAP3_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(3<<4)|3 ),
        GID_RF1_VAP4            = GROUP_ID(4, (1<<13)|(1<<9)|(4<<4)|0 ),
            GID_RF1_VAP4_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(4<<4)|1 ),
            GID_RF1_VAP4_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(4<<4)|2 ),
            GID_RF1_VAP4_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(4<<4)|3 ),
        GID_RF1_VAP5            = GROUP_ID(4, (1<<13)|(1<<9)|(5<<4)|0 ),
            GID_RF1_VAP5_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(5<<4)|1 ),
            GID_RF1_VAP5_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(5<<4)|2 ),
            GID_RF1_VAP5_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(5<<4)|3 ),
        GID_RF1_VAP6            = GROUP_ID(4, (1<<13)|(1<<9)|(6<<4)|0 ),
            GID_RF1_VAP6_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(6<<4)|1 ),
            GID_RF1_VAP6_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(6<<4)|2 ),
            GID_RF1_VAP6_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(6<<4)|3 ),
        GID_RF1_VAP7            = GROUP_ID(4, (1<<13)|(1<<9)|(7<<4)|0 ),
            GID_RF1_VAP7_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(7<<4)|1 ),
            GID_RF1_VAP7_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(7<<4)|2 ),
            GID_RF1_VAP7_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(7<<4)|3 ),
        GID_RF1_VAP8            = GROUP_ID(4, (1<<13)|(1<<9)|(8<<4)|0 ),
            GID_RF1_VAP8_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(8<<4)|1 ),
            GID_RF1_VAP8_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(8<<4)|2 ),
            GID_RF1_VAP8_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(8<<4)|3 ),
        GID_RF1_VAP9            = GROUP_ID(4, (1<<13)|(1<<9)|(9<<4)|0 ),
            GID_RF1_VAP9_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(9<<4)|1 ),
            GID_RF1_VAP9_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(9<<4)|2 ),
            GID_RF1_VAP9_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(9<<4)|3 ),
        GID_RF1_VAP10            = GROUP_ID(4, (1<<13)|(1<<9)|(10<<4)|0 ),
            GID_RF1_VAP10_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(10<<4)|1 ),
            GID_RF1_VAP10_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(10<<4)|2 ),
            GID_RF1_VAP10_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(10<<4)|3 ),
        GID_RF1_VAP11            = GROUP_ID(4, (1<<13)|(1<<9)|(11<<4)|0 ),
            GID_RF1_VAP11_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(11<<4)|1 ),
            GID_RF1_VAP11_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(11<<4)|2 ),
            GID_RF1_VAP11_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(11<<4)|3 ),
        GID_RF1_VAP12            = GROUP_ID(4, (1<<13)|(1<<9)|(12<<4)|0 ),
            GID_RF1_VAP12_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(12<<4)|1 ),
            GID_RF1_VAP12_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(12<<4)|2 ),
            GID_RF1_VAP12_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(12<<4)|3 ),
        GID_RF1_VAP13            = GROUP_ID(4, (1<<13)|(1<<9)|(13<<4)|0 ),
            GID_RF1_VAP13_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(13<<4)|1 ),
            GID_RF1_VAP13_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(13<<4)|2 ),
            GID_RF1_VAP13_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(13<<4)|3 ),
        GID_RF1_VAP14            = GROUP_ID(4, (1<<13)|(1<<9)|(14<<4)|0 ),
            GID_RF1_VAP14_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(14<<4)|1 ),
            GID_RF1_VAP14_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(14<<4)|2 ),
            GID_RF1_VAP14_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(14<<4)|3 ),
        GID_RF1_VAP15            = GROUP_ID(4, (1<<13)|(1<<9)|(15<<4)|0 ),
            GID_RF1_VAP15_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(15<<4)|1 ),
            GID_RF1_VAP15_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(15<<4)|2 ),
            GID_RF1_VAP15_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(15<<4)|3 ),
        GID_RF1_VAP16            = GROUP_ID(4, (1<<13)|(1<<9)|(16<<4)|0 ),
            GID_RF1_VAP16_ACL    = GROUP_ID(4, (1<<13)|(1<<9)|(16<<4)|1 ),
            GID_RF1_VAP16_SEC    = GROUP_ID(4, (1<<13)|(1<<9)|(16<<4)|2 ),
            GID_RF1_VAP16_IAPP   = GROUP_ID(4, (1<<13)|(1<<9)|(16<<4)|3 ),
        GID_RF1_WDS1            = GROUP_ID(4, (1<<13)|(2<<9)|1 ), 
        GID_RF1_WDS2            = GROUP_ID(4, (1<<13)|(2<<9)|2 ),
        GID_RF1_WDS3            = GROUP_ID(4, (1<<13)|(2<<9)|3 ),
        GID_RF1_WDS4            = GROUP_ID(4, (1<<13)|(2<<9)|4 ),
        GID_RF1_WDS5            = GROUP_ID(4, (1<<13)|(2<<9)|5 ), 
        GID_RF1_WDS6            = GROUP_ID(4, (1<<13)|(2<<9)|6 ),
        GID_RF1_WDS7            = GROUP_ID(4, (1<<13)|(2<<9)|7 ),
        GID_RF1_WDS8            = GROUP_ID(4, (1<<13)|(2<<9)|8 ),
        GID_RF1_SCAN            = GROUP_ID(4, (1<<13)|(3<<9)|0 ),
	GID_RF1_STA1		= GROUP_ID(4, (1<<13)|(4<<9)|0 ),
            GID_RF1_STA1_SEC    = GROUP_ID(4, (1<<13)|(4<<9)|(1<<4)|0 ),
	GID_RF1_REP1		= GROUP_ID(4, (1<<13)|(5<<9)|0 ),
            GID_RF1_REP1_SEC    = GROUP_ID(4, (1<<13)|(5<<9)|(1<<4)|0 ),
        
    GID_RF2                     = GROUP_ID(4, (2<<13)|0 ),
        GID_RF2_VAP1            = GROUP_ID(4, (2<<13)|(1<<9)|(1<<4)|0 ),
            GID_RF2_VAP1_ACL    = GROUP_ID(4, (2<<13)|(1<<9)|(1<<4)|1 ),
            GID_RF2_VAP1_SEC    = GROUP_ID(4, (2<<13)|(1<<9)|(1<<4)|2 ),
            GID_RF2_VAP1_IAPP   = GROUP_ID(4, (2<<13)|(1<<9)|(1<<4)|3 ),
        GID_RF2_VAP2            = GROUP_ID(4, (2<<13)|(1<<9)|(2<<4)|0 ),
            GID_RF2_VAP2_ACL    = GROUP_ID(4, (2<<13)|(1<<9)|(2<<4)|1 ),
            GID_RF2_VAP2_SEC    = GROUP_ID(4, (2<<13)|(1<<9)|(2<<4)|2 ),
            GID_RF2_VAP2_IAPP   = GROUP_ID(4, (2<<13)|(1<<9)|(2<<4)|3 ),
        GID_RF2_VAP3            = GROUP_ID(4, (2<<13)|(1<<9)|(3<<4)|0 ),
            GID_RF2_VAP3_ACL    = GROUP_ID(4, (2<<13)|(1<<9)|(3<<4)|1 ),
            GID_RF2_VAP3_SEC    = GROUP_ID(4, (2<<13)|(1<<9)|(3<<4)|2 ),
            GID_RF2_VAP3_IAPP   = GROUP_ID(4, (2<<13)|(1<<9)|(3<<4)|3 ),
        GID_RF2_VAP4            = GROUP_ID(4, (2<<13)|(1<<9)|(4<<4)|0 ),
            GID_RF2_VAP4_ACL    = GROUP_ID(4, (2<<13)|(1<<9)|(4<<4)|1 ),
            GID_RF2_VAP4_SEC    = GROUP_ID(4, (2<<13)|(1<<9)|(4<<4)|2 ),
            GID_RF2_VAP4_IAPP   = GROUP_ID(4, (2<<13)|(1<<9)|(4<<4)|3 ),
        GID_RF2_VAP5            = GROUP_ID(4, (2<<13)|(1<<9)|(5<<4)|0 ),
            GID_RF2_VAP5_ACL    = GROUP_ID(4, (2<<13)|(1<<9)|(5<<4)|1 ),
            GID_RF2_VAP5_SEC    = GROUP_ID(4, (2<<13)|(1<<9)|(5<<4)|2 ),
            GID_RF2_VAP5_IAPP   = GROUP_ID(4, (2<<13)|(1<<9)|(5<<4)|3 ),
        GID_RF2_VAP6            = GROUP_ID(4, (2<<13)|(1<<9)|(6<<4)|0 ),
            GID_RF2_VAP6_ACL    = GROUP_ID(4, (2<<13)|(1<<9)|(6<<4)|1 ),
            GID_RF2_VAP6_SEC    = GROUP_ID(4, (2<<13)|(1<<9)|(6<<4)|2 ),
            GID_RF2_VAP6_IAPP   = GROUP_ID(4, (2<<13)|(1<<9)|(6<<4)|3 ),
        GID_RF2_VAP7            = GROUP_ID(4, (2<<13)|(1<<9)|(7<<4)|0 ),
            GID_RF2_VAP7_ACL    = GROUP_ID(4, (2<<13)|(1<<9)|(7<<4)|1 ),
            GID_RF2_VAP7_SEC    = GROUP_ID(4, (2<<13)|(1<<9)|(7<<4)|2 ),
            GID_RF2_VAP7_IAPP   = GROUP_ID(4, (2<<13)|(1<<9)|(7<<4)|3 ),
        GID_RF2_VAP8            = GROUP_ID(4, (2<<13)|(1<<9)|(8<<4)|0 ),
            GID_RF2_VAP8_ACL    = GROUP_ID(4, (2<<13)|(1<<9)|(8<<4)|1 ),
            GID_RF2_VAP8_SEC    = GROUP_ID(4, (2<<13)|(1<<9)|(8<<4)|2 ),
            GID_RF2_VAP8_IAPP   = GROUP_ID(4, (2<<13)|(1<<9)|(8<<4)|3 ),
        GID_RF2_WDS1            = GROUP_ID(4, (2<<13)|(2<<9)|1 ), 
        GID_RF2_WDS2            = GROUP_ID(4, (2<<13)|(2<<9)|2 ),
        GID_RF2_WDS3            = GROUP_ID(4, (2<<13)|(2<<9)|3 ),
        GID_RF2_WDS4            = GROUP_ID(4, (2<<13)|(2<<9)|4 ),
        GID_RF2_WDS5            = GROUP_ID(4, (2<<13)|(2<<9)|5 ), 
        GID_RF2_WDS6            = GROUP_ID(4, (2<<13)|(2<<9)|6 ),
        GID_RF2_WDS7            = GROUP_ID(4, (2<<13)|(2<<9)|7 ),
        GID_RF2_WDS8            = GROUP_ID(4, (2<<13)|(2<<9)|8 ),
        GID_RF2_SCAN            = GROUP_ID(4, (2<<13)|(3<<9)|0 ),
	GID_RF2_STA1		= GROUP_ID(4, (2<<13)|(4<<9)|0 ),
            GID_RF2_STA1_SEC    = GROUP_ID(4, (2<<13)|(4<<9)|(1<<4)|0 ),
	GID_RF2_REP1		= GROUP_ID(4, (2<<13)|(5<<9)|0 ),
            GID_RF2_REP1_SEC    = GROUP_ID(4, (2<<13)|(5<<9)|(1<<4)|0 ),

    GID_RF3                     = GROUP_ID(4, (3<<13)|0 ),
        GID_RF3_VAP1            = GROUP_ID(4, (3<<13)|(1<<9)|(1<<4)|0 ),
            GID_RF3_VAP1_ACL    = GROUP_ID(4, (3<<13)|(1<<9)|(1<<4)|1 ),
            GID_RF3_VAP1_SEC    = GROUP_ID(4, (3<<13)|(1<<9)|(1<<4)|2 ),
            GID_RF3_VAP1_IAPP   = GROUP_ID(4, (3<<13)|(1<<9)|(1<<4)|3 ),
        GID_RF3_VAP2            = GROUP_ID(4, (3<<13)|(1<<9)|(2<<4)|0 ),
            GID_RF3_VAP2_ACL    = GROUP_ID(4, (3<<13)|(1<<9)|(2<<4)|1 ),
            GID_RF3_VAP2_SEC    = GROUP_ID(4, (3<<13)|(1<<9)|(2<<4)|2 ),
            GID_RF3_VAP2_IAPP   = GROUP_ID(4, (3<<13)|(1<<9)|(2<<4)|3 ),
        GID_RF3_VAP3            = GROUP_ID(4, (3<<13)|(1<<9)|(3<<4)|0 ),
            GID_RF3_VAP3_ACL    = GROUP_ID(4, (3<<13)|(1<<9)|(3<<4)|1 ),
            GID_RF3_VAP3_SEC    = GROUP_ID(4, (3<<13)|(1<<9)|(3<<4)|2 ),
            GID_RF3_VAP3_IAPP   = GROUP_ID(4, (3<<13)|(1<<9)|(3<<4)|3 ),
        GID_RF3_VAP4            = GROUP_ID(4, (3<<13)|(1<<9)|(4<<4)|0 ),
            GID_RF3_VAP4_ACL    = GROUP_ID(4, (3<<13)|(1<<9)|(4<<4)|1 ),
            GID_RF3_VAP4_SEC    = GROUP_ID(4, (3<<13)|(1<<9)|(4<<4)|2 ),
            GID_RF3_VAP4_IAPP   = GROUP_ID(4, (3<<13)|(1<<9)|(4<<4)|3 ),
        GID_RF3_VAP5            = GROUP_ID(4, (3<<13)|(1<<9)|(5<<4)|0 ),
            GID_RF3_VAP5_ACL    = GROUP_ID(4, (3<<13)|(1<<9)|(5<<4)|1 ),
            GID_RF3_VAP5_SEC    = GROUP_ID(4, (3<<13)|(1<<9)|(5<<4)|2 ),
            GID_RF3_VAP5_IAPP   = GROUP_ID(4, (3<<13)|(1<<9)|(5<<4)|3 ),
        GID_RF3_VAP6            = GROUP_ID(4, (3<<13)|(1<<9)|(6<<4)|0 ),
            GID_RF3_VAP6_ACL    = GROUP_ID(4, (3<<13)|(1<<9)|(6<<4)|1 ),
            GID_RF3_VAP6_SEC    = GROUP_ID(4, (3<<13)|(1<<9)|(6<<4)|2 ),
            GID_RF3_VAP6_IAPP   = GROUP_ID(4, (3<<13)|(1<<9)|(6<<4)|3 ),
        GID_RF3_VAP7            = GROUP_ID(4, (3<<13)|(1<<9)|(7<<4)|0 ),
            GID_RF3_VAP7_ACL    = GROUP_ID(4, (3<<13)|(1<<9)|(7<<4)|1 ),
            GID_RF3_VAP7_SEC    = GROUP_ID(4, (3<<13)|(1<<9)|(7<<4)|2 ),
            GID_RF3_VAP7_IAPP   = GROUP_ID(4, (3<<13)|(1<<9)|(7<<4)|3 ),
        GID_RF3_VAP8            = GROUP_ID(4, (3<<13)|(1<<9)|(8<<4)|0 ),
            GID_RF3_VAP8_ACL    = GROUP_ID(4, (3<<13)|(1<<9)|(8<<4)|1 ),
            GID_RF3_VAP8_SEC    = GROUP_ID(4, (3<<13)|(1<<9)|(8<<4)|2 ),
            GID_RF3_VAP8_IAPP   = GROUP_ID(4, (3<<13)|(1<<9)|(8<<4)|3 ),
        GID_RF3_WDS1            = GROUP_ID(4, (3<<13)|(2<<9)|1 ), 
        GID_RF3_WDS2            = GROUP_ID(4, (3<<13)|(2<<9)|2 ),
        GID_RF3_WDS3            = GROUP_ID(4, (3<<13)|(2<<9)|3 ),
        GID_RF3_WDS4            = GROUP_ID(4, (3<<13)|(2<<9)|4 ),
        GID_RF3_WDS5            = GROUP_ID(4, (3<<13)|(2<<9)|5 ), 
        GID_RF3_WDS6            = GROUP_ID(4, (3<<13)|(2<<9)|6 ),
        GID_RF3_WDS7            = GROUP_ID(4, (3<<13)|(2<<9)|7 ),
        GID_RF3_WDS8            = GROUP_ID(4, (3<<13)|(2<<9)|8 ),
        GID_RF3_SCAN            = GROUP_ID(4, (3<<13)|(3<<9)|0 ),
	GID_RF3_STA1		= GROUP_ID(4, (3<<13)|(4<<9)|0 ),
            GID_RF3_STA1_SEC    = GROUP_ID(4, (3<<13)|(4<<9)|(1<<4)|0 ),
	GID_RF3_REP1		= GROUP_ID(4, (3<<13)|(5<<9)|0 ),
            GID_RF3_REP1_SEC    = GROUP_ID(4, (3<<13)|(5<<9)|(1<<4)|0 ),

    GID_RF4                     = GROUP_ID(4, (4<<13)|0 ),
        GID_RF4_VAP1            = GROUP_ID(4, (4<<13)|(1<<9)|(1<<4)|0 ),
            GID_RF4_VAP1_ACL    = GROUP_ID(4, (4<<13)|(1<<9)|(1<<4)|1 ),
            GID_RF4_VAP1_SEC    = GROUP_ID(4, (4<<13)|(1<<9)|(1<<4)|2 ),
            GID_RF4_VAP1_IAPP   = GROUP_ID(4, (4<<13)|(1<<9)|(1<<4)|3 ),
        GID_RF4_VAP2            = GROUP_ID(4, (4<<13)|(1<<9)|(2<<4)|0 ),
            GID_RF4_VAP2_ACL    = GROUP_ID(4, (4<<13)|(1<<9)|(2<<4)|1 ),
            GID_RF4_VAP2_SEC    = GROUP_ID(4, (4<<13)|(1<<9)|(2<<4)|2 ),
            GID_RF4_VAP2_IAPP   = GROUP_ID(4, (4<<13)|(1<<9)|(2<<4)|3 ),
        GID_RF4_VAP3            = GROUP_ID(4, (4<<13)|(1<<9)|(3<<4)|0 ),
            GID_RF4_VAP3_ACL    = GROUP_ID(4, (4<<13)|(1<<9)|(3<<4)|1 ),
            GID_RF4_VAP3_SEC    = GROUP_ID(4, (4<<13)|(1<<9)|(3<<4)|2 ),
            GID_RF4_VAP3_IAPP   = GROUP_ID(4, (4<<13)|(1<<9)|(3<<4)|3 ),
        GID_RF4_VAP4            = GROUP_ID(4, (4<<13)|(1<<9)|(4<<4)|0 ),
            GID_RF4_VAP4_ACL    = GROUP_ID(4, (4<<13)|(1<<9)|(4<<4)|1 ),
            GID_RF4_VAP4_SEC    = GROUP_ID(4, (4<<13)|(1<<9)|(4<<4)|2 ),
            GID_RF4_VAP4_IAPP   = GROUP_ID(4, (4<<13)|(1<<9)|(4<<4)|3 ),
        GID_RF4_VAP5            = GROUP_ID(4, (4<<13)|(1<<9)|(5<<4)|0 ),
            GID_RF4_VAP5_ACL    = GROUP_ID(4, (4<<13)|(1<<9)|(5<<4)|1 ),
            GID_RF4_VAP5_SEC    = GROUP_ID(4, (4<<13)|(1<<9)|(5<<4)|2 ),
            GID_RF4_VAP5_IAPP   = GROUP_ID(4, (4<<13)|(1<<9)|(5<<4)|3 ),
        GID_RF4_VAP6            = GROUP_ID(4, (4<<13)|(1<<9)|(6<<4)|0 ),
            GID_RF4_VAP6_ACL    = GROUP_ID(4, (4<<13)|(1<<9)|(6<<4)|1 ),
            GID_RF4_VAP6_SEC    = GROUP_ID(4, (4<<13)|(1<<9)|(6<<4)|2 ),
            GID_RF4_VAP6_IAPP   = GROUP_ID(4, (4<<13)|(1<<9)|(6<<4)|3 ),
        GID_RF4_VAP7            = GROUP_ID(4, (4<<13)|(1<<9)|(7<<4)|0 ),
            GID_RF4_VAP7_ACL    = GROUP_ID(4, (4<<13)|(1<<9)|(7<<4)|1 ),
            GID_RF4_VAP7_SEC    = GROUP_ID(4, (4<<13)|(1<<9)|(7<<4)|2 ),
            GID_RF4_VAP7_IAPP   = GROUP_ID(4, (4<<13)|(1<<9)|(7<<4)|3 ),
        GID_RF4_VAP8            = GROUP_ID(4, (4<<13)|(1<<9)|(8<<4)|0 ),
            GID_RF4_VAP8_ACL    = GROUP_ID(4, (4<<13)|(1<<9)|(8<<4)|1 ),
            GID_RF4_VAP8_SEC    = GROUP_ID(4, (4<<13)|(1<<9)|(8<<4)|2 ),
            GID_RF4_VAP8_IAPP   = GROUP_ID(4, (4<<13)|(1<<9)|(8<<4)|3 ),
        GID_RF4_WDS1            = GROUP_ID(4, (4<<13)|(2<<9)|1 ), 
        GID_RF4_WDS2            = GROUP_ID(4, (4<<13)|(2<<9)|2 ),
        GID_RF4_WDS3            = GROUP_ID(4, (4<<13)|(2<<9)|3 ),
        GID_RF4_WDS4            = GROUP_ID(4, (4<<13)|(2<<9)|4 ),
        GID_RF4_WDS5            = GROUP_ID(4, (4<<13)|(2<<9)|5 ), 
        GID_RF4_WDS6            = GROUP_ID(4, (4<<13)|(2<<9)|6 ),
        GID_RF4_WDS7            = GROUP_ID(4, (4<<13)|(2<<9)|7 ),
        GID_RF4_WDS8            = GROUP_ID(4, (4<<13)|(2<<9)|8 ),
        GID_RF4_SCAN            = GROUP_ID(4, (4<<13)|(3<<9)|0 ),
	GID_RF4_STA1		= GROUP_ID(4, (4<<13)|(4<<9)|0 ),
            GID_RF4_STA1_SEC    = GROUP_ID(4, (4<<13)|(4<<9)|(1<<4)|0 ),
	GID_RF4_REP1		= GROUP_ID(4, (4<<13)|(5<<9)|0 ),
            GID_RF4_REP1_SEC    = GROUP_ID(4, (4<<13)|(5<<9)|(1<<4)|0 ),

	GID_NET_GENERAL		= GROUP_ID(5, (1<<13)|0),
	    GID_NET_WALL	= GROUP_ID(5, (1<<13)|(1<<9)|(1<<4)|0),
	    GID_NET_WALL_AD	= GROUP_ID(5, (1<<13)|(1<<9)|(1<<4)|1),
	    GID_DOS_PREVENTION	= GROUP_ID(5, (1<<13)|(2<<9)|0 ),

	GID_NET_VLAN		= GROUP_ID(5, (2<<13)|0),
	GID_NET_VLAN0           = GROUP_ID(5, (2<<13)|(1<<9)|(1<<4)|0),
	    GID_NET_VLAN0_CONF  = GROUP_ID(5, (2<<13)|(1<<9)|(1<<4)|1),
	    GID_NET_VLAN0_DHCP  = GROUP_ID(5, (2<<13)|(1<<9)|(1<<4)|2),
	    GID_NET_VLAN0_POLICY= GROUP_ID(5, (2<<13)|(1<<9)|(1<<4)|3), 
	    GID_NET_VLAN0_LOGINPAGE= GROUP_ID(5, (2<<13)|(1<<9)|(1<<4)|4), 
	    GID_NET_VLAN0_LOGINSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(1<<4)|5), 
	    GID_NET_VLAN0_LOGINFAIL= GROUP_ID(5, (2<<13)|(1<<9)|(1<<4)|6), 
	    GID_NET_VLAN0_LOGINSUCCESSOD= GROUP_ID(5, (2<<13)|(1<<9)|(1<<4)|7), 
	    GID_NET_VLAN0_LOGOUTSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(1<<4)|8), 
	    GID_NET_VLAN0_DHCPRELAY  = GROUP_ID(5, (2<<13)|(1<<9)|(1<<4)|9),
	GID_NET_VLAN1           = GROUP_ID(5, (2<<13)|(1<<9)|(2<<4)|0),
	    GID_NET_VLAN1_CONF  = GROUP_ID(5, (2<<13)|(1<<9)|(2<<4)|1),
	    GID_NET_VLAN1_DHCP  = GROUP_ID(5, (2<<13)|(1<<9)|(2<<4)|2),
	    GID_NET_VLAN1_POLICY= GROUP_ID(5, (2<<13)|(1<<9)|(2<<4)|3),
	    GID_NET_VLAN1_LOGINPAGE= GROUP_ID(5, (2<<13)|(1<<9)|(2<<4)|4), 
	    GID_NET_VLAN1_LOGINSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(2<<4)|5), 
	    GID_NET_VLAN1_LOGINFAIL= GROUP_ID(5, (2<<13)|(1<<9)|(2<<4)|6), 
	    GID_NET_VLAN1_LOGINSUCCESSOD= GROUP_ID(5, (2<<13)|(1<<9)|(2<<4)|7), 
	    GID_NET_VLAN1_LOGOUTSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(2<<4)|8), 
	    GID_NET_VLAN1_DHCPRELAY  = GROUP_ID(5, (2<<13)|(1<<9)|(2<<4)|9),
	GID_NET_VLAN2           = GROUP_ID(5, (2<<13)|(1<<9)|(3<<4)|0),
	    GID_NET_VLAN2_CONF  = GROUP_ID(5, (2<<13)|(1<<9)|(3<<4)|1),
	    GID_NET_VLAN2_DHCP  = GROUP_ID(5, (2<<13)|(1<<9)|(3<<4)|2),
	    GID_NET_VLAN2_POLICY= GROUP_ID(5, (2<<13)|(1<<9)|(3<<4)|3),
	    GID_NET_VLAN2_LOGINPAGE= GROUP_ID(5, (2<<13)|(1<<9)|(3<<4)|4), 
	    GID_NET_VLAN2_LOGINSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(3<<4)|5), 
	    GID_NET_VLAN2_LOGINFAIL= GROUP_ID(5, (2<<13)|(1<<9)|(3<<4)|6), 
	    GID_NET_VLAN2_LOGINSUCCESSOD= GROUP_ID(5, (2<<13)|(1<<9)|(3<<4)|7), 
	    GID_NET_VLAN2_LOGOUTSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(3<<4)|8), 
	    GID_NET_VLAN2_DHCPRELAY  = GROUP_ID(5, (2<<13)|(1<<9)|(3<<4)|9),
	GID_NET_VLAN3           = GROUP_ID(5, (2<<13)|(1<<9)|(4<<4)|0),
	    GID_NET_VLAN3_CONF  = GROUP_ID(5, (2<<13)|(1<<9)|(4<<4)|1),
	    GID_NET_VLAN3_DHCP  = GROUP_ID(5, (2<<13)|(1<<9)|(4<<4)|2),
	    GID_NET_VLAN3_POLICY= GROUP_ID(5, (2<<13)|(1<<9)|(4<<4)|3),
	    GID_NET_VLAN3_LOGINPAGE= GROUP_ID(5, (2<<13)|(1<<9)|(4<<4)|4), 
	    GID_NET_VLAN3_LOGINSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(4<<4)|5), 
	    GID_NET_VLAN3_LOGINFAIL= GROUP_ID(5, (2<<13)|(1<<9)|(4<<4)|6), 
	    GID_NET_VLAN3_LOGINSUCCESSOD= GROUP_ID(5, (2<<13)|(1<<9)|(4<<4)|7), 
	    GID_NET_VLAN3_LOGOUTSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(4<<4)|8), 
	    GID_NET_VLAN3_DHCPRELAY  = GROUP_ID(5, (2<<13)|(1<<9)|(4<<4)|9),
	GID_NET_VLAN4           = GROUP_ID(5, (2<<13)|(1<<9)|(5<<4)|0),
	    GID_NET_VLAN4_CONF  = GROUP_ID(5, (2<<13)|(1<<9)|(5<<4)|1),
	    GID_NET_VLAN4_DHCP  = GROUP_ID(5, (2<<13)|(1<<9)|(5<<4)|2),
	    GID_NET_VLAN4_POLICY= GROUP_ID(5, (2<<13)|(1<<9)|(5<<4)|3),
	    GID_NET_VLAN4_LOGINPAGE= GROUP_ID(5, (2<<13)|(1<<9)|(5<<4)|4), 
	    GID_NET_VLAN4_LOGINSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(5<<4)|5), 
	    GID_NET_VLAN4_LOGINFAIL= GROUP_ID(5, (2<<13)|(1<<9)|(5<<4)|6), 
	    GID_NET_VLAN4_LOGINSUCCESSOD= GROUP_ID(5, (2<<13)|(1<<9)|(5<<4)|7), 
	    GID_NET_VLAN4_LOGOUTSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(5<<4)|8), 
	    GID_NET_VLAN4_DHCPRELAY  = GROUP_ID(5, (2<<13)|(1<<9)|(5<<4)|9),
	GID_NET_VLAN5           = GROUP_ID(5, (2<<13)|(1<<9)|(6<<4)|0),
	    GID_NET_VLAN5_CONF  = GROUP_ID(5, (2<<13)|(1<<9)|(6<<4)|1),
	    GID_NET_VLAN5_DHCP  = GROUP_ID(5, (2<<13)|(1<<9)|(6<<4)|2),
	    GID_NET_VLAN5_POLICY= GROUP_ID(5, (2<<13)|(1<<9)|(6<<4)|3),
	    GID_NET_VLAN5_LOGINPAGE= GROUP_ID(5, (2<<13)|(1<<9)|(6<<4)|4), 
	    GID_NET_VLAN5_LOGINSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(6<<4)|5), 
	    GID_NET_VLAN5_LOGINFAIL= GROUP_ID(5, (2<<13)|(1<<9)|(6<<4)|6), 
	    GID_NET_VLAN5_LOGINSUCCESSOD= GROUP_ID(5, (2<<13)|(1<<9)|(6<<4)|7), 
	    GID_NET_VLAN5_LOGOUTSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(6<<4)|8), 
	    GID_NET_VLAN5_DHCPRELAY  = GROUP_ID(5, (2<<13)|(1<<9)|(6<<4)|9),
	GID_NET_VLAN6           = GROUP_ID(5, (2<<13)|(1<<9)|(7<<4)|0),
	    GID_NET_VLAN6_CONF  = GROUP_ID(5, (2<<13)|(1<<9)|(7<<4)|1),
	    GID_NET_VLAN6_DHCP  = GROUP_ID(5, (2<<13)|(1<<9)|(7<<4)|2),
	    GID_NET_VLAN6_POLICY= GROUP_ID(5, (2<<13)|(1<<9)|(7<<4)|3),
	    GID_NET_VLAN6_LOGINPAGE= GROUP_ID(5, (2<<13)|(1<<9)|(7<<4)|4), 
	    GID_NET_VLAN6_LOGINSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(7<<4)|5), 
	    GID_NET_VLAN6_LOGINFAIL= GROUP_ID(5, (2<<13)|(1<<9)|(7<<4)|6), 
	    GID_NET_VLAN6_LOGINSUCCESSOD= GROUP_ID(5, (2<<13)|(1<<9)|(7<<4)|7), 
	    GID_NET_VLAN6_LOGOUTSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(7<<4)|8), 
	    GID_NET_VLAN6_DHCPRELAY  = GROUP_ID(5, (2<<13)|(1<<9)|(7<<4)|9),
	GID_NET_VLAN7           = GROUP_ID(5, (2<<13)|(1<<9)|(8<<4)|0),
	    GID_NET_VLAN7_CONF  = GROUP_ID(5, (2<<13)|(1<<9)|(8<<4)|1),
	    GID_NET_VLAN7_DHCP  = GROUP_ID(5, (2<<13)|(1<<9)|(8<<4)|2),
	    GID_NET_VLAN7_POLICY= GROUP_ID(5, (2<<13)|(1<<9)|(8<<4)|3),
	    GID_NET_VLAN7_LOGINPAGE= GROUP_ID(5, (2<<13)|(1<<9)|(8<<4)|4), 
	    GID_NET_VLAN7_LOGINSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(8<<4)|5), 
	    GID_NET_VLAN7_LOGINFAIL= GROUP_ID(5, (2<<13)|(1<<9)|(8<<4)|6), 
	    GID_NET_VLAN7_LOGINSUCCESSOD= GROUP_ID(5, (2<<13)|(1<<9)|(8<<4)|7), 
	    GID_NET_VLAN7_LOGOUTSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(8<<4)|8), 
	    GID_NET_VLAN7_DHCPRELAY  = GROUP_ID(5, (2<<13)|(1<<9)|(8<<4)|9),
	GID_NET_VLAN8		= GROUP_ID(5, (2<<13)|(1<<9)|(9<<4)|0),
	    GID_NET_VLAN8_CONF  = GROUP_ID(5, (2<<13)|(1<<9)|(9<<4)|1),
	    GID_NET_VLAN8_DHCP  = GROUP_ID(5, (2<<13)|(1<<9)|(9<<4)|2),
	    GID_NET_VLAN8_POLICY= GROUP_ID(5, (2<<13)|(1<<9)|(9<<4)|3),
	    GID_NET_VLAN8_LOGINPAGE= GROUP_ID(5, (2<<13)|(1<<9)|(9<<4)|4), 
	    GID_NET_VLAN8_LOGINSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(9<<4)|5), 
	    GID_NET_VLAN8_LOGINFAIL= GROUP_ID(5, (2<<13)|(1<<9)|(9<<4)|6), 
	    GID_NET_VLAN8_LOGINSUCCESSOD= GROUP_ID(5, (2<<13)|(1<<9)|(9<<4)|7), 
	    GID_NET_VLAN8_LOGOUTSUCCESS= GROUP_ID(5, (2<<13)|(1<<9)|(9<<4)|8), 
	    GID_NET_VLAN8_DHCPRELAY  = GROUP_ID(5, (2<<13)|(1<<9)|(9<<4)|9),

	GID_MGMT_AUTH		= GROUP_ID(5, (3<<13)|(1<<9)|0),
	GID_MGMT_AUTH1		= GROUP_ID(5, (3<<13)|(1<<9)|(1<<4)|0),
	    GID_MGMT_AUTH1_RO	= GROUP_ID(5, (3<<13)|(1<<9)|(1<<4)|1),
	GID_MGMT_AUTH2		= GROUP_ID(5, (3<<13)|(1<<9)|(2<<4)|0),
	    GID_MGMT_AUTH2_NAS  = GROUP_ID(5, (3<<13)|(1<<9)|(2<<4)|1),
	    GID_MGMT_AUTH2_MAP  = GROUP_ID(5, (3<<13)|(1<<9)|(2<<4)|2),
	GID_MGMT_AUTH3		= GROUP_ID(5, (3<<13)|(1<<9)|(3<<4)|0),
	    GID_MGMT_AUTH3_NAS  = GROUP_ID(5, (3<<13)|(1<<9)|(3<<4)|1),
	    GID_MGMT_AUTH3_MAP  = GROUP_ID(5, (3<<13)|(1<<9)|(3<<4)|2),
	GID_MGMT_AUTH4		= GROUP_ID(5, (3<<13)|(1<<9)|(4<<4)|0),
	    GID_MGMT_AUTH4_NAS	= GROUP_ID(5, (3<<13)|(1<<9)|(4<<4)|1),
	    GID_MGMT_AUTH4_MAP	= GROUP_ID(5, (3<<13)|(1<<9)|(4<<4)|2),
	GID_MGMT_AUTH5		= GROUP_ID(5, (3<<13)|(1<<9)|(5<<4)|0),
	    GID_MGMT_AUTH5_NAS  = GROUP_ID(5, (3<<13)|(1<<9)|(5<<4)|1),
	    GID_MGMT_AUTH5_MAP  = GROUP_ID(5, (3<<13)|(1<<9)|(5<<4)|2),
	GID_MGMT_AUTH6		= GROUP_ID(5, (3<<13)|(1<<9)|(6<<4)|0),
	    GID_MGMT_AUTH6_TICKET=GROUP_ID(5, (3<<13)|(1<<9)|(6<<4)|1),

	GID_OD_BILL1		= GROUP_ID(5, (3<<13)|(2<<9)|(1<<4)|0),
	GID_OD_BILL2            = GROUP_ID(5, (3<<13)|(2<<9)|(1<<4)|1),
	GID_OD_BILL3            = GROUP_ID(5, (3<<13)|(2<<9)|(1<<4)|2),
	GID_OD_BILL4            = GROUP_ID(5, (3<<13)|(2<<9)|(1<<4)|3),
	GID_OD_BILL5            = GROUP_ID(5, (3<<13)|(2<<9)|(1<<4)|4),
	GID_OD_BILL6            = GROUP_ID(5, (3<<13)|(2<<9)|(1<<4)|5),
	GID_OD_BILL7            = GROUP_ID(5, (3<<13)|(2<<9)|(1<<4)|6),
	GID_OD_BILL8            = GROUP_ID(5, (3<<13)|(2<<9)|(1<<4)|7),
	GID_OD_BILL9            = GROUP_ID(5, (3<<13)|(2<<9)|(1<<4)|8),
	GID_OD_BILL10           = GROUP_ID(5, (3<<13)|(2<<9)|(1<<4)|9),

	GID_OD_TERM		= GROUP_ID(5, (3<<13)|(3<<9)|0),
	GID_OD_TERM1		= GROUP_ID(5, (3<<13)|(3<<9)|(1<<4)|0),
	GID_OD_TERM2            = GROUP_ID(5, (3<<13)|(3<<9)|(1<<4)|1),
	GID_OD_TERM3            = GROUP_ID(5, (3<<13)|(3<<9)|(1<<4)|2),
	GID_OD_TERM4            = GROUP_ID(5, (3<<13)|(3<<9)|(1<<4)|3),
	GID_OD_TERM5            = GROUP_ID(5, (3<<13)|(3<<9)|(1<<4)|4),
	GID_OD_TERM6            = GROUP_ID(5, (3<<13)|(3<<9)|(1<<4)|5),
	GID_OD_TERM7            = GROUP_ID(5, (3<<13)|(3<<9)|(1<<4)|6),
	GID_OD_TERM8            = GROUP_ID(5, (3<<13)|(3<<9)|(1<<4)|7),
	GID_OD_TERM9            = GROUP_ID(5, (3<<13)|(3<<9)|(1<<4)|8),
	GID_OD_TERM10           = GROUP_ID(5, (3<<13)|(3<<9)|(1<<4)|9),

	GID_NAS_CLIENT1		= GROUP_ID(5, (3<<13)|(4<<9)|(1<<4)|0),
	GID_NAS_CLIENT2         = GROUP_ID(5, (3<<13)|(4<<9)|(1<<4)|1),
	GID_NAS_CLIENT3		= GROUP_ID(5, (3<<13)|(4<<9)|(1<<4)|2),
	GID_NAS_CLIENT4         = GROUP_ID(5, (3<<13)|(4<<9)|(1<<4)|3),
	GID_NAS_CLIENT5         = GROUP_ID(5, (3<<13)|(4<<9)|(1<<4)|4),
	GID_NAS_CLIENT6         = GROUP_ID(5, (3<<13)|(4<<9)|(1<<4)|5),
	GID_NAS_CLIENT7         = GROUP_ID(5, (3<<13)|(4<<9)|(1<<4)|6),
	GID_NAS_CLIENT8         = GROUP_ID(5, (3<<13)|(4<<9)|(1<<4)|7),
	GID_NAS_CLIENT9         = GROUP_ID(5, (3<<13)|(4<<9)|(1<<4)|8),
	GID_NAS_CLIENT10	= GROUP_ID(5, (3<<13)|(4<<9)|(1<<4)|9),

	GID_BLACKLIST		= GROUP_ID(5, (3<<13)|(5<<9)|0),
	GID_BLACKLIST1		= GROUP_ID(5, (3<<13)|(5<<9)|(1<<4)|0),
	GID_BLACKLIST2		= GROUP_ID(5, (3<<13)|(5<<9)|(1<<4)|1),
	GID_BLACKLIST3		= GROUP_ID(5, (3<<13)|(5<<9)|(1<<4)|2),
	GID_BLACKLIST4		= GROUP_ID(5, (3<<13)|(5<<9)|(1<<4)|3),
	GID_BLACKLIST5		= GROUP_ID(5, (3<<13)|(5<<9)|(1<<4)|4),
	GID_BLACKLIST6		= GROUP_ID(5, (3<<13)|(5<<9)|(1<<4)|5),

	GID_PRIVILEGEIP		= GROUP_ID(5, (3<<13)|(6<<9)|(1<<4)|0),
	GID_PRIVILEGEMAC	= GROUP_ID(5, (3<<13)|(6<<9)|(2<<4)|0),

	GID_POLICY0      	= GROUP_ID(6, (1<<8)|1),
	GID_POLICY0_FRULE	= GROUP_ID(6, (1<<8)|(1<<3)|0),
	GID_POLICY0_ROUTE	= GROUP_ID(6, (1<<8)|(1<<3)|1),
	GID_POLICY0_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(1<<3)|2),
	GID_POLICY0_BANDWIDTH	= GROUP_ID(6, (1<<8)|(1<<3)|3),
	GID_POLICY1		= GROUP_ID(6, (1<<8)|2),
	GID_POLICY1_FRULE	= GROUP_ID(6, (1<<8)|(2<<3)|0),
	GID_POLICY1_ROUTE	= GROUP_ID(6, (1<<8)|(2<<3)|1),
	GID_POLICY1_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(2<<3)|2),
	GID_POLICY1_BANDWIDTH	= GROUP_ID(6, (1<<8)|(2<<3)|3),
	GID_POLICY2		= GROUP_ID(6, (1<<8)|3),
	GID_POLICY2_FRULE	= GROUP_ID(6, (1<<8)|(3<<3)|0),
	GID_POLICY2_ROUTE	= GROUP_ID(6, (1<<8)|(3<<3)|1),
	GID_POLICY2_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(3<<3)|2),
	GID_POLICY2_BANDWIDTH	= GROUP_ID(6, (1<<8)|(3<<3)|3),
	GID_POLICY3		= GROUP_ID(6, (1<<8)|4),
	GID_POLICY3_FRULE	= GROUP_ID(6, (1<<8)|(4<<3)|0),
	GID_POLICY3_ROUTE	= GROUP_ID(6, (1<<8)|(4<<3)|1),
	GID_POLICY3_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(4<<3)|2),
	GID_POLICY3_BANDWIDTH	= GROUP_ID(6, (1<<8)|(4<<3)|3),
	GID_POLICY4		= GROUP_ID(6, (1<<8)|5),
	GID_POLICY4_FRULE	= GROUP_ID(6, (1<<8)|(5<<3)|0),
	GID_POLICY4_ROUTE	= GROUP_ID(6, (1<<8)|(5<<3)|1),
	GID_POLICY4_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(5<<3)|2),
	GID_POLICY4_BANDWIDTH	= GROUP_ID(6, (1<<8)|(5<<3)|3),
	GID_POLICY5		= GROUP_ID(6, (1<<8)|6),
	GID_POLICY5_FRULE	= GROUP_ID(6, (1<<8)|(6<<3)|0),
	GID_POLICY5_ROUTE	= GROUP_ID(6, (1<<8)|(6<<3)|1),
	GID_POLICY5_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(6<<3)|2),
	GID_POLICY5_BANDWIDTH	= GROUP_ID(6, (1<<8)|(6<<3)|3),
	GID_POLICY6		= GROUP_ID(6, (1<<8)|7),
	GID_POLICY6_FRULE	= GROUP_ID(6, (1<<8)|(7<<3)|0),
	GID_POLICY6_ROUTE	= GROUP_ID(6, (1<<8)|(7<<3)|1),
	GID_POLICY6_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(7<<3)|2),
	GID_POLICY6_BANDWIDTH	= GROUP_ID(6, (1<<8)|(7<<3)|3),
	GID_POLICY7		= GROUP_ID(6, (1<<8)|8),
	GID_POLICY7_FRULE	= GROUP_ID(6, (1<<8)|(8<<3)|0),
	GID_POLICY7_ROUTE	= GROUP_ID(6, (1<<8)|(8<<3)|1),
	GID_POLICY7_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(8<<3)|2),
	GID_POLICY7_BANDWIDTH	= GROUP_ID(6, (1<<8)|(8<<3)|3),
	GID_POLICY8		= GROUP_ID(6, (1<<8)|9),
	GID_POLICY8_FRULE	= GROUP_ID(6, (1<<8)|(9<<3)|0),
	GID_POLICY8_ROUTE	= GROUP_ID(6, (1<<8)|(9<<3)|1),
	GID_POLICY8_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(9<<3)|2),
	GID_POLICY8_BANDWIDTH	= GROUP_ID(6, (1<<8)|(9<<3)|3),
	GID_POLICY9		= GROUP_ID(6, (1<<8)|10),
	GID_POLICY9_FRULE	= GROUP_ID(6, (1<<8)|(10<<3)|0),
	GID_POLICY9_ROUTE	= GROUP_ID(6, (1<<8)|(10<<3)|1),
	GID_POLICY9_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(10<<3)|2),
	GID_POLICY9_BANDWIDTH	= GROUP_ID(6, (1<<8)|(10<<3)|3),
	GID_POLICY10		= GROUP_ID(6, (1<<8)|11),
	GID_POLICY10_FRULE	= GROUP_ID(6, (1<<8)|(11<<3)|0),
	GID_POLICY10_ROUTE	= GROUP_ID(6, (1<<8)|(11<<3)|1),
	GID_POLICY10_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(11<<3)|2),
	GID_POLICY10_BANDWIDTH	= GROUP_ID(6, (1<<8)|(11<<3)|3),
	GID_POLICY11		= GROUP_ID(6, (1<<8)|12),
	GID_POLICY11_FRULE	= GROUP_ID(6, (1<<8)|(12<<3)|0),
	GID_POLICY11_ROUTE	= GROUP_ID(6, (1<<8)|(12<<3)|1),
	GID_POLICY11_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(12<<3)|2),
	GID_POLICY11_BANDWIDTH	= GROUP_ID(6, (1<<8)|(12<<3)|3),
	GID_POLICY12		= GROUP_ID(6, (1<<8)|13),
	GID_POLICY12_FRULE	= GROUP_ID(6, (1<<8)|(13<<3)|0),
	GID_POLICY12_ROUTE	= GROUP_ID(6, (1<<8)|(13<<3)|1),
	GID_POLICY12_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(13<<3)|2),
	GID_POLICY12_BANDWIDTH	= GROUP_ID(6, (1<<8)|(13<<3)|3),
	GID_POLICY13		= GROUP_ID(6, (1<<8)|14),
	GID_POLICY13_FRULE	= GROUP_ID(6, (1<<8)|(14<<3)|0),
	GID_POLICY13_ROUTE	= GROUP_ID(6, (1<<8)|(14<<3)|1),
	GID_POLICY13_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(14<<3)|2),
	GID_POLICY13_BANDWIDTH	= GROUP_ID(6, (1<<8)|(14<<3)|3),
	GID_POLICY14		= GROUP_ID(6, (1<<8)|15),
	GID_POLICY14_FRULE	= GROUP_ID(6, (1<<8)|(15<<3)|0),
	GID_POLICY14_ROUTE	= GROUP_ID(6, (1<<8)|(15<<3)|1),
	GID_POLICY14_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(15<<3)|2),
	GID_POLICY14_BANDWIDTH	= GROUP_ID(6, (1<<8)|(15<<3)|3),
	GID_POLICY15		= GROUP_ID(6, (1<<8)|16),
	GID_POLICY15_FRULE	= GROUP_ID(6, (1<<8)|(16<<3)|0),
	GID_POLICY15_ROUTE	= GROUP_ID(6, (1<<8)|(16<<3)|1),
	GID_POLICY15_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(16<<3)|2),
	GID_POLICY15_BANDWIDTH	= GROUP_ID(6, (1<<8)|(16<<3)|3),
	GID_POLICY16		= GROUP_ID(6, (1<<8)|17),
	GID_POLICY16_FRULE	= GROUP_ID(6, (1<<8)|(17<<3)|0),
	GID_POLICY16_ROUTE	= GROUP_ID(6, (1<<8)|(17<<3)|1),
	GID_POLICY16_SESSION_LIMIT	= GROUP_ID(6, (1<<8)|(17<<3)|2),
	GID_POLICY16_BANDWIDTH	= GROUP_ID(6, (1<<8)|(17<<3)|3),

// 
    GID_END                     = 0
};


#define MAGIC_A260    0x00010010
#define MAGIC_A300    0x00010011
#define MAGIC_A300R1  0x00010016
#define MAGIC_A800    0x00010030
#define MAGIC_A800G   0x00010031
#define MAGIC_WCB1000 0x00010012
#define MAGIC_A600    0x00010013
#define MAGIC_A560    0x00010014
#define MAGIC_A560R1  0x00010019
#define MAGIC_W1100   0x00010015
#define MAGIC_A704    0x00010017
#define MAGIC_A700    0x00010018
#define MAGIC_A210    0x0001001a
#define MAGIC_A520    0x0001001b
#define MAGIC_A110    0x0001001c
#define MAGIC_A524    0x0001001d
#define MAGIC_A747    0x0001001e
#define MAGIC_A620    0x0001001f


#endif
