#ifndef _PREMISSION_H_
#define _PREMISSION_H_

/* User Group */
#define     USER_GROUP_END      0
#define     USER_GROUP_NONE     -1
#define     USER_GROUP_1        1
#define     USER_GROUP_2        2
#define     USER_GROUP_3        3

/* Permission */
#define     PERM_NONE           0x0
#define     PERM_READ           0x1
#define     PERM_WRITE          0x2
#define     PERM_EXEC           0x4

/* Operation ID */
#define     OID_DHCP_RENEW      0x01
#define     OID_SCAN            0x02
#define     OID_PING            0x03
#define     OID_RESET_CONFIG    0x04
#define     OID_BACKUP_CONFIG   0x05
#define     OID_RESTORE_CONFIG  0x06
#define     OID_SYS_UPGRADE     0x07
#define     OID_REBOOT          0x08
#define     OID_CHANGE_ALL_PWD  0x09
#define     OID_WPS_OPERATION   0x0a
#define     OID_EXPORT_LOCAL	0x0b
#define     OID_EXPORT_ONDEMAND	0x0c

#define     PERM(g, p)          ((p) << ((g-1)*3))
#define     GET_GRP_PERM(g, p)  (((p) >> ((g-1)*3)) & 0x7)

typedef struct {
    unsigned int gid;
    char         *name;
    unsigned int permission;
} permission_row_t;

typedef struct {
    unsigned int    u_gid;
    char            *u_name;
} user_group_row_t;

#endif
