#ifndef _SYSCALL_H_
#define _SYSCALL_H_


// TODO: make path configable in runtime
//define path
#define PATH_RC_NET          "/etc/rc.d/rc.net"
#define PATH_RC_WLAN         "/etc/rc.d/rc.wlan"
#define PATH_RC_BRIDGE       "/etc/rc.d/rc.bridge"
#define PATH_RC_MGNT         "/etc/rc.d/rc.mgnt"
#define PATH_RC_SYSTIME	     "/etc/rc.d/rc.systime"	   
#define PATH_UDHCPD          "/etc/rc.d/udhcpd.sh"
#define PATH_DUMPLEASES      "/usr/bin/dumpleases"
#define PATH_LEASE_FILE      "/tmp/udhcpd_%s.leases"
#define PATH_TMP_LEASE_FILE  "/tmp/leases.txt"
#define PATH_IWPRIV          "/sbin/iwpriv"
#define PATH_IWLIST          "/sbin/iwlist"
#define PATH_IWCONFIG        "/sbin/iwconfig"
#define PATH_IFCONFIG        "/sbin/ifconfig"
#define PATH_LOGREAD	     "/sbin/logread"
#define PATH_OOPSLOG	     "/usr/sbin/oopslog"
#define PATH_OOPSLOG_FILE    "/tmp/oopsLog"
#define PATH_CAPWAP_LOG	     "/var/log/wtp.log.txt"
#define PATH_WDS_SLAVE       "/bin/wdsds"
#define PATH_TOUCH           "/bin/touch"
#define PATH_SCAN            "/sbin/scan"
#define PATH_BSSINFO         "/sbin/bss_info"
#define PATH_STALIST         "/sbin/sta_list"
#define PATH_WDSLIST         "/sbin/wds_list"
#define PATH_CHECK_GRE	     "/sbin/check_gre_peer"
#define PATH_CHECK_WTP	     "/sbin/check_wtp"
#define PATH_UPTIME_FILE     "/proc/uptime"
#define PATH_NET_ROUTE       "/proc/net/route"
#define PATH_IRQ             "/proc/interrupts"
#define PATH_KERNEL          "/proc/version"
#define PATH_KERNEL_TAG      "/etc/kernel_tag"
#define PATH_BUILD           "/etc/build"
#define PATH_BUILD_TIME      "/etc/build_time"
#define PATH_BUILD_TAG       "/etc/build_tag"
#define PATH_MODEL           "/etc/model"
#define PATH_PKG_INFO        "/etc/pkg.info"
#define PATH_PRODUCT_INFO    "/etc/product.info"
#define PATH_SYNC_CFG        "/tmp/sync_config"
#define PATH_DATE            "/tmp/date"
#define PATH_IW_DATA         "/tmp/iwconfig"
#define PATH_IWPRIV_DATA     "/tmp/iwpriv"
#define PRODUCT_INFO_COMPANY "COMPANY"
#define PRODUCT_INFO_PRODUCT "PRODUCT"
#define PRODUCT_INFO_DEVICE  "DEIVICE"
#define PRODUCT_INFO_PLATFORM "PLATFORM"
#define PRODUCT_INFO_MODEL   "MODEL"
#define PRODUCT_INFO_SITE    "SITE"
#define PATH_FIREWALL_CONF   "/tmp/firewall.conf"
#define PATH_FIREWALL_MOD    "/sbin/firewall_mod.sh"
#define PATH_TRANS_CONF_SH   "/etc/rc.d/trans.conf.sh"
#define PATH_MINIUPNPD_CONF  "/tmp/miniupnpd.conf"
#define PATH_RC_DDNS         "/etc/rc.d/rc.ddns"
#define PATH_PING            "/bin/ping"
#define PATH_PING_RESULT     "/tmp/ping_result"
#define PATH_TRACERT	     "/usr/bin/traceroute"
#define PATH_TRACERT_RESULT  "/tmp/trace_result"
#define PATH_ARP	     "/ramfs/bin/arp.sh"
#define PATH_REBOOT_FLAG     "/tmp/reboot.t"
#define PATH_FEATURE_CTRL    "/conf/fctrl_web.conf"
#define PATH_CUSTOMIZE_SH    "/sbin/customize.sh"
#define PATH_BFW    	     "/etc/rc.d/bfirewall.sh"
#define PATH_DAI    	     "/etc/rc.d/DAI.sh"

//define sys_id
#define CMD_REBOOT          0
#define CMD_CLEAR_SYSLOG    1
#define CMD_RENEW_IP        2
#define CMD_GEN_SYSLOG	    3

#define POSTFIX_LEN             64
#define MAX_AUTH_SERVERS        5

//define system error code
#define SYS_UPLOAD_SUCCESS           0
#define SYS_BACKUP_SUCCESS           0
#define SYS_WRITE_SUCCESS            0
#define SYS_ERR_CHECK_SUM           -1
#define SYS_ERR_MAGIC_NUM           -2
#define SYS_ERR_WRITE_FLASH         -3
#define SYS_ERR_UPLOAD_FAIL         -4
#define SYS_ERR_GENERAL             -9
#define SYS_ERR_FW_FORMAT           -10
#define SYS_ERR_BRAND_MISMATCH	    -11
#define SYS_ERR_FW_VER_DOWN         -12

int get_pid(char *process);
int cip_system(char *cmd);
int uptime(char *time);
int get_if(char *if_name, char *attr, char *value);
int apply_sys(int sys_id);
int get_sys_item(char *name, char *value);
unsigned int checksum(char *addr, unsigned int count);
int pkg_info(int f_size, char *value);
int chk_cfg_sync(char *, void *);
void print_arg(char *, char *, int (*)(char *, void *));
void print_int(char *, char *, int (*)(char *, void *));
void print_double(char *, char *, int (*)(char *, void *));
void print_str(char *, char *, int (*)(char *, void *));
void print_uptime(char *, char *, int (*)(char *, void *));
void print_date(char *, char *, int (*)(char *, void *));
void print_ip(char *, char *, int (*)(char *, void *));
void print_mac(char *, char *, int (*)(char *, void *));
void print_band(char *, char *, int (*)(char *, void *));
void get_ver(char*, char*);
int get_dev_ver(char *, void *);
int get_arg(char *, void *);
int get_date(char *, void *);
int get_file_content(char *, void *);
int get_product_info(char *, void *);
int find_partition(const char *name, char *partition);
int find_mtd(const char *name, char *mtd);
int find_mtdblock(const char *name, char *mtdblock);
int cip_ping(char *url);
int cip_ping_p(char *url, int *pid_p);
int cip_tracert_p(char *url, int *pid_p);
int chkFeature(char *key, char *value);

typedef struct ap_list {
    char ssid[33];
    char mac[18];
    int ch;
    int rate;
    int signal;
    char type[16];
    char security[32];
    struct ap_list *next;
} AP_LIST;

#define foreach_ap_get(node, list) \
    for (node = list; node; node = node->next)

typedef struct SYS_ITEM_LIST {
    char *item;
    char *key;
    void (*fp)(char*, char*, int (*)(char *, void *));
    int (*get_stat)(char *, void *);
} SYS_ITEM_LIST;

typedef struct BRAND_ID_LIST {
    char id[2];
    char *company;
    char *model;
} BRAND_ID_LIST;

void set_systime(char *systime, char *zone);
void print_aps(AP_LIST *list);
int free_ap_list(AP_LIST *list);
AP_LIST *wdsd_scan(int rfno, char *secret, int ch, int mode);
AP_LIST *rf_scan(int rfno, int is_scan, char t[]);
AP_LIST *wdsd_connected(int rfno);
// The following functions were implemented in cipcfg extension
int upload_firmware(unsigned char *upload_img, int len);
int getWebAccount(int idx, char *name, char *passwd);

int getpwd(int len, char *passwd);
int enc(char *src, char *dst,int shift);
int dec(char *src, char *dst);
int getVlanbyIP(char *clientip);
void checkSession(char *sess_str,  char *ipAdd, char *macAdd);
int userStatus(char *uname, int fullname);
int get_mgmt_index(char *username, int vlanId);
int getAuthStatus(char *mac);
int get_group_index( int vlanNo, int mgmt_ind);
int getpwd(int len, char *passwd);
unsigned long getexptime(int nDays);

char *get_rc_env(char *name, char *value, int len);
int ip_strtoaddr(char *ipstr, unsigned long *ipaddr);
char *ip_addrtostr(unsigned long ipaddr, char *ipstr);
int get_ipmask(char *ipstr, char *maskstr, unsigned long *broadcast, unsigned long *netaddr);
char* hexbinconvert(char* attr, int direct);
#endif
