#include <net/if.h>
#include <strings.h>
#include "proxy_arp.h"
#include "cipcfg.h"
#include "wlan.h"

#define EBT_CMD_TMP "ebtables -t nat -%c PROXY_ARP -p arp --arp-ip-dst %s -j arpreply --arpreply-mac %s"

static int is_sta_mac(const unsigned char *mac)
{
    int 		i, rfidx = 0;
    char 		ifname[IFNAMSIZ];
    ASSOC_STA_LIST 	*sta_list = NULL, *entry = NULL;

    for (i = 0; i < MAX_VAP; i++) {
	if (get_vap_ifname_by_idx(rfidx, i, ifname) == NULL)
	    continue;
	if ((sta_list = get_sta_list(ifname)) == NULL)
	    continue;
	foreach_ap_get(entry, sta_list) {
	    if (strcasecmp(mac, entry) == 0) {
		free_sta_list(sta_list);
		return 1;
	    }
	}
	free_sta_list(sta_list);
    }
    return 0;
}

int add_proxy_arp(const unsigned char *ip, const unsigned char *mac)
{
    char cmd[BUFSIZ];

    if (is_sta_mac(mac)) {
	sprintf(cmd, EBT_CMD_TMP, 'A', ip, mac);
	system(cmd);
	return 0;
    }
    return -1;
}

int remove_proxy_arp(const unsigned char *ip, const unsigned char *mac)
{
    char cmd[BUFSIZ];

    sprintf(cmd, EBT_CMD_TMP " >/dev/null 2>&1", 'D', ip, mac);
    system(cmd);
    return 0;
}
