
#ifndef __LINUX_BRIDGE_EBT_CIPRED_H
#define __LINUX_BRIDGE_EBT_CIPRED_H

#define EBT_CIPRED_NAME 0x01
#define EBT_CIPRED_SZ 0x02
#define EBT_CIPRED_MASK (EBT_CIPRED_NAME | EBT_CIPRED_SZ) 
#define EBT_CIPRED_MATCH "cipred"
#define CIPRED_SRC 1 
#define CIPRED_DST 2 
// the same values are used for the invflags

enum {
    XT_CIPNAM_CHECK    = 1 << 0,
    XT_CIPNAM_SET      = 1 << 1,
    XT_CIPNAM_UPDATE   = 1 << 2,
    XT_CIPNAM_REMOVE   = 1 << 3,
    XT_CIPNAM_ATTR     = 1 << 5,

    XT_CIPNAM_SOURCE   = 1 << 0,
    XT_CIPNAM_DEST     = 1 << 1,
    XT_CIPNAM_SRCMAC   = 1 << 2,

    XT_CIPNAM_NAME_LEN = 17,
    XT_CIPNAM_ACCOUNT  = 1,
};
struct ebt_cipred_info
{
	uint8_t  side;
	uint8_t  bitmask;
//	uint8_t  invflags;
    char name[XT_CIPNAM_NAME_LEN];
    char sz_name[XT_CIPNAM_NAME_LEN];
};


#endif
