#ifndef __LINUX_BRIDGE_EBT_MVLAN_H
#define __LINUX_BRIDGE_EBT_MVLAN_H

#define EBT_VLAN_ID		0x01
#define EBT_VLAN_PRIO		0x02
#define EBT_VLAN_ENCAP		0x04
#define EBT_VLAN_IP_PROTO	0x08
#define EBT_VLAN_IP_SPORT	0x10
#define EBT_VLAN_IP_DPORT	0x20
#define EBT_VLAN_MASK (EBT_VLAN_ID | EBT_VLAN_PRIO | EBT_VLAN_ENCAP | \
			EBT_VLAN_IP_PROTO | EBT_VLAN_IP_SPORT | EBT_VLAN_IP_DPORT)
#define EBT_VLAN_MATCH "mvlan"

struct ebt_vlan_info {
	uint16_t id[32];		/* VLAN ID {1-4095} */
	uint8_t prio;		/* VLAN User Priority {0-7} */
	__be16 encap;		/* VLAN Encapsulated frame code {0-65535} */
	uint8_t bitmask;		/* Args bitmask bit 1=1 - ID arg,
				   bit 2=1 User-Priority arg, bit 3=1 encap*/
	uint8_t invflags;		/* Inverse bitmask  bit 1=1 - inversed ID arg, 
				   bit 2=1 - inversed Pirority arg */
	int vidsize;
	uint8_t  protocol;
	uint16_t sport[2];
	uint16_t dport[2];

};

#endif
