/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf 14476 2006-04-18 17:36:51Z hardaker $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "a300.h"
#include "iwlib.h"
#include <stdlib.h> //for atol
#include "cipcfg.h"
#include "wlan.h"
#include "id.h"
#include <unistd.h> //fork
#include <signal.h>
#include <sys/wait.h>

#include <linux/netdevice.h>
#include <errno.h>

//#include "ath_wlan_status.h"
//private
//#define MINLOADFREQ 5                       // min reload frequency in seconds      // for testing
#define MINLOADFREQ 3                       // min reload frequency in seconds      // for testing
#define TABLE_SIZE   1
#ifndef UCHAR
  typedef unsigned char UCHAR;
#endif
#define PROC_NET_DEV      "/proc/net/dev"
#define PROC_NET_MADWIFI  "/proc/net/madwifi"
#define PATH_IWPRIV	"/sbin/iwpriv"
#define IEEE80211_IOCTL_STA_STATS       (SIOCDEVPRIVATE+5)
#define  IEEE80211_IOCTL_STA_INFO        (SIOCDEVPRIVATE+6)
#define VAP_TABLE 0
#define STA_TABLE 1

/****************************************************************************
*                            Private Variables                              *
****************************************************************************/
static unsigned long rf_lastLoad = 0;		// ET in secs at last table load
static unsigned long vap_lastLoad = 0;		// ET in secs at last table load
static unsigned long sta_lastLoad = 0;		// ET in secs at last table load
static unsigned long wds_lastLoad = 0;		// ET in secs at last table load
static unsigned long acl_lastLoad = 0;		// ET in secs at last table load
static unsigned long acl_conf_lastLoad = 0;	// ET in secs at last write setting 
static unsigned long acl_mac_lastLoad = 0;	// ET in secs at last write setting 
static unsigned long acl_status_lastLoad = 0;	// ET in secs at last write setting 
static struct avNode *lastNode, *newNode, *np;
char retval[MAX_VALUE_LEN];
long return_ipval;
long return_int;
extern char* config_rom;
extern char* config_ram;
extern char* current_config;
int  num_interface=0;			//record the number of interface 
static int  mapping_index[100];		//mapping each interface to a unique index in this array
static char interface[100][IFNAMSIZ]; //record all interface name in /proc/net/dev
int reinit_cipcfg=0;	//flag to decide doing init_cipcfg();

CIPCFG *cipcfg = NULL;	//cipcfg to current_config
/****************************************************************************
*                            Private Funtions                               *
****************************************************************************/
void if_init();	    //fill all interface in interface array
void rf_loadData();
void vap_loadData(int);
void wds_loadData();
void acl_loadData();
static void initRfStructs();
static void loadRfStructs (  char * );
static void initVapStructs();
static void loadVapStructs( int, char * );
static void initWdsStructs();
static void loadWdsStructs(  char * );
static int loadStStructs( int , char * ,int);
static void loadAclStructs(char *);
void chd_handler(int signum, siginfo_t *info, void *context);
void a300_conf_init_handler(int signum, siginfo_t *info, void *context);
CIPCFG * get_cipcfg();

// Linked List Functions
static void addList ( char *, char *, int );
static void initLists();                    // initialize all the linked lists
static void flushLists();                   // flush all the linked lists
static void flushList ( char * );           // flush a single linked list

// utility Functions
static int  openSocket ( void );
static char *htob ( char * );
static int  hasChanged ( char *, int );
int checkMacAddress(char *,int); 
void cipcfgIfName(char *, char * ,int);
void enabled_vap(char * ,char *);
int search_mac_in_vap(char *,char *);

/*
 * foripnetAccessPointMIB_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             foripnetAccessPointMIB_variables_oid[] = { 1, 3, 6, 1, 4, 1, 31932 };


struct variable7 foripnetAccessPointMIB_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */
#define FORIPNETCPUFREQUENCY		1
    {FORIPNETCPUFREQUENCY, ASN_OCTET_STR, RONLY, var_foripnetAccessPointMIB, 3,
     {2, 1, 1}},
#define FORIPNETRAMSIZE			2
    {FORIPNETRAMSIZE, ASN_OCTET_STR, RONLY, var_foripnetAccessPointMIB, 3, {2, 1, 2}},
#define FORIPNETFLASHSIZE		3
    {FORIPNETFLASHSIZE, ASN_OCTET_STR, RONLY, var_foripnetAccessPointMIB, 3, {2, 1, 3}},
#define FORIPNETVERSIONDESCRIPTION	4
    {FORIPNETVERSIONDESCRIPTION, ASN_OCTET_STR, RONLY, var_foripnetAccessPointMIB, 3,
     {2, 1, 4}},
#define FORIPNETBUILDNUMBER		5
    {FORIPNETBUILDNUMBER    , ASN_OCTET_STR, RONLY, var_foripnetAccessPointMIB, 3,
     {2, 1, 5}},
#define FORIPNETCOUNTRYCODE		6
    {FORIPNETCOUNTRYCODE, ASN_OCTET_STR, RONLY, var_foripnetAccessPointMIB, 3,
     {2, 1, 6}},
#define FORIPNETMAXRFCARD		7	
    {FORIPNETMAXRFCARD, ASN_INTEGER, RONLY, var_foripnetAccessPointMIB, 3,
     {2, 1, 7}},
#define FORIPNETMAXVAP			8	
    {FORIPNETMAXVAP, ASN_INTEGER, RONLY, var_foripnetAccessPointMIB, 3,
     {2, 1, 8}},
#define FORIPNETOPERATIONMODE		9 
    {FORIPNETOPERATIONMODE, ASN_OCTET_STR, RONLY, var_foripnetAccessPointMIB, 3,
     {2, 1, 9}},
#define FORIPNETTYPEOFIPCONFIG		10	
    {FORIPNETTYPEOFIPCONFIG, ASN_OCTET_STR, RONLY, var_foripnetAccessPointMIB, 4,
     {2, 1, 10, 1}},
#define FORIPNETMACOFDEV		11	
    {FORIPNETMACOFDEV, ASN_OCTET_STR, RONLY, var_foripnetAccessPointMIB, 4, {2, 1, 10, 2}},
#define FORIPNETIPOFDEV			12
    {FORIPNETIPOFDEV, ASN_IPADDRESS, RONLY, var_foripnetAccessPointMIB, 4, {2, 1, 10, 3}},
#define FORIPNETNETMASKOFDEV		13	
    {FORIPNETNETMASKOFDEV, ASN_IPADDRESS, RONLY, var_foripnetAccessPointMIB, 4,
     {2, 1, 10, 4}},
#define FORIPNETGATEWAYOFDEV		14
    {FORIPNETGATEWAYOFDEV, ASN_IPADDRESS, RONLY, var_foripnetAccessPointMIB, 4,
     {2, 1, 10, 5}},
#define FORIPNETSTPCONFIG		15
    {FORIPNETSTPCONFIG, ASN_INTEGER, RONLY, var_foripnetAccessPointMIB, 4, {2, 1, 10, 6}},
#define FORIPNETAPWEBADMINNAME		16
    {FORIPNETAPWEBADMINNAME, ASN_OCTET_STR, RONLY, var_foripnetAccessPointMIB, 3,
     {2, 4, 1}},
#define FORIPNETAPWEBADMINPASSWORD	17
    {FORIPNETAPWEBADMINPASSWORD, ASN_OCTET_STR, RONLY, var_foripnetAccessPointMIB, 3,
     {2, 4, 2}},
#define FORIPNETAPREBOOT		18
    {FORIPNETAPREBOOT, ASN_INTEGER, RWRITE, var_foripnetAccessPointMIB, 3, {2, 4, 3}},

#define FORIPNETONLINENUM		19
    {FORIPNETONLINENUM   , ASN_INTEGER, RONLY, var_foripnetAccessPointMIB, 3,
     {2, 5, 1}},
#define FORIPNETKICKOUTSTATION		20	
    {FORIPNETKICKOUTSTATION, ASN_OCTET_STR, RWRITE, var_foripnetAccessPointMIB, 3,
     {2, 5, 3}},
//rf card information
#define FORIPNETRFINDEX			21
    {FORIPNETRFINDEX, ASN_INTEGER, RONLY, var_foripnetApGeneralTable, 5,
     {2,2, 1, 1, 1}},
#define FORIPNETRFMAC			70
    {FORIPNETRFMAC, ASN_OCTET_STR, RONLY, var_foripnetApGeneralTable, 5,
     {2,2, 1, 1, 2}},
#define FORIPNETWIRELESSMODE		22
    {FORIPNETWIRELESSMODE, ASN_OCTET_STR, RONLY,
     var_foripnetApGeneralTable, 5, {2, 2, 1, 1, 3}},
#define FORIPNETWIRELESSBAND		23	
    {FORIPNETWIRELESSBAND, ASN_INTEGER, RONLY, var_foripnetApGeneralTable,
     5, {2, 2, 1, 1, 4}},
#define FORIPNETAUTOCHANNEL		24
    {FORIPNETAUTOCHANNEL, ASN_INTEGER, RONLY, var_foripnetApGeneralTable,
     5, {2, 2, 1, 1, 5}},
#define FORIPNETAUTOTRANSMITRATE	25	
    {FORIPNETAUTOTRANSMITRATE, ASN_OCTET_STR, RONLY,
     var_foripnetApGeneralTable, 5, {2, 2, 1, 1, 6}},
#define FORIPNETMAXTRANSMITRATE		26
    {FORIPNETMAXTRANSMITRATE, ASN_OCTET_STR, RONLY,
     var_foripnetApGeneralTable, 5, {2, 2, 1, 1, 7}},
#define FORIPNETTXPOWER			27
    {FORIPNETTXPOWER, ASN_OCTET_STR, RONLY, var_foripnetApGeneralTable, 5,
     {2,2, 1, 1, 8}},
#define FORIPNETBSSIDNUMBER		28
    {FORIPNETBSSIDNUMBER, ASN_INTEGER, RONLY, var_foripnetApGeneralTable,
     5, {2, 2, 1, 1, 9}},

#define FORIPNETRFSTAS			29
    {FORIPNETRFSTAS, ASN_INTEGER, RONLY, var_foripnetApGeneralTable,
     5, {2, 2, 1, 1, 10}},

//Vap config table
#define FORIPNETVAPIFINDEX		30
    {FORIPNETVAPIFINDEX, ASN_INTEGER, RONLY, var_foripnetVapConfigTable, 5,
     {2, 2, 2, 1, 1}},
#define FORIPNETVAPIFDESCR		31
    {FORIPNETVAPIFDESCR, ASN_OCTET_STR, RONLY, var_foripnetVapConfigTable,
     5, {2, 2, 2, 1, 2}},
#define FORIPNETVAPESSID		32
    {FORIPNETVAPESSID, ASN_OCTET_STR, RONLY, var_foripnetVapConfigTable, 5,
     {2, 2, 2, 1, 3}},
#define FORIPNETVAPVID			33
    {FORIPNETVAPVID, ASN_INTEGER, RONLY, var_foripnetVapConfigTable, 5,
     {2, 2, 2, 1, 4}},
#define FORIPNETVAPSTAS			34
    {FORIPNETVAPSTAS, ASN_INTEGER, RONLY, var_foripnetVapConfigTable, 5,
     {2, 2, 2, 1, 5}},
#define FORIPNETVAPTUNMODE		72
    {FORIPNETVAPTUNMODE, ASN_INTEGER, RONLY, var_foripnetVapConfigTable, 5,
     {2, 2, 2, 1, 6}},

//Vap security table
#define FORIPNETSECVAPINDEX		35
    {FORIPNETSECVAPINDEX, ASN_INTEGER, RONLY, var_foripnetApSecTable, 5,
     {2, 2, 3, 1, 1}},
#define FORIPNETSECTYPE			36
    {FORIPNETSECTYPE, ASN_OCTET_STR, RONLY, var_foripnetApSecTable, 5,
     {2, 2, 3, 1, 2}},
#define FORIPNETSECMODE			37
    {FORIPNETSECMODE, ASN_OCTET_STR, RONLY, var_foripnetApSecTable, 5,
     {2, 2, 3, 1, 3}},
#define FORIPNETEAPCONF			38
    {FORIPNETEAPCONF, ASN_INTEGER, RONLY, var_foripnetApSecTable, 5,
     {2, 2, 3, 1, 4}},
#define FORIPNETENCCONF			39
    {FORIPNETENCCONF, ASN_OCTET_STR, RONLY, var_foripnetApSecTable, 5,
     {2, 2, 3, 1, 5}},
//Vap advance table
#define FORIPNETAPADVIFINDEX		40
    {FORIPNETAPADVIFINDEX, ASN_INTEGER, RONLY, var_foripnetApAdvTable, 5,
     {2, 2, 4, 1, 1}},
#define FORIPNETHIDDENSSID		41
    {FORIPNETHIDDENSSID, ASN_INTEGER, RONLY, var_foripnetApAdvTable, 5,
     {2, 2, 4, 1, 2}},
#define FORIPNETSTISOLATION		42
    {FORIPNETSTISOLATION, ASN_INTEGER, RONLY, var_foripnetApAdvTable, 5,
     {2, 2, 4, 1, 3}},
#define FORIPNETWMM			43
    {FORIPNETWMM, ASN_INTEGER, RONLY, var_foripnetApAdvTable, 5,
     {2, 2, 4, 1, 4}},
//Vap ACL conf table
#define FORIPNETAPACCESSCONTROLINDEX	44
    {FORIPNETAPACCESSCONTROLINDEX, ASN_INTEGER, RONLY,
     var_foripnetApAccessControlTable, 5, {2, 2, 5, 1 ,1}},
#define FORIPNETAPACCESSCONTROLCONF	45
    {FORIPNETAPACCESSCONTROLCONF, ASN_INTEGER, RWRITE,
     var_foripnetApAccessControlTable, 5, {2, 2, 5, 1 ,2}},
//Vap ACL list table
#define FORIPNETAPMACACLINDEX		46
    {FORIPNETAPMACACLINDEX, ASN_INTEGER, RONLY,
     var_foripnetApAccessControlListTable, 5, {2, 2, 6, 1, 1}},
#define FORIPNETAPMACACLSTATUS		47
    {FORIPNETAPMACACLSTATUS, ASN_INTEGER, RWRITE,
     var_foripnetApAccessControlListTable, 5, {2, 2, 6, 1, 2}},
#define FORIPNETAPMACACLADDR		48
    {FORIPNETAPMACACLADDR, ASN_OCTET_STR, RWRITE,
     var_foripnetApAccessControlListTable, 5, {2, 2, 6, 1, 3}},
// WDS table
#define FORIPNETWDSINDEX		71
    {FORIPNETWDSINDEX,  ASN_INTEGER, RONLY ,  var_foripnetWdsStTable, 5,  { 2,3,1, 1, 1 }},
#define FORIPNETLINKINDEX		49
    {FORIPNETLINKINDEX,  ASN_INTEGER, RONLY ,  var_foripnetWdsStTable, 5,  { 2,3,1, 1, 2 }},
#define FORIPNETSTATUS			50
    {FORIPNETSTATUS,  ASN_OCTET_STR, RONLY ,  var_foripnetWdsStTable, 5,  { 2,3,1, 1, 3 }},
#define FORIPNETMAC			51
    {FORIPNETMAC,  ASN_OCTET_STR, RONLY ,  var_foripnetWdsStTable, 5,  { 2,3,1, 1, 4 }},
#define FORIPNETWDSSNR			52
    {FORIPNETWDSSNR,  ASN_INTEGER, RONLY ,  var_foripnetWdsStTable, 5,  { 2,3,1, 1, 5 }},
#define FORIPNETTXRATE			53
    {FORIPNETTXRATE,  ASN_OCTET_STR, RONLY ,  var_foripnetWdsStTable, 5,  { 2,3,1, 1, 6 }},
#define FORIPNETTXCNT			54
    {FORIPNETTXCNT,  ASN_INTEGER, RONLY ,  var_foripnetWdsStTable, 5,  { 2,3,1, 1, 7 }},
#define FORIPNETTXERR			55
    {FORIPNETTXERR,  ASN_INTEGER, RONLY ,  var_foripnetWdsStTable, 5,  { 2,3,1, 1, 8 }},

#define FORIPNETWDSSEC			56
    {FORIPNETWDSSEC,  ASN_OCTET_STR,  RONLY ,  var_foripnetWdsStTable, 5,  { 2,3,1, 1, 9 }},
//Station information table
#define FORIPNETSTINDEX			57
    {FORIPNETSTINDEX, ASN_INTEGER, RONLY, var_foripnetStStatTable, 5,
     {2, 5, 2, 1, 1}},
#define FORIPNETSTSTATMAC		58
    {FORIPNETSTSTATMAC, ASN_OCTET_STR, RONLY, var_foripnetStStatTable, 5,
     {2, 5, 2, 1, 2}},
#define FORIPNETSTSTATVAP		59
    {FORIPNETSTSTATVAP, ASN_INTEGER, RONLY, var_foripnetStStatTable, 5,
     {2, 5, 2, 1, 3}},
#define FORIPNETSTSNR			60
    {FORIPNETSTSNR, ASN_COUNTER, RONLY, var_foripnetStStatTable, 5,
     {2, 5, 2, 1, 4}},
#define FORIPNETPKSOFSTATX		61
    {FORIPNETPKSOFSTATX, ASN_COUNTER, RONLY, var_foripnetStStatTable, 5,
     {2, 5, 2, 1, 5}},
#define FORIPNETPKSOFSTARX		62
    {FORIPNETPKSOFSTARX, ASN_COUNTER, RONLY, var_foripnetStStatTable, 5,
     {2, 5, 2, 1, 6}},
#define FORIPNETBYTESOFSTATX		63
    {FORIPNETBYTESOFSTATX, ASN_COUNTER, RONLY, var_foripnetStStatTable, 5,
     {2, 5, 2, 1, 7}},
#define FORIPNETBYTESOFSTARX		64
    {FORIPNETBYTESOFSTARX, ASN_COUNTER, RONLY, var_foripnetStStatTable, 5,
     {2, 5, 2, 1, 8}},
#define FORIPNETOKPKSOFSTARX		65
    {FORIPNETOKPKSOFSTARX, ASN_COUNTER, RONLY, var_foripnetStStatTable, 5,
     {2, 5, 2, 1, 9}},
#define FORIPNETERRPKSOFSTARX		66
    {FORIPNETERRPKSOFSTARX, ASN_COUNTER, RONLY, var_foripnetStStatTable, 5,
     {2, 5, 2, 1, 10}},
#define FORIPNETOKPKSOFSTATX		67
    {FORIPNETOKPKSOFSTATX, ASN_COUNTER, RONLY, var_foripnetStStatTable, 5,
     {2, 5, 2, 1, 11}},
#define FORIPNETERRPKSOFSTATX		68
    {FORIPNETERRPKSOFSTATX, ASN_COUNTER, RONLY, var_foripnetStStatTable, 5,
     {2, 5, 2, 1, 12}},
#define FORIPNETSTIDLETIME		69
    {FORIPNETSTIDLETIME	, ASN_INTEGER, RONLY, var_foripnetStStatTable, 5,
     {2, 5, 2, 1, 13}},
};

/*
 * (L = length of the oidsuffix) 
 */


/** Initializes the foripnetAccessPointMIB module */
void
init_a300(void)
{

    struct sigaction sig;
    DEBUGMSGTL(("a300", "Initializing\n"));
    int   enterpriseid = NETSNMP_ENTERPRISE_OID;
    foripnetAccessPointMIB_variables_oid[6]=enterpriseid;
    //printf("init a300 module,enterpriseid:%d\n",enterpriseid);
    REGISTER_MIB("a300", foripnetAccessPointMIB_variables, variable7,
                 foripnetAccessPointMIB_variables_oid);
    
    initLists();
    cipcfg = init_cipcfg_f(current_config);
    /* 
     * Add SIGUSR2 signal handler
     * SIGUSR2 is received while webs applying some settings
     */
    sig.sa_sigaction = a300_conf_init_handler;
    sig.sa_flags |= SA_SIGINFO;
    sigaction(SIGUSR2, &sig, NULL);

}
/* 
 *if_init() - load all interface name from PROC_NET_DEV to interface variable
 */
void if_init(){
    int skfd;
    FILE *fp;
    char bfr[1024],ifName[1024];
    char *s,*t;
    int i =0;
    skfd = openSocket();                            // open socket
    if ( skfd < 0 ) {
	syslog ( LOG_ERR, "SNMP if_init() - %s\n", "socket open failure" );
	return;
    }

    fp = fopen ( PROC_NET_DEV, "r" );
    if ( fp ) {
	while ( fgets ( bfr, sizeof ( bfr ), fp )) {
	    if ( strstr ( bfr, ":" )) {
		s = bfr; t = ifName;
		while ( isspace ( *s ))                     // discard white space
		    *s++;
		while ( *s != ':' )                         // get interface name
		    *t++ = *s++;
		*t = '\0';
		strcpy(interface[i],ifName);
		mapping_index[i] = netsnmp_arch_interface_index_find(ifName); //get the index of the ifName
		i++;
	    }
	}
	fclose ( fp );
    }
    num_interface = i;	//num_interface record the number of interface
    /*
    for(i=0 ; i< num_interface ;i++)
	printf("interface:%s\n",interface[i]);
    */
    close ( skfd );
}

/****************************************************************************
*                                                                           *
*    shutdown_a300() - perform any required cleanup @ shutdown              *
*                                                                           *
****************************************************************************/
void shutdown_a300( void ) {
          flushLists();
	  close_cipcfg(cipcfg);
}

#if 0
    struct variable {
        u_char          magic;  /* passed to function as a hint */
        char            type;   /* type of variable */
        /*
         * See important comment in snmp_vars.c relating to acl
         */
        u_short         acl;    /* access control list for variable */
        FindVarMethod  *findVar;        /* function that finds variable */
        u_char          namelen;        /* length of above */
        oid             name[MAX_OID_LEN];      /* object identifier of variable */
    };
#endif
unsigned char  *
var_foripnetAccessPointMIB(struct variable *vp,
             oid * name,
             size_t *length,
             int exact, size_t *var_len, WriteMethod ** write_method)
{
    struct in_addr ipval;
    char key[MAX_VALUE_LEN], group_name[4];
    static char MACWork[17];
    memset(key ,0 ,MAX_VALUE_LEN);
    memset(retval,0 ,MAX_VALUE_LEN);
    int ret=-1,i,j;
    CIPCFG *lcipcfg = NULL;
    lcipcfg = get_cipcfg();
    
    
    if (header_generic(vp, name, length, exact, var_len, write_method)
        == MATCH_FAILED)
        return NULL;

    switch (vp->magic) {
    case FORIPNETCPUFREQUENCY:
	strcpy(key,"CPU");
	ret=get_product_info( key , retval);
	if (ret != CIPCFG_SUCCESS) {
	    retval[0]='\0';
	    *var_len = 0;
	}
	else
	    *var_len = strlen(retval);
        return (u_char *) & retval;

    case FORIPNETRAMSIZE:
	strcpy(key,"MEM");
	ret=get_product_info( key , retval);
	if (ret != CIPCFG_SUCCESS) {
	    retval[0]='\0';
	    *var_len = 0;
	}
	else
	    *var_len = strlen(retval);
        return (u_char *) & retval;

    case FORIPNETFLASHSIZE:
	strcpy(key,"FLASH");
	ret=get_product_info( key , retval);
	if (ret != CIPCFG_SUCCESS) {
	    retval[0]='\0';
	    *var_len = 0;
	}
	else
	    *var_len = strlen(retval);
        return (u_char *) & retval;

    case FORIPNETVERSIONDESCRIPTION:
	ret = get_sys_item("sw_ver", retval);
	printf("Get firmware version:%s from CIPCFG.\n",retval);
	if (ret != CIPCFG_SUCCESS) {
	    retval[0]='\0';
	    *var_len = 0;
	}
	else
	    *var_len = strlen(retval);
        return (u_char *) & retval;

    case FORIPNETBUILDNUMBER:
	ret = get_sys_item("build", retval);
	printf("Get build number:%s from CIPCFG.\n",retval);
	if (ret != CIPCFG_SUCCESS) {
	    retval[0]='\0';
	    *var_len = 0;
	}
	else
	    *var_len = strlen(retval);
        return (u_char *) & retval;

    case FORIPNETCOUNTRYCODE:
	printf("Get country from CIPCFG.\n");
	if(lcipcfg != NULL)
	    ret=get_cfg_item_by_str(lcipcfg, "rf1", "country", retval);

	if(ret<0)
	    *var_len = 0;
	else
	    *var_len = strlen(retval);
        return (u_char *) & retval;


    case FORIPNETMAXRFCARD:
	printf("Get MAX RF cards.\n");
	return_ipval = MAX_RF;
	*var_len = sizeof(long);
        return (u_char *) & return_ipval;

    case FORIPNETMAXVAP:
	printf("Get MAX VAPs.\n");
	return_ipval = MAX_VAP;
	*var_len = sizeof(long);
        return (u_char *) & return_ipval;

    case FORIPNETOPERATIONMODE:
	if(lcipcfg != NULL)
	    ret=get_cfg_item_by_str(lcipcfg, "opmode", "type", retval);
        if(ret<0)
            *var_len = 0;
        else
            *var_len = strlen(retval);
	return (u_char *) & retval;

    case FORIPNETTYPEOFIPCONFIG:
	printf("Get ip type from CIPCFG.\n");
	if(lcipcfg != NULL)
	    ret=get_cfg_item_by_str(lcipcfg, "wan_ip", "type", retval);
	if(ret<0)
	    *var_len = 0;
	else
	    *var_len = strlen(retval);
	    return (u_char *) & retval;

    case FORIPNETMACOFDEV:
	ret = get_sys_item("wan_mac", retval);
	printf("Get ip address:%s from CIPCFG.\n",retval);
	if (ret != CIPCFG_SUCCESS)
	    *var_len =0;
	else if(strlen(retval) > 0){
	    checkMacAddress(retval,0);
	    MACWork[ 0] = retval[ 0];
	    MACWork[ 1] = retval[ 1];
	    MACWork[ 2] = retval[ 3];
	    MACWork[ 3] = retval[ 4];
	    MACWork[ 4] = retval[ 6];
	    MACWork[ 5] = retval[ 7];
	    MACWork[ 6] = retval[ 9];
	    MACWork[ 7] = retval[10];
	    MACWork[ 8] = retval[12];
	    MACWork[ 9] = retval[13];
	    MACWork[10] = retval[15];
	    MACWork[11] = retval[16];
	    MACWork[12] = '\0';
	    *var_len = 6;
	}
	return ( u_char * ) htob ( MACWork );

    case FORIPNETIPOFDEV:
	ret = get_sys_item("wan_ip", retval);
	printf("Get ip address:%s from CIPCFG.\n",retval);
	if (ret != CIPCFG_SUCCESS)
	    *var_len =0;
	else {
	    inet_aton(retval,&ipval);       //converts the numbers-and-dots notation into binary data
	    return_ipval = ipval.s_addr;
	    *var_len = sizeof(long);
	}
        return (u_char *) & return_ipval;

    case FORIPNETNETMASKOFDEV:
	ret = get_sys_item("wan_mask", retval);
	printf("Get netmask:%s from CIPCFG.\n",retval);
	if (ret != CIPCFG_SUCCESS)
	    *var_len =0;
	else {
	    inet_aton(retval,&ipval);       //converts the numbers-and-dots notation into binary data
	    return_ipval = ipval.s_addr;
	    *var_len = sizeof(long);
	}
        return (u_char *) & return_ipval;

    case FORIPNETGATEWAYOFDEV:
	ret = get_sys_item("default_gw", retval);
	printf("Get gateway:%s from CIPCFG.\n",retval);
	if (ret != CIPCFG_SUCCESS)
	    *var_len =0;
	else {
	    inet_aton(retval,&ipval);       //converts the numbers-and-dots notation into binary data
	    return_ipval = ipval.s_addr;
	    *var_len = sizeof(long);
	}
        return (u_char *) & return_ipval;

    case FORIPNETSTPCONFIG:
	printf("Get stp from CIPCFG.\n");
	if(lcipcfg != NULL)
	    ret=get_cfg_item_by_str(lcipcfg, "network_L2", "stp", retval);
	if(ret<0)
	    *var_len = 0;
	else {
	    if(strcmp(retval,"enable")==0)
		return_int =1;
	    else
		return_int =0;
	    *var_len = sizeof(long);
	}
	return (u_char *) & return_int;

    case FORIPNETAPWEBADMINNAME:
	printf("Get admin name from CIPCFG.\n");
	if(lcipcfg != NULL)
	    ret=get_cfg_item_by_str(lcipcfg, "admin", "name", retval);
	*var_len = strlen(retval);
        return (u_char *) & retval;

    case FORIPNETAPWEBADMINPASSWORD:
	return NULL;
#if 0
	printf("Get admin password from CIPCFG.\n");
	if(lcipcfg != NULL)
	    ret=get_cfg_item_by_str(lcipcfg, "admin", "password", retval);
	if(ret<0)
	    *var_len = 0;
	else
	    *var_len = strlen(retval);
        return (u_char *) & retval;
#endif

    case FORIPNETAPREBOOT:
        *write_method = write_foripnetApReboot;
	return_int =0;
	*var_len = sizeof(long);
        return (u_char *) & return_int;

    case FORIPNETONLINENUM:
	return_int =0;
	for(i = 0 ; i < MAX_RF ; i ++) {
	    for(j = 0 ; j < MAX_VAP ; j++) {
		sprintf(key ,"%s%d%s%d%s","rf",i+1,"_vap",j+1,"_sta");
		ret=get_sys_item(key,retval);
		if (ret == CIPCFG_SUCCESS)
		    return_int += atoi(retval);
	    }
	}
	*var_len = sizeof(long);
	return (u_char *) & return_int;

    case FORIPNETKICKOUTSTATION:
        *write_method = write_foripnetkickOutStation;
	strcpy(MACWork ,"FFFFFFFFFFFF");
	MACWork[12] = '\0';
	*var_len = 6;
	return ( u_char * ) htob ( MACWork );

    default:
        ERROR_MSG("");
    }
    return NULL;
}

/*
 * var_foripnetApGeneralTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_foripnetAccessPointMIB above.
 */
unsigned char  *
var_foripnetApGeneralTable(struct variable *vp,
                           oid * name,
                           size_t *length,
                           int exact,
                           size_t *var_len, WriteMethod ** write_method)
{
    oid      rName [MAX_OID_LEN];
    int found = FALSE;
    static char MACWork[17];


    rf_loadData();
    memcpy (( char * ) rName, ( char * ) vp->name, ( int ) vp->namelen * sizeof ( oid ));
    for ( np = LIST_FIRST ( &agList ); np != NULL; np = LIST_NEXT ( np, nodes )) {
	ag = ( struct agTbl_data * ) np->data;
	printf("ag->rfIndex:%d ,exact:%d\n",ag->rfIndex,exact);
	rName[vp->namelen] = ag->rfIndex;
	if ((  exact && ( snmp_oid_compare ( rName, vp->namelen + 1, name, *length ) == 0 )) ||
       	    ( !exact && ( snmp_oid_compare ( rName, vp->namelen + 1, name, *length ) >  0 ))) {

	    switch ( vp->magic ) {      // found requested OID, now check for requested variable
		case FORIPNETRFINDEX:
		    if( ag->haveRfIndex) found = TRUE ; break;
		case FORIPNETRFMAC:
		    if( ag->haveMac) found = TRUE ; break;
		case FORIPNETWIRELESSMODE:
		    if( ag->haveWirelessMode) found = TRUE ; break;
		case FORIPNETWIRELESSBAND:
		    if( ag->haveWirelessBand) found = TRUE ; break;
		case FORIPNETAUTOCHANNEL:
		    if( ag->haveAutoChannel) found = TRUE ; break;
		case FORIPNETAUTOTRANSMITRATE:
		    if( ag->haveAutoTransRate) found = TRUE ; break;
		case FORIPNETMAXTRANSMITRATE:
		    if( ag->haveMaxTransRate) found = TRUE ; break;
		case FORIPNETTXPOWER:
		    if( ag->haveTxPower) found = TRUE ; break;
		case FORIPNETBSSIDNUMBER:
		    if( ag->haveBssidNumber) found = TRUE ; break;
		case FORIPNETRFSTAS:
		    if( ag->haveRfSta) found = TRUE ; break;
	    }
	}
	if (found)
	    break;
    }
    if(!found)
	return NULL;

    memcpy (( char * ) name, ( char * ) rName, ( vp->namelen + 1 ) * sizeof ( oid ));
    *length = vp->namelen + 1;
    *var_len = sizeof ( long );
    *write_method = NULL;

    switch (vp->magic) {
    case FORIPNETRFINDEX:
        return (u_char *) & ag->rfIndex;
    case FORIPNETRFMAC:
	if(strlen(ag->mac) > 0) {
	    MACWork[ 0] = ag->mac[ 0];
	    MACWork[ 1] = ag->mac[ 1];
	    MACWork[ 2] = ag->mac[ 3];
	    MACWork[ 3] = ag->mac[ 4];
	    MACWork[ 4] = ag->mac[ 6];
	    MACWork[ 5] = ag->mac[ 7];
	    MACWork[ 6] = ag->mac[ 9];
	    MACWork[ 7] = ag->mac[10];
	    MACWork[ 8] = ag->mac[12];
	    MACWork[ 9] = ag->mac[13];
	    MACWork[10] = ag->mac[15];
	    MACWork[11] = ag->mac[16];
	    MACWork[12] = '\0';
	    *var_len = 6;
	}
	else if(strlen(cl->mac) == 0)
	    *var_len= 0;
	return (u_char *)  htob(MACWork);
    case FORIPNETWIRELESSMODE:
	*var_len=strlen(ag->wirelessMode);
        return (u_char *) & ag->wirelessMode;
    case FORIPNETWIRELESSBAND:
        return (u_char *) & ag->wirelessBand;
    case FORIPNETAUTOCHANNEL:
        return (u_char *) & ag->autoChannel;
    case FORIPNETAUTOTRANSMITRATE:
	*var_len=strlen(ag->autoTransRate);
        return (u_char *) & ag->autoTransRate;
    case FORIPNETMAXTRANSMITRATE:
	*var_len=strlen(ag->maxTransRate);
        return (u_char *) & ag->maxTransRate;
    case FORIPNETTXPOWER:
	*var_len=strlen(ag->txPower);
        return (u_char *) & ag->txPower;
    case FORIPNETBSSIDNUMBER:
        return (u_char *) & ag->bssidNumber;
    case FORIPNETRFSTAS:
        return (u_char *) & ag->rfSta;
    default:
        ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_foripnetVapConfigTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_foripnetAccessPointMIB above.
 */
unsigned char  *
var_foripnetVapConfigTable(struct variable *vp,
                           oid * name,
                           size_t *length,
                           int exact,
                           size_t *var_len, WriteMethod ** write_method)
{
    oid      rName [MAX_OID_LEN];
    int found = FALSE;

    vap_loadData(VAP_TABLE);
    memcpy (( char * ) rName, ( char * ) vp->name, ( int ) vp->namelen * sizeof ( oid ));
    for ( np = LIST_FIRST ( &vcList ); np != NULL; np = LIST_NEXT ( np, nodes )) {
	vc = ( struct vcTbl_data * ) np->data;
	//printf("vc->ifIndex:%d ,exact:%d\n",vc->ifIndex,exact);
	rName[vp->namelen] = vc->ifIndex;
	if ((  exact && ( snmp_oid_compare ( rName, vp->namelen + 1, name, *length ) == 0 )) ||
       	    ( !exact && ( snmp_oid_compare ( rName, vp->namelen + 1, name, *length ) >  0 ))) {

	    switch ( vp->magic ) {      // found requested OID, now check for requested variable
		case FORIPNETVAPIFINDEX:
		    if( vc->haveVapIfIndex) found = TRUE ; break;
		case FORIPNETVAPIFDESCR:
		    if( vc->haveVapIfDescr) found = TRUE ; break;
		case FORIPNETVAPESSID:
		    if( vc->haveVapIfEssid) found = TRUE ; break;
		case FORIPNETVAPVID:
		    if( vc->haveVapVid) found = TRUE ; break;
		case FORIPNETVAPSTAS:
		    if( vc->haveVapSta) found = TRUE ; break;
		case FORIPNETVAPTUNMODE:
		    if( vc->haveVapTunMode) found = TRUE ; break;
	    }
	}
	if (found)
	    break;
    }
    if(!found)
	return NULL;

    memcpy (( char * ) name, ( char * ) rName, ( vp->namelen + 1 ) * sizeof ( oid ));
    *length = vp->namelen + 1;
    *var_len = sizeof ( long );
    *write_method = NULL;

    switch (vp->magic) {
    case FORIPNETVAPIFINDEX:
        return (u_char *) & vc->ifIndex;
    case FORIPNETVAPIFDESCR:
	*var_len=strlen(vc->vapIfDescr);
        return (u_char *) & vc->vapIfDescr;
    case FORIPNETVAPESSID:
	*var_len=strlen(vc->vapIfEssid);
        return (u_char *) & vc->vapIfEssid;
    case FORIPNETVAPVID:
        return (u_char *) & vc->vapVid;
    case FORIPNETVAPSTAS:
        return (u_char *) & vc->vapSta;
    case FORIPNETVAPTUNMODE:
        return (u_char *) & vc->vapTunMode;
    default:
        ERROR_MSG("");
    }
    return NULL;
}

/*
 * var_foripnetApSecTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_foripnetAccessPointMIB above.
 */
unsigned char  *
var_foripnetApSecTable(struct variable *vp,
                       oid * name,
                       size_t *length,
                       int exact,
                       size_t *var_len, WriteMethod ** write_method)
{
    oid      rName [MAX_OID_LEN];
    int found = FALSE;

    vap_loadData(VAP_TABLE);
    memcpy (( char * ) rName, ( char * ) vp->name, ( int ) vp->namelen * sizeof ( oid ));
    for ( np = LIST_FIRST ( &asList ); np != NULL; np = LIST_NEXT ( np, nodes )) {
	as = ( struct asTbl_data * ) np->data;
	//printf("as->ifIndex:%d ,exact:%d\n",as->ifIndex,exact);
	rName[vp->namelen] = as->ifIndex;
	if ((  exact && ( snmp_oid_compare ( rName, vp->namelen + 1, name, *length ) == 0 )) ||
       	    ( !exact && ( snmp_oid_compare ( rName, vp->namelen + 1, name, *length ) >  0 ))) {

	    switch ( vp->magic ) {      // found requested OID, now check for requested variable
		case FORIPNETSECVAPINDEX:
		    if( as->haveVapIfIndex) found = TRUE ; break;
		case FORIPNETSECTYPE:
		    if( as->haveSecType) found = TRUE ; break;
		case FORIPNETSECMODE:
		    if( as->haveSecMode) found = TRUE ; break;
		case FORIPNETEAPCONF:
		    if( as->haveEapConf) found = TRUE ; break;
		case FORIPNETENCCONF:
		    if( as->haveEncConf) found = TRUE ; break;
	    }
	}
	if (found)
	    break;
    }
    if(!found)
	return NULL;

    memcpy (( char * ) name, ( char * ) rName, ( vp->namelen + 1 ) * sizeof ( oid ));
    *length = vp->namelen + 1;
    *var_len = sizeof ( long );
    *write_method = NULL;
    switch (vp->magic) {
    case FORIPNETSECVAPINDEX:
        return (u_char *) & as->ifIndex;
    case FORIPNETSECTYPE:
	*var_len = strlen(as->secType);
        return (u_char *) & as->secType;
    case FORIPNETSECMODE:
	*var_len = strlen(as->secMode);
        return (u_char *) & as->secMode;
    case FORIPNETEAPCONF:
        return (u_char *) & as->eapConf;
    case FORIPNETENCCONF:
	*var_len = strlen(as->encConf);
        return (u_char *) & as->encConf;
    default:
        ERROR_MSG("");
    }
    return NULL;
}

/*
 * var_foripnetApAdvTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_foripnetAccessPointMIB above.
 */
unsigned char  *
var_foripnetApAdvTable(struct variable *vp,
                       oid * name,
                       size_t *length,
                       int exact,
                       size_t *var_len, WriteMethod ** write_method)
{
    oid      rName [MAX_OID_LEN];
    int found = FALSE;

    vap_loadData(VAP_TABLE);
    memcpy (( char * ) rName, ( char * ) vp->name, ( int ) vp->namelen * sizeof ( oid ));
    for ( np = LIST_FIRST ( &adList ); np != NULL; np = LIST_NEXT ( np, nodes )) {
	ad = ( struct adTbl_data * ) np->data;
	//printf("ad->ifIndex:%d ,exact:%d\n",ad->ifIndex,exact);
	rName[vp->namelen] = ad->ifIndex;
	if ((  exact && ( snmp_oid_compare ( rName, vp->namelen + 1, name, *length ) == 0 )) ||
       	    ( !exact && ( snmp_oid_compare ( rName, vp->namelen + 1, name, *length ) >  0 ))) {

	    switch ( vp->magic ) {      // found requested OID, now check for requested variable
		case FORIPNETAPADVIFINDEX:
		    if( ad->haveVapIfIndex) found = TRUE ; break;
		case FORIPNETHIDDENSSID:
		    if( ad->haveHiddenSsid) found = TRUE ; break;
		case FORIPNETSTISOLATION:
		    if( ad->haveStIsolation) found = TRUE ; break;
		case FORIPNETWMM:
		    if( ad->haveWmm) found = TRUE ; break;
	    }
	}
	if (found)
	    break;
    }
    if(!found)
	return NULL;

    memcpy (( char * ) name, ( char * ) rName, ( vp->namelen + 1 ) * sizeof ( oid ));
    *length = vp->namelen + 1;
    *var_len = sizeof ( long );
    *write_method = NULL;
    switch (vp->magic) {
    case FORIPNETAPADVIFINDEX:
        return (u_char *) & ad->ifIndex;
    case FORIPNETHIDDENSSID:
        return (u_char *) & ad->hiddenSsid;
    case FORIPNETSTISOLATION:
        return (u_char *) & ad->stIsolation;
    case FORIPNETWMM:
        return (u_char *) & ad->wmm;
    default:
        ERROR_MSG("");
    }
    return NULL;
}

/*
 * var_foripnetApAccessControlTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_foripnet above.
 */
unsigned char  *
var_foripnetApAccessControlTable(struct variable *vp,
                                 oid * name,
                                 size_t *length,
                                 int exact,
                                 size_t *var_len,
                                 WriteMethod ** write_method)
{

    oid      rName [MAX_OID_LEN];
    int found = FALSE;

    acl_loadData();
    memcpy (( char * ) rName, ( char * ) vp->name, ( int ) vp->namelen * sizeof ( oid ));
    for ( np = LIST_FIRST ( &acList ); np != NULL; np = LIST_NEXT ( np, nodes )) {
	ac = ( struct acTbl_data * ) np->data;
	//printf("ac->index:%d ,exact:%d\n",ac->index,exact);
	rName[vp->namelen] = ac->index;
	if ((  exact && ( snmp_oid_compare ( rName, vp->namelen + 1, name, *length ) == 0 )) ||
       	    ( !exact && ( snmp_oid_compare ( rName, vp->namelen + 1, name, *length ) >  0 ))) {

	    switch ( vp->magic ) {      // found requested OID, now check for requested variable
		case FORIPNETAPACCESSCONTROLINDEX:
		    if( ac->haveAccessControlIndex) found = TRUE ; break;
		case FORIPNETAPACCESSCONTROLCONF:
		    if( ac->haveAccessControlConf) found = TRUE ; break;
	    }
	}
	if (found)
	    break;
    }
    if(!found)
	return NULL;

    memcpy (( char * ) name, ( char * ) rName, ( vp->namelen + 1 ) * sizeof ( oid ));
    *length = vp->namelen + 1;
    *var_len = sizeof ( long );
    *write_method = NULL;
    switch (vp->magic) {
    case FORIPNETAPACCESSCONTROLINDEX:
        return (u_char *) & ac->index;
    case FORIPNETAPACCESSCONTROLCONF:
        *write_method = write_foripnetApAccessControlConf;
        return (u_char *) & ac->accessControlConf;
    default:
        ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_foripnetApAccessControlListTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_foripnetAccessPointMIB above.
 */
unsigned char  *
var_foripnetApAccessControlListTable(struct variable *vp,
                                 oid * name,
                                 size_t *length,
                                 int exact,
                                 size_t *var_len,
                                 WriteMethod ** write_method)
{

    oid      rName [MAX_OID_LEN];
    int found = FALSE;
    static char MACWork[17];

    acl_loadData();

    memcpy (( char * ) rName, ( char * ) vp->name, ( int ) vp->namelen * sizeof ( oid ));
    for ( np = LIST_FIRST ( &clList ); np != NULL; np = LIST_NEXT ( np, nodes )) {
	cl = ( struct clTbl_data * ) np->data;
	//printf("cl->vapIndex:%d,cl->dataIndex:%d ,exact:%d\n",cl->vapIndex,cl->dataIndex,exact);
	rName[vp->namelen+0] = cl->vapIndex;
	rName[vp->namelen+1] = cl->dataIndex;
	
	if ((  exact && ( snmp_oid_compare ( rName, vp->namelen + 2, name, *length ) == 0 )) ||
       	    ( !exact && ( snmp_oid_compare ( rName, vp->namelen + 2, name, *length ) >  0 ))) {

	    switch ( vp->magic ) {      // found requested OID, now check for requested variable
		case FORIPNETAPMACACLINDEX:
		    if( cl->haveMacAclIndex) found = TRUE ; break;
		case FORIPNETAPMACACLSTATUS:
		    if( cl->haveMacAclStatus) found = TRUE ; break;
		case FORIPNETAPMACACLADDR:
		    if( cl->haveMac) found = TRUE ;
		     break;
	    }
	}
	if (found)
	    break;
    }
    if(!found)
	return NULL;

    memcpy (( char * ) name, ( char * ) rName, ( vp->namelen + 2 ) * sizeof ( oid ));
    *length = vp->namelen + 2;
    *var_len = sizeof ( long );
    *write_method = NULL;
    switch (vp->magic) {
    case FORIPNETAPMACACLINDEX:
        return (u_char *) & cl->macAclIndex;
    case FORIPNETAPMACACLSTATUS:
        *write_method = write_foripnetApMacAclStatus;
        return (u_char *) & cl->macAclStatus;
    case FORIPNETAPMACACLADDR:
        *write_method = write_foripnetApMacAclAddr;
	if(strlen(cl->mac) > 0) {
	    MACWork[ 0] = cl->mac[ 0];
	    MACWork[ 1] = cl->mac[ 1];
	    MACWork[ 2] = cl->mac[ 3];
	    MACWork[ 3] = cl->mac[ 4];
	    MACWork[ 4] = cl->mac[ 6];
	    MACWork[ 5] = cl->mac[ 7];
	    MACWork[ 6] = cl->mac[ 9];
	    MACWork[ 7] = cl->mac[10];
	    MACWork[ 8] = cl->mac[12];
	    MACWork[ 9] = cl->mac[13];
	    MACWork[10] = cl->mac[15];
	    MACWork[11] = cl->mac[16];
	    MACWork[12] = '\0';
	    *var_len = 6;
	}
	else if(strlen(cl->mac) == 0)
	    *var_len= 0;
	return (u_char *)  htob(MACWork);
    default:
        ERROR_MSG("");
    }
    return NULL;
}

/*
 * var_foripnetWdsStTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_foripnet above.
 */
unsigned char *
var_foripnetWdsStTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    oid      rName [MAX_OID_LEN];
    int found = FALSE;
    static char MACWork[17];

    wds_loadData();

    memcpy (( char * ) rName, ( char * ) vp->name, ( int ) vp->namelen * sizeof ( oid ));
    for ( np = LIST_FIRST ( &wtList ); np != NULL; np = LIST_NEXT ( np, nodes )) {
	wt = ( struct wdsTbl_data * ) np->data;
	//printf("wt->linkIndex:%d ,exact:%d\n",wt->linkIndex,exact);
	rName[vp->namelen+0] = wt->rfIndex;
	rName[vp->namelen+1] = wt->linkIndex;
	
	if ((  exact && ( snmp_oid_compare ( rName, vp->namelen + 2, name, *length ) == 0 )) ||
       	    ( !exact && ( snmp_oid_compare ( rName, vp->namelen + 2, name, *length ) >  0 ))) {

	    switch ( vp->magic ) {      // found requested OID, now check for requested variable
		case FORIPNETWDSINDEX:
		    if( wt->haveWdsIfIndex) found = TRUE ; break;
		case FORIPNETLINKINDEX:
		    if( wt->haveLinkIndex) found = TRUE ; break;
		case FORIPNETSTATUS:
		    if( wt->haveStatus) found = TRUE ; break;
		case FORIPNETMAC:
		    if( wt->haveMac) found = TRUE ; break;
		case FORIPNETWDSSNR:
		    if( wt->haveWdsSNR) found = TRUE ; break;
		case FORIPNETTXRATE:
		    if( wt->haveTxRate) found = TRUE ; break;
		case FORIPNETTXCNT:
		    if( wt->haveTxCnt) found = TRUE ; break;
		case FORIPNETTXERR:
		    if( wt->haveTxErrCnt) found = TRUE ; break;
		case FORIPNETWDSSEC:			
		    if( wt->haveSecType) found = TRUE ; break;
	    }
	}
	if (found)
	    break;
    }
    if(!found)
	return NULL;

    memcpy (( char * ) name, ( char * ) rName, ( vp->namelen + 2 ) * sizeof ( oid ));
    *length = vp->namelen + 2;
    *var_len = sizeof ( long );
    *write_method = NULL;
    switch(vp->magic) {
    case FORIPNETWDSINDEX:
        return (u_char*) & wt->ifIndex;
    case FORIPNETLINKINDEX:
        return (u_char*) & wt->linkIndex;
    case FORIPNETSTATUS:
	*var_len = strlen(wt->status);
        return (u_char*) & wt->status;
    case FORIPNETMAC:
	MACWork[ 0] = wt->mac[ 0];
	MACWork[ 1] = wt->mac[ 1];
	MACWork[ 2] = wt->mac[ 3];
	MACWork[ 3] = wt->mac[ 4];
	MACWork[ 4] = wt->mac[ 6];
	MACWork[ 5] = wt->mac[ 7];
	MACWork[ 6] = wt->mac[ 9];
	MACWork[ 7] = wt->mac[10];
	MACWork[ 8] = wt->mac[12];
	MACWork[ 9] = wt->mac[13];
	MACWork[10] = wt->mac[15];
	MACWork[11] = wt->mac[16];
	MACWork[12] = '\0';
	*var_len = 6;
        return (u_char *)  htob(MACWork);
    case FORIPNETWDSSNR:
        return (u_char *) & wt->wdsSNR;
    case FORIPNETTXRATE:
	*var_len = strlen(wt->txRate);
        return (u_char *) & wt->txRate;
    case FORIPNETTXCNT:
        return (u_char *) & wt->txCnt;
    case FORIPNETTXERR:
        return (u_char *) & wt->txErrCnt;
    case FORIPNETWDSSEC:			
	*var_len = strlen(wt->secType);
        return (u_char *) & wt->secType;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_foripnetStStatTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_foripnetAccessPointMIB above.
 */
unsigned char  *
var_foripnetStStatTable(struct variable *vp,
                        oid * name,
                        size_t *length,
                        int exact,
                        size_t *var_len, WriteMethod ** write_method)
{
    oid      rName [MAX_OID_LEN];
    int found = FALSE;
    static char MACWork[17];

    vap_loadData(STA_TABLE);
    memcpy (( char * ) rName, ( char * ) vp->name, ( int ) vp->namelen * sizeof ( oid ));
    for ( np = LIST_FIRST ( &ssList ); np != NULL; np = LIST_NEXT ( np, nodes )) {
	ss = ( struct ssTbl_data * ) np->data;
	//printf("ss->rfIndex:%d,ss->stIndex:%d ,exact:%d\n",ss->rfIndex,ss->stIndex,exact);
	rName[vp->namelen+0] = ss->stIndex;
	rName[vp->namelen+1] = ss->rfIndex;
	rName[vp->namelen+2] = ss->stStatVap;
	if ((  exact && ( snmp_oid_compare ( rName, vp->namelen + 3, name, *length ) == 0 )) ||
       	    ( !exact && ( snmp_oid_compare ( rName, vp->namelen + 3, name, *length ) >  0 ))) {
	    switch ( vp->magic ) {      // found requested OID, now check for requested variable
		case FORIPNETSTINDEX:
		    if( ss->haveIndex) found = TRUE ; break;
		case FORIPNETSTSTATMAC:
		    if( ss->haveMac) found = TRUE ; break;
		case FORIPNETSTSTATVAP:
		    if( ss->haveStStatVap) found = TRUE ; break;
		case FORIPNETSTSNR:
		    if( ss->haveStSNR) found = TRUE ; break;
		case FORIPNETPKSOFSTATX:
		    if( ss->havePksOfStaTx) found = TRUE ; break;
		case FORIPNETPKSOFSTARX:
		    if( ss->havePksOfStaRx) found = TRUE ; break;
		case FORIPNETBYTESOFSTATX:
		    if( ss->haveBytesOfStaTx) found = TRUE ; break;
		case FORIPNETBYTESOFSTARX:
		    if( ss->haveBytesOfStaRx) found = TRUE ; break;
		case FORIPNETOKPKSOFSTARX:
		    if( ss->haveOkPksOfStaRx) found = TRUE ; break;
		case FORIPNETERRPKSOFSTARX:
		    if( ss->haveErrPksOfStaRx) found = TRUE ; break;
		case FORIPNETOKPKSOFSTATX:
		    if( ss->haveOkPksOfStaTx) found = TRUE ; break;
		case FORIPNETERRPKSOFSTATX:
		    if( ss->haveErrPksOfStaTx) found = TRUE ; break;
		case FORIPNETSTIDLETIME:	
		    if( ss->haveLastRx) found = TRUE ; break;
	    }
	}
	if (found)
	    break;
    }
    if(!found)
	return NULL;

    memcpy (( char * ) name, ( char * ) rName, ( vp->namelen + 3 ) * sizeof ( oid ));
    *length = vp->namelen + 3;
    *var_len = sizeof ( long );
    *write_method = NULL;
    switch (vp->magic) {
    case FORIPNETSTINDEX:
        return (u_char *) & ss->stIndex;
    case FORIPNETSTSTATMAC:
	MACWork[ 0] = ss->mac[ 0];
	MACWork[ 1] = ss->mac[ 1];
	MACWork[ 2] = ss->mac[ 3];
	MACWork[ 3] = ss->mac[ 4];
	MACWork[ 4] = ss->mac[ 6];
	MACWork[ 5] = ss->mac[ 7];
	MACWork[ 6] = ss->mac[ 9];
	MACWork[ 7] = ss->mac[10];
	MACWork[ 8] = ss->mac[12];
	MACWork[ 9] = ss->mac[13];
	MACWork[10] = ss->mac[15];
	MACWork[11] = ss->mac[16];
	MACWork[12] = '\0';
	*var_len = 6;
        return (u_char *)  htob(MACWork);
    case FORIPNETSTSTATVAP:
        return (u_char *) & ss->stStatVap;
    case FORIPNETSTSNR:
        return (u_char *) & ss->stSNR;
    case FORIPNETPKSOFSTATX:
        return (u_char *) & ss->pksOfStaTx;
    case FORIPNETPKSOFSTARX:
        return (u_char *) & ss->pksOfStaRx;
    case FORIPNETBYTESOFSTATX:
        return (u_char *) & ss->bytesOfStaTx;
    case FORIPNETBYTESOFSTARX:
        return (u_char *) & ss->bytesOfStaRx;
    case FORIPNETOKPKSOFSTARX:
        return (u_char *) & ss->okPksOfStaRx;
    case FORIPNETERRPKSOFSTARX:
        return (u_char *) & ss->errPksOfStaRx;
    case FORIPNETOKPKSOFSTATX:
        return (u_char *) & ss->okPksOfStaTx;
    case FORIPNETERRPKSOFSTATX:
        return (u_char *) & ss->errPksOfStaTx;
    case FORIPNETSTIDLETIME:	
        return (u_char *) & ss->lastRx;
    default:
        ERROR_MSG("");
    }
    return NULL;
}


int
write_foripnetApAccessControlConf(int action,
                                  u_char * var_val,
                                  u_char var_val_type,
                                  size_t var_val_len,
                                  u_char * statP,
                                  oid * name, size_t name_len)
{
    long            value;
    int             size;
    int rf=0,vap=0,gid=0,ret=0,i=0;
    extern const int gid_vap_acl[][MAX_VAP];
    char    item_name[25];
    ITEM_LIST	*list = NULL;
    CIPCFG *cipcfg = NULL;
    int pid;
    struct sigaction sig;
    struct timeval et;   

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER)   {
            fprintf(stderr, "write to foripnet not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
	gettimeofday ( &et, ( struct timezone * ) 0 );  // get time-of-day
	if ( et.tv_sec < acl_conf_lastLoad + 1)       // only reload so often
	    return SNMP_ERR_WRONGVALUE;
	acl_conf_lastLoad = et.tv_sec;
/*
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to foripnet: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
*/
        break;

    case RESERVE2:
	value = *(int *)var_val;
	if((value < 1) || (value > 3)) 
	    return SNMP_ERR_WRONGVALUE;
        break;

    case FREE:
    case ACTION:
    case UNDO:
	break;
    case COMMIT:
	/* var_val is 1 or 2 */
        size = var_val_len;
	value = *(int *)var_val;

	/* Add SIGCHILD signal handler */
	sig.sa_sigaction = chd_handler;
	sig.sa_flags |= SA_SIGINFO;
	sigaction(SIGCHLD, &sig, NULL);
    
	if((value >=1) && (value <=3)) {
	    for ( i = 0 ; i < num_interface; i++ ) {
		if(ac->index == mapping_index[i])
		    break;
	    }
	    rf = atoi(interface[i]+3)+1; 
	    vap = atoi(interface[i]+6)+1;
	    gid=gid_vap_acl[rf-1][vap-1];
	    if(value == 1) {
		sprintf(item_name, "state");
		list = append_cfg_item(NULL ,gid, item_name ,"disable");
	    }
	    else if (value == 2) {
		sprintf(item_name, "state");
		list = append_cfg_item(NULL ,gid, item_name ,"enable");
		sprintf(item_name, "policy");
		list = append_cfg_item(list,gid, item_name ,"allow");
	    }
	    else if(value == 3) {
		sprintf(item_name, "state");
		list = append_cfg_item(NULL ,gid, item_name ,"enable");
		sprintf(item_name, "policy");
		list = append_cfg_item(list,gid, item_name ,"deny");
	    }
	    print_list(list);
	    pid = fork();
	    if( pid == 0 ) {	//child process
		cipcfg  = init_cipcfg_f(config_ram);
		if(cipcfg != NULL) {
		    ret = set_cfg_items(cipcfg, list);
		    if (ret != CIPCFG_SUCCESS) {
			printf("Set cipcfg fault..%d\n",ret);
			close_cipcfg(cipcfg);
			exit(1);
		    }
		    close_cipcfg(cipcfg);
		    exit(0);
		}
	    }
	    else if (pid > 0 ) {
		printf("parent process return\n");
	    }
	    else
		printf("fork fail in write_foripnetApAccessControlConf\n");
	}

        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_foripnetApReboot(int action,
                       u_char * var_val,
                       u_char var_val_type,
                       size_t var_val_len,
                       u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to foripnet not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }

	break;
    case RESERVE2:
	/*
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to foripnet: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	*/
	value = *(int *)var_val;
	if(value == 1) {
	    //printf("reboot\n");
	    cip_system("reboot");
	}
	else
	    return SNMP_ERR_WRONGVALUE;
	
        break;

    case FREE:
    case ACTION:
    case UNDO:
    case COMMIT:
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_foripnetkickOutStation(int action,
                             u_char * var_val,
                             u_char var_val_type,
                             size_t var_val_len,
                             u_char * statP, oid * name, size_t name_len)
{
    char            value;
    int             size;
    char    mac[20];
    char    iface[14];
    char    buf[MAX_VALUE_LEN];
    int ret=0,i=0;
    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr, "write to foripnet not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
	break;

    case RESERVE2:
	printf(" in kickout \n");
	size = var_val_len;
	
	if(size == 12 ) {	//string
	    sprintf(mac,"%c%c:%c%c:%c%c:%c%c:%c%c:%c%c",*(var_val+0),*(var_val+1),*(var_val+2),*(var_val+3),*(var_val+4),*(var_val+5),*(var_val+6),*(var_val+7),*(var_val+8),*(var_val+9),*(var_val+10),*(var_val+11));
	    printf("mac:%s\n",mac);
	}
	else if (size == 6) {	//hex string

	    sprintf(mac,"%02x:%02x:%02x:%02x:%02x:%02x",*(var_val+0),*(var_val+1),*(var_val+2),*(var_val+3),*(var_val+4),*(var_val+5));
	    printf("mac:%s\n",mac);
	}
	else {
            fprintf(stderr, "write to foripnet: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
	}

	ret = checkMacAddress(mac,1);
	if(ret < 0 )
	    return SNMP_ERR_WRONGVALUE;
	memset(iface,0,sizeof(iface));
	enabled_vap(mac,iface);
	if (strlen(iface) > 0) {
	    printf(" found mac :%s in iface :%s\n",mac,iface);
	    
	    sprintf(buf, "%s %s kickmac %s", PATH_IWPRIV, iface, mac);
	    ret=cip_system(buf);
	    if(ret != CIPCFG_SUCCESS)
		printf("kick mac error\n");
	    else
		printf("buf:%s,MAX:%d\n",buf,MAX_VALUE_LEN);
	}
	else {
	    printf(" no found mac :%s in all iface\n",mac);
	    return SNMP_ERR_WRONGVALUE;
	}


        break;

    case FREE:
    case ACTION:
    case UNDO:
    case COMMIT:
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_foripnetApMacAclStatus(int action,
                             u_char * var_val,
                             u_char var_val_type,
                             size_t var_val_len,
                             u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;
    extern const int gid_vap_acl[][MAX_VAP];
    char    group_name[14],item_name[25];
    int rf=0,vap=0,gid=0,ret=0,pid,i;
    struct sigaction sig;
    struct timeval et;   

    ITEM_LIST	*list = NULL;
    CIPCFG *cipcfg= NULL;

    switch (action) {
	case RESERVE1:
	    if (var_val_type != ASN_INTEGER) {
		fprintf(stderr, "write to foripnet not ASN_INTEGER\n");
		return SNMP_ERR_WRONGTYPE;
	    }
	    gettimeofday ( &et, ( struct timezone * ) 0 );  // get time-of-day
	    if ( et.tv_sec < acl_status_lastLoad + 1)       // only reload so often
		return SNMP_ERR_WRONGVALUE;
	    acl_status_lastLoad = et.tv_sec;
	    /*
	       if (var_val_len > sizeof(long)) {
	       fprintf(stderr, "write to foripnet: bad length\n");
	       return SNMP_ERR_WRONGLENGTH;
	       }*/
	    break;

	case RESERVE2:
	    value = *(long *) var_val;
	    //only care about 1 = disable , 2 = enable 
	    if((value <1)||(value >=3))
		return SNMP_ERR_WRONGVALUE;

	    for ( i = 0 ; i < num_interface ; i++) {
		if( cl->vapIndex == mapping_index[i])
		    break;
	    }
	    //get rf card number
	    rf = atoi(interface[i]+3)+1;
	    //get vap number
	    vap = atoi(interface[i]+6)+1;

	    cipcfg  = init_cipcfg_f(config_ram);
	    if(cipcfg != NULL) {
		//check the value of mac , if value is empty , can't set state enable 
		sprintf(group_name ,"rf%d_vap%d_acl",rf,vap);
		sprintf(item_name ,"acl_entry:%d.mac",cl->dataIndex);
		memset(retval,0,MAX_VALUE_LEN);
		ret=get_cfg_item_by_str(cipcfg, group_name, item_name, retval);
		if(ret < 0)
		    return SNMP_ERR_NOACCESS;
		else {
		    if(strlen(retval)==0) { //mac is empty
			printf("mac is empty , no write\n");
			return SNMP_ERR_NOACCESS;
		    }
		}
		close_cipcfg(cipcfg);
	    }

	    break;

	case FREE:
	case ACTION:
	case UNDO:
	    break;
	case COMMIT:
	    size = var_val_len;
	    value = *(long *) var_val;

	    /* Add SIGCHILD signal handler */
	    sig.sa_sigaction = chd_handler;
	    sig.sa_flags |= SA_SIGINFO;
	    sigaction(SIGCHLD, &sig, NULL);

	    for ( i = 0 ; i < num_interface ; i++) {
		if( cl->vapIndex == mapping_index[i])
		    break;
	    }
	    //get rf card number
	    rf = atoi(interface[i]+3)+1;
	    //get vap number
	    vap = atoi(interface[i]+6)+1;
	    printf("rf:%d,vap:%d\n",rf,vap);

	    pid = fork();
	    if ( pid == 0 ) {
		cipcfg  = init_cipcfg_f(config_ram);
		if(cipcfg != NULL) {
		    sprintf(item_name, "acl_entry:%d.enabled", cl->dataIndex);
		    gid=gid_vap_acl[rf-1][vap-1];

		    if(value == 2)
			list = append_cfg_item(NULL ,gid, item_name ,"enable");
		    else
			list = append_cfg_item(NULL ,gid, item_name ,"disable");

		    print_list(list);
		    ret=set_cfg_items(cipcfg, list);
		    if (ret != CIPCFG_SUCCESS) {
			printf("Set cipcfg fault..%d\n",ret);
			close_cipcfg(cipcfg);
			exit(1);
		    }
		    close_cipcfg(cipcfg);
		    exit(0);
		}
	    }
	    else if (pid > 0 ) {
		printf("parent process return\n");
	    }
	    else
		printf("fork fail in write_foripnetApMacAclStatus\n");
	    break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_foripnetApMacAclAddr(int action,
                           u_char * var_val,
                           u_char var_val_type,
                           size_t var_val_len,
                           u_char * statP, oid * name, size_t name_len)
{
    char            value;
    int             size;
    int	    ret=0;
    char    mac[20],item_name[25];
    int rf=0,vap=0,i=0,gid=0,pid;
    extern const int gid_vap_acl[][MAX_VAP];
    struct sigaction sig;
    struct timeval et;   
    
    ITEM_LIST	*list = NULL;
    CIPCFG *cipcfg = NULL;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_OCTET_STR) {
            fprintf(stderr, "write to foripnet not ASN_OCTET_STR\n");
            return SNMP_ERR_WRONGTYPE;
        }
	gettimeofday ( &et, ( struct timezone * ) 0 );  // get time-of-day
	if ( et.tv_sec < acl_mac_lastLoad + 1)       // only reload so often
	    return SNMP_ERR_WRONGVALUE;
	acl_mac_lastLoad = et.tv_sec;
/*
        if (var_val_len != 6) {
            fprintf(stderr, "write to foripnet: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	
*/
        break;

    case RESERVE2:
        size = var_val_len;
	if ((size != 6 ) && (size != 12)) {
            fprintf(stderr, "write to foripnet: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
	}
        break;

    case FREE:
    case ACTION:
    case UNDO:
        break;
    case COMMIT:
        size = var_val_len;
        value = *(char *) var_val;
	/* Add SIGCHILD signal handler */
	sig.sa_sigaction = chd_handler;
	sig.sa_flags |= SA_SIGINFO;
	sigaction(SIGCHLD, &sig, NULL);

	if(size == 12 ){	//string
	    sprintf(mac,"%c%c:%c%c:%c%c:%c%c:%c%c:%c%c",*(var_val+0),*(var_val+1),*(var_val+2),*(var_val+3),*(var_val+4),*(var_val+5),*(var_val+6),*(var_val+7),*(var_val+8),*(var_val+9),*(var_val+10),*(var_val+11));
	    
	}
	else if (size == 6) {	//hex string
	    sprintf(mac,"%02x:%02x:%02x:%02x:%02x:%02x",*(var_val+0),*(var_val+1),*(var_val+2),*(var_val+3),*(var_val+4),*(var_val+5));
	
	}
	ret = checkMacAddress(mac,1);
	if(ret < 0 ) 
	    return SNMP_ERR_WRONGVALUE; //the format of mac is incorrect
	else {	    //the format of mac is correct

	    for( i = 0 ; i < num_interface ; i++) {
		if (cl->vapIndex == mapping_index[i])
		    break;
	    }
	    
	    //get rf card number
	    rf = atoi(interface[i]+3)+1;
	    //get vap number
	    vap = atoi(interface[i]+6)+1;
	    //get index
	    sprintf(item_name, "acl_entry:%d.mac", cl->dataIndex);
	    //get gid
	    gid=gid_vap_acl[rf-1][vap-1];
	    list = append_cfg_item(NULL ,gid, item_name ,mac);
	    print_list(list);
	    pid = fork();
	    if( pid == 0 ) {	//child
		cipcfg  = init_cipcfg_f(config_ram);
		if(cipcfg != NULL) {
		    ret = set_cfg_items(cipcfg, list);
		    if( ret != CIPCFG_SUCCESS ) {
			printf("can't set_cfg_items\n");
			close_cipcfg(cipcfg);
			exit(1);
		    }
		    close_cipcfg(cipcfg);
		    exit(0);
		}
	    }
	    else if (pid > 0 ) {
		printf("parent process return\n");
	    }
	    else
		printf("fork fail in write_foripnetApMacAclAddr\n");
	}
        break;
    }
    return SNMP_ERR_NOERROR;
}

void rf_loadData()
{
    struct timeval et;   
    int i=0;
    int rf_enabled[MAX_RF]={0},tmp=0;
    char ifname[16];
    gettimeofday ( &et, ( struct timezone * ) 0 );  // get time-of-day
    if ( et.tv_sec < rf_lastLoad + MINLOADFREQ )       // only reload so often
	return;
    rf_lastLoad = et.tv_sec;

    printf("rf call flushLists\n");
    flushLists();
    if_init();
    //if wifiX is enabled , rf_enabled[X] set 1
    for(i=0 ; i<num_interface ;i++) {
	if(strncmp(interface[i],"wifi",4)==0) {
	    tmp=atoi(interface[i]+4);
	    rf_enabled[tmp]=1;
	}
    }
    //load data sequentially
    for(i=0 ; i < MAX_RF ; i++) {
	if(rf_enabled[i] == 1) {
	    initRfStructs();
	    sprintf(ifname , "wifi%d",i);
	    loadRfStructs(ifname );//interest in wifiX
	}
    }
}

void vap_loadData(int table)
{
    int skfd;

    struct iwreq wrq;                       // ioctl request structure
    struct timeval et;   
    int sta=0;
    int ret=0,i=0,enable_vap=0;
    extern int errno;
    char group_name[14];

    gettimeofday ( &et, ( struct timezone * ) 0 );  // get time-of-day
    if (table == VAP_TABLE ) {
	if ( et.tv_sec < vap_lastLoad + MINLOADFREQ )       // only reload so often
	    return ;
	vap_lastLoad = et.tv_sec;
    }
    else if (table == STA_TABLE ) {
	if ( et.tv_sec < sta_lastLoad + MINLOADFREQ )       // only reload so often
	    return ;
	sta_lastLoad = et.tv_sec;
    }

    flushLists();
    if_init();

    for(i=0 ; i < num_interface ; i++) {
	strncpy ( wrq.ifr_name, interface[i], IFNAMSIZ);
	skfd = openSocket();                            // open socket
	if ( skfd < 0 ) {
	    syslog ( LOG_ERR, "SNMP vap_loadData() - %s\n", "socket open failure" );
	    return;
	}
	if ( (ret=ioctl ( skfd, SIOCGIWNAME, &wrq )) >= 0 ) {

	    if(cipcfg != NULL) {
		cipcfgIfName(interface[i], group_name ,2); //group_name = rfX
		if(strcmp(group_name,"rf5")!=0) {
		    memset(retval,0 ,MAX_VALUE_LEN);
		    ret=get_cfg_item_by_str(cipcfg, group_name, "roles", retval);//chenck roles of the rf card
		}
		/*
		   a300 only one rf card ,ifName = ath0apX , ath0wdsX
		   a800g has four rf cards,ifName = ath0ap0 ,ath1sta0
		*/
		if((strstr(retval,"ap")!=NULL)&&(strstr(interface[i],"ap"))) {
		    memset(group_name , 0 , 14);
		    cipcfgIfName(interface[i], group_name ,1); //group_name = rfXvapX
		    memset(retval,0 ,MAX_VALUE_LEN);
		    ret=get_cfg_item_by_str(cipcfg, group_name, "state", retval);//chenck state of the vap
		    if(strcmp(retval,"enable")==0)
			enable_vap=1;
		    if( enable_vap ) {
			printf ( "%s ifName: %s\n", "loadTables() -", interface[i]);
			initVapStructs();
			loadVapStructs(skfd ,interface[i]);
			sta=loadStStructs(skfd ,interface[i],sta );
			printf("## sta:%d ##\n",sta);
			enable_vap=0;
		    }
		}
		else
		    printf("WDS or wdsd\n");
	    }
	    else //cipcfg is NULL
		return;
	}
	else
	    printf("Warning: %s\n", strerror(errno));

	close ( skfd );
    }
    return ;
}

void wds_loadData()
{
    struct timeval et;   
    int i=0,ret=0,enable_wds=0;
    char group_name[14];
    gettimeofday ( &et, ( struct timezone * ) 0 );  // get time-of-day
    if ( et.tv_sec < wds_lastLoad + MINLOADFREQ )       // only reload so often
	return;
    wds_lastLoad = et.tv_sec;

    flushLists();
    if_init();

    for(i=0 ; i< num_interface ;i++) {
	cipcfgIfName(interface[i], group_name ,2); //group_name = rfX
	if(cipcfg != NULL) {
	    if(strcmp(group_name,"rf5")!=0) {
		memset(retval,0 ,MAX_VALUE_LEN);
		ret=get_cfg_item_by_str(cipcfg, group_name, "roles", retval);//chenck roles of the rf card
	    }
	}
	if((strstr(retval,"wds")!=NULL)&&(strstr(interface[i],"wds"))) {
	    memset(group_name , 0 ,14);
	    cipcfgIfName(interface[i], group_name ,3); //group_name = rfXwdsX
	    ret=get_cfg_item_by_str(cipcfg, group_name, "state", retval);//chenck state of the vap
	    if(strcmp(retval,"enable")==0)
		enable_wds=1;
	    if( enable_wds ) {
		initWdsStructs();
		loadWdsStructs(interface[i]);
		enable_wds=0;
	    }
	}
    }
}
void acl_loadData()
{
    struct timeval et;   
    int i=0;
    gettimeofday ( &et, ( struct timezone * ) 0 );  // get time-of-day
    if ( et.tv_sec < acl_lastLoad + MINLOADFREQ )       // only reload so often
	return;
    acl_lastLoad = et.tv_sec;

    flushLists();
    if_init();

    for(i=0 ; i< num_interface ;i++) {
	if(strncmp(interface[i],"wifi",4)==0)
	    loadAclStructs(interface[i]);
    }
}
/****************************************************************************
 *                                                                           *
 *                     initStructs() - initialize structures                 *
 *                                                                           *
 ****************************************************************************/
static void initRfStructs()
{
    memset (( char * ) &nAg, 0, sizeof ( nAg ));  
}
static void initVapStructs()
{
    //Cipherium MIB Stuctures
    memset (( char * ) &nVc, 0, sizeof ( nVc ));  
    memset (( char * ) &nAs, 0, sizeof ( nAs ));  
    memset (( char * ) &nAd, 0, sizeof ( nAd ));  
}
static void initWdsStructs()
{
    memset (( char * ) &nWt, 0, sizeof ( nWt ));  
}
static void initStStructs()
{
    memset (( char * ) &nSs, 0, sizeof ( nSs ));  
}
static void initAcStructs()
{
    memset (( char * ) &nAc, 0, sizeof ( nAc ));  
}
static void initClStructs()
{
    memset (( char * ) &nCl, 0, sizeof ( nCl ));  
}

/****************************************************************************
*                                                                           *
*              loadRfStructs() - load rf card structures	            *
*                                                                           *
****************************************************************************/
static void loadRfStructs (char *ifName )
{
    int ret=0 ,i=0,rf_num=0; 
    char group_name[14];
    char item[MAX_VALUE_LEN];
    CIPCFG * lcipcfg =NULL;

    memset(group_name ,0 , 14);
    cipcfgIfName(ifName , group_name ,0);

    /* get Mac of Rf card */
    nAg.haveMac = TRUE;
    sprintf( item, "%s_mac", group_name );
    ret=get_sys_item( item, retval);
    printf("Get mac:%s from CIPCFG.\n",retval);
    if(ret ==  CIPCFG_ERR_UNKNOWN_ITEM ) {
	nAg.haveMac= FALSE;
    }
    else if (ret == CIPCFG_SUCCESS) {
	strncpy(nAg.mac,retval,strlen(retval));
    }
    /* get Status of TxPower */
    nAg.haveTxPower = TRUE;
    sprintf( item, "%s_txpwr", group_name );
    ret=get_sys_item( item, retval);
    printf("Get txpower:%s from CIPCFG.\n",retval);
    if(ret ==  CIPCFG_ERR_UNKNOWN_ITEM ) {
	nAg.haveTxPower = FALSE;
    }
    else if (ret == CIPCFG_SUCCESS) {
	strncpy(nAg.txPower,retval,strlen(retval));
    }


    /* get Status of Band */
    nAg.haveWirelessBand = TRUE;
    sprintf( item, "%s_band", group_name );
    memset(retval, 0, sizeof(retval));
    ret=get_sys_item( item, retval);
    printf("Get wirelessBand(status):%s from CIPCFG.\n",retval);
    if(ret ==  CIPCFG_ERR_UNKNOWN_ITEM ) {
	nAg.haveWirelessBand = FALSE;
    }
    else if ( ret == CIPCFG_SUCCESS ) {
	if(strcmp(retval , "N/A")==0)
	{
	    printf("N/A\n");
	    nAg.wirelessBand=0; //Disabled 
	}
	else if (strcmp(retval ,"802.11b+g")==0) //b+g
	{
	    printf("802.11b+g\n");
	    nAg.wirelessBand=4;
	}
	else if (strcmp(retval ,"802.11a")==0)
	{
	    printf("802.11a\n");
	    nAg.wirelessBand=1;
	}
	else if (strcmp(retval ,"802.11b")==0)
	{
	    printf("802.11b\n");
	    nAg.wirelessBand=2;
	}
	else if (strcmp(retval ,"802.11g")==0)
	{
	    printf("802.11g\n");
	    nAg.wirelessBand=3;
	}
	else if (strcmp(retval ,"802.11g+n")==0)
	{
	    printf("802.11g+n\n");
	    nAg.wirelessBand=5;
	}
	else if (strcmp(retval ,"802.11a+n")==0)
	{
	    printf("802.11a+n\n");
	    nAg.wirelessBand=6;
	}
	else if (strcmp(retval ,"802.11n")==0)
	{
	    printf("802.11n\n");
	    nAg.wirelessBand=7;
	}
	else
	{
	    printf("802.11\n");
	    nAg.wirelessBand=8;
	}
    }
    
    /* get stations of each rf card */
    nAg.haveRfSta= TRUE;
    for(i = 0 ; i < MAX_VAP ; i++ ) {
	sprintf(item ,"%s%s%d%s",group_name ,"_vap",i+1,"_sta");
	ret=get_sys_item(item,retval);
	if (ret == CIPCFG_SUCCESS)
	    nAg.rfSta += atoi(retval);
	else
	    nAg.haveRfSta= FALSE;
    }

    lcipcfg = get_cipcfg();
    if(lcipcfg != NULL) {
	/* get Status of Channel */
	nAg.haveAutoChannel = TRUE;
	ret=get_cfg_item_by_str(cipcfg, group_name, "channel", retval);
	printf("Get autoChannel:%s from CIPCFG.\n",retval);
	if(ret < 0 )
	    nAg.haveAutoChannel = FALSE;
	else    
	{
	    if(strcmp(retval,"auto")==0)
		nAg.autoChannel =1;
	    else
		nAg.autoChannel =0;
	}

	/* get wireless mode from cipcfg */
	nAg.haveWirelessMode = TRUE;
	ret=get_cfg_item_by_str(lcipcfg, group_name, "roles", retval);
	printf("Get WirelessMode:%s from CIPCFG.\n",retval);
	if(ret < 0 )
	    nAg.haveWirelessMode = FALSE;
	else	
	    strncpy(nAg.wirelessMode , retval ,strlen(retval));

	/* get transmit rate from cipcfg */
	nAg.haveAutoTransRate = TRUE;
	nAg.haveMaxTransRate = TRUE;
	ret=get_cfg_item_by_str(lcipcfg, group_name, "rate", retval);
	printf("Get AutoTransRate:%s from CIPCFG.\n",retval);
	if(ret < 0) {
	    nAg.haveAutoTransRate = FALSE;
	    nAg.haveMaxTransRate = FALSE ;
	}
	else {
	    if(strcmp(retval , "auto")==0) {
		strncpy(nAg.autoTransRate,"enable",6);
		strncpy(nAg.maxTransRate,"auto",4);
	    }
	    else {
		strncpy(nAg.autoTransRate,"disable",7);
		strncpy(nAg.maxTransRate,retval,strlen(retval));
	    }
	}

	/* get online stations in each vaps */
	if(strncmp(nAg.wirelessMode ,"ap",2)==0) {
	    nAg.haveBssidNumber = TRUE;
	    rf_num= atoi(group_name+2);//get rf_card number
	    for(i=1; i < MAX_VAP+1 ;i++) {
		sprintf(group_name,"rf%d_vap%d",rf_num,i);
		ret=get_cfg_item_by_str(lcipcfg, group_name, "state", retval);
		if(ret < 0) {
		    nAg.haveBssidNumber = FALSE;
		}
		else {
		    if(strcmp(retval ,"enable")==0) {
			nAg.bssidNumber++;
			printf("nAg.bssidNumber:%d\n",nAg.bssidNumber);
		    }
		}
	    }
	}
    }

    if ( hasChanged (( char * ) &nAg, sizeof ( nAg ))) {
      nAg.haveRfIndex = TRUE;
      nAg.rfIndex = atoi(ifName+4);
      sprintf ( nAg.UID, "%04d\0", nAg.rfIndex );
      strcpy ( nAg.ifName, ifName );
      addList (( char * ) &agList, ( char * ) &nAg, sizeof ( nAg ));
    }
}

static void 
loadVapStructs ( int skfd, char *ifName)
{
    int ret=0;
    int ifIndex =0;
    char group_name[14];
    char item[MAX_VALUE_LEN];
    int secMode=0; //1:open , 2:shared , 3:auto , 4:8021x , 5:wpa ,0:error
    int eap=0; //1:eap ,2:psk 
    int wapi_type = 0; // 1:eap, 2:cert
    CIPCFG * lcipcfg=NULL;
    //-----------Vap General
    memset(retval,0 ,MAX_VALUE_LEN);
    ifIndex = if_nametoindex (ifName);
    cipcfgIfName(ifName , group_name ,1);
    if ( !ifIndex ) {
	syslog ( LOG_ERR, "SNMP %s - %s %s\n", 
		"loadVapStructs()", ifName, "has no ifIndex" );
	return;
    }
    /* get stations for each vap */
    nVc.haveVapSta = TRUE;
    sprintf(item ,"%s%s",group_name ,"_sta");
    ret=get_sys_item(item ,retval);
    if (ret == CIPCFG_SUCCESS)
	nVc.vapSta = atoi(retval);
    else
	nVc.haveVapSta = FALSE;
    
    lcipcfg=get_cipcfg();
    if(lcipcfg != NULL) {
	nVc.haveVapIfDescr = TRUE;
	printf("Get descr from CIPCFG.\n");
	ret=get_cfg_item_by_str(lcipcfg, group_name, "name", retval);
	if(ret < 0)
	    nVc.haveVapIfDescr = FALSE;
	else
	    strncpy(nVc.vapIfDescr,retval,strlen(retval)) ;

	memset(retval,0 ,MAX_VALUE_LEN);

	nVc.haveVapIfEssid = TRUE;
	printf("Get ssid from CIPCFG.\n");
	ret=get_cfg_item_by_str(lcipcfg, group_name, "ssid", retval);
	if(ret < 0)
	    nVc.haveVapIfEssid = FALSE;
	else
	    strncpy(nVc.vapIfEssid,retval,strlen(retval)) ;

	memset(retval,0 ,MAX_VALUE_LEN);

	nVc.haveVapVid = TRUE;
	printf("Get vid from CIPCFG.\n");
	ret=get_cfg_item_by_str(lcipcfg, group_name, "vid", retval);
	if(ret < 0)
	    nVc.haveVapVid = FALSE;
	else {
	    if(strcmp(retval,"4096")==0)
		nVc.vapVid=0 ;
	    else
		nVc.vapVid=atoi(retval) ;
	}

        memset(retval,0 ,MAX_VALUE_LEN);

	nVc.haveVapTunMode= TRUE;
	printf("Get Tun mode from CIPCFG.\n");
	ret=get_cfg_item_by_str(lcipcfg, group_name, "tun", retval);
	if(ret < 0)
	    nVc.haveVapTunMode = FALSE;
	else {
	    if(strcmp(retval,"enable")==0)
		nVc.vapTunMode= 1;
	    else
		nVc.vapTunMode= 0;
	}

	//-----------Vap Advance
	memset(retval,0 ,MAX_VALUE_LEN);

	nAd.haveHiddenSsid = TRUE;
	printf("Get hiddenSsid from CIPCFG.\n");
	ret=get_cfg_item_by_str(lcipcfg, group_name, "hidessid", retval);
	if(ret < 0)
	    nAd.haveHiddenSsid = FALSE;
	else {
	    if(strcmp(retval,"enable")==0)
		nAd.hiddenSsid = 1;
	    else
		nAd.hiddenSsid = 0;
	}

	memset(retval,0 ,MAX_VALUE_LEN);

	nAd.haveStIsolation = TRUE;
	printf("Get isolation from CIPCFG.\n");
	ret=get_cfg_item_by_str(lcipcfg, group_name, "sta_isolate", retval);
	if(ret < 0)
	    nAd.haveStIsolation = FALSE;
	else {
	    if(strcmp(retval,"enable")==0)
		nAd.stIsolation = 1;
	    else
		nAd.stIsolation = 0;
	}

	memset(retval,0 ,MAX_VALUE_LEN);

	nAd.haveWmm = TRUE;
	printf("Get wmm from CIPCFG.\n");
	ret=get_cfg_item_by_str(lcipcfg, group_name, "wmm", retval);
	if(ret < 0 )
	    nAd.haveWmm = FALSE;
	else {
	    if(strcmp(retval,"enable")==0)
		nAd.wmm = 1;
	    else
		nAd.wmm = 0;
	}

	//-----------Vap Security
	strncat(group_name ,"_sec",4);
	group_name[13]=0;
	printf("new group_name:%s\n",group_name);

	memset(retval,0 ,MAX_VALUE_LEN);
	nAs.haveSecMode = TRUE ;
	printf("Get secMode from CIPCFG.\n");
	ret=get_cfg_item_by_str(lcipcfg, group_name, "mode", retval);

	if(ret < 0)
	    nAs.haveSecMode = FALSE;
	else {
	    strncpy(nAs.secMode,retval,strlen(retval));
	    if(strncmp(nAs.secMode,"open" ,4)==0)
		secMode = 1;
	    else if(strncmp(nAs.secMode,"shared" ,6)==0)
		secMode = 2;
	    else if(strncmp(nAs.secMode,"auto" ,4)==0)
		secMode = 3;
	    else if(strncmp(nAs.secMode,"8021x" ,5)==0)
		secMode = 4;
	    else if(strncmp(nAs.secMode,"wpa" ,3)==0)
		secMode = 5;
	    else if (strncmp(nAs.secMode, "wapi", 4) == 0)
		secMode = 6;
	}

	memset(retval,0 ,MAX_VALUE_LEN);
	nAs.haveEapConf= TRUE ;
	printf("Get eapConf from CIPCFG.\n");
	ret=get_cfg_item_by_str(lcipcfg, group_name, "wpa.eap", retval);
	if(ret <0)
	    nAs.haveEapConf= FALSE;
	else {
	    if(strncmp(retval,"eap",3)==0) {
		nAs.eapConf = 1;
		eap = 1;
	    }
	    else if (strncmp(retval ,"psk",3)==0) {
		nAs.eapConf = 0;
		eap = 2;
	    }
	}

	ret = get_cfg_item_by_str(lcipcfg, group_name, "wapi.wapi_type", retval);
	if (ret >= 0) {
	    if (!strncmp(retval, "psk", 3)) 
		wapi_type = 1;
	    else if (!strncmp(retval, "cert", 4))
		wapi_type = 2;
	}

	memset(retval,0 ,MAX_VALUE_LEN);
	
	nAs.haveSecType = TRUE ;
	ret=get_cfg_item_by_str(lcipcfg, group_name, "wep.enabled", retval);
	if(ret <0)
	    nAs.haveSecType = FALSE;
	else {
	    if((secMode == 1) && (strncmp(retval ,"disable" , 7) == 0))
		sprintf(nAs.secType ,"%s" , "None");
	    else if ((secMode == 1 || secMode == 2 || secMode == 3) && strncmp(retval ,"enable",6) == 0)
		sprintf(nAs.secType ,"%s" , "WEP");
	    else if (secMode == 4)
		sprintf(nAs.secType ,"%s" , "802.1X");
	    else if ((secMode == 5) && (eap == 2)) 
		sprintf(nAs.secType ,"%s" , "WPA-PSK");
	    else if ((secMode == 5) && (eap == 1)) 
		sprintf(nAs.secType ,"%s" , "WPA-Radius" );
	    else if(secMode == 0 )
		sprintf(nAs.secType ,"%s" , "N/A" );
	    else if (secMode == 6 && (wapi_type == 1))
		sprintf(nAs.secType, "%s", "WAPI-PSK");
	    else if (secMode == 6 && (wapi_type == 2))
		sprintf(nAs.secType, "%s", "WAPI-CERT");
	}

	memset(retval,0 ,MAX_VALUE_LEN);
	nAs.haveEncConf = FALSE;
	if (get_cfg_item_by_str(lcipcfg, group_name, "mode", retval) 
		== CIPCFG_SUCCESS && !strcmp(retval, "wpa")) {
	    nAs.haveEncConf= TRUE ;
	    memset(retval,0 ,MAX_VALUE_LEN);
	    printf("Get EncConf from CIPCFG.\n");
	    ret=get_cfg_item_by_str(lcipcfg, group_name, "wpa.enc", retval);
	    if(ret < 0)
		nAs.haveEncConf= FALSE;
	    else
		strncpy(nAs.encConf,retval,strlen(retval));
	}

	printf("--[vap ret]:%d--\n",ret);
    }


    if ( hasChanged (( char * ) &nVc, sizeof ( nVc ))) {
	nVc.haveVapIfIndex = TRUE;
	nVc.ifIndex = ifIndex;
	sprintf ( nVc.UID, "%04d\0", nVc.ifIndex );
	strcpy ( nVc.ifName, ifName );
	addList (( char * ) &vcList, ( char * ) &nVc, sizeof ( nVc ));
    }
    if ( hasChanged (( char * ) &nAs, sizeof ( nAs ))) {
	nAs.haveVapIfIndex = TRUE;
	nAs.ifIndex = ifIndex;
	sprintf ( nAs.UID, "%04d\0", nAs.ifIndex );
	strcpy ( nAs.ifName, ifName );
	addList (( char * ) &asList, ( char * ) &nAs, sizeof ( nAs ));
    }
    if ( hasChanged (( char * ) &nAd, sizeof ( nAd ))) {
	nAd.haveVapIfIndex = TRUE;
	nAd.ifIndex = ifIndex;
	sprintf ( nAd.UID, "%04d\0", nAd.ifIndex );
	strcpy ( nAd.ifName, ifName );
	addList (( char * ) &adList, ( char * ) &nAd, sizeof ( nAd ));
    }
}

static void 
loadWdsStructs ( char *ifName)
{
    int rate,ret;
    char item_value[MAX_VALUE_LEN];
    char group_name[14],item_name[20],buf[64];
    int  link_idx,ok_cnt=0;
    int wep=0; //0:disable 1:enable
    int wpa=0; //0:disable 1:enable
    int wpaEnc=0; //1:rc4-tkip 2:aes-ccmp 0:error
    double last_rx;
    FILE *fp;
    ASSOC_STA_LIST * sta = NULL;
    CIPCFG * lcipcfg=NULL;

    nWt.rfIndex = atoi(ifName+3);
    nWt.haveWdsIfIndex = TRUE;
    nWt.ifIndex = if_nametoindex (ifName);
    nWt.haveLinkIndex = TRUE;
    link_idx = atoi(ifName+7);

    if ((sta = get_sta_list(ifName)) == NULL)
    {
	nWt.haveLinkIndex = FALSE;
	nWt.haveStatus = FALSE;
	nWt.haveMac = FALSE;
	nWt.haveWdsSNR = FALSE;
	nWt.haveTxRate = FALSE;
	nWt.haveTxCnt = FALSE;
	nWt.haveTxErrCnt = FALSE;
	nWt.haveSecType = FALSE;
	return ;
    }

    last_rx = sta->last_rx;
    //mac
    nWt.haveMac = TRUE;
    strncpy(nWt.mac, sta->mac ,strlen(sta->mac));
    ret = checkMacAddress(nWt.mac,0);
    if (ret < 0 )
	nWt.haveMac = FALSE;
    //rssi
    nWt.haveWdsSNR = TRUE;
    nWt.wdsSNR= sta->rssi;
    //rate
    rate= (int)(sta->tx_rate * 2);
    nWt.haveTxRate = TRUE;
    sprintf(nWt.txRate, "%d%s", rate/2, (rate%2)==1 ? ".5":"");
    //total cnt
    nWt.haveTxCnt = TRUE;
    nWt.txCnt = sta->tx_okcnt + sta->tx_errcnt;
    //errcnt
    nWt.haveTxErrCnt = TRUE;
    nWt.txErrCnt = sta->tx_errcnt;
    //okcnt
    ok_cnt = sta->tx_okcnt;
    
    free_sta_list(sta);

    sprintf(group_name, "rf%d_wds%d", nWt.rfIndex + 1, link_idx + 1);
    lcipcfg=get_cipcfg();
    if(lcipcfg !=NULL) {
    
	nWt.haveSecType = TRUE;
	sprintf(nWt.secType,"%s","None");
	//WEP check
	ret = get_cfg_item_by_str(lcipcfg, group_name, "wep.enabled", retval);
	if (ret != CIPCFG_SUCCESS) {
	    nWt.haveSecType = FALSE;
	}
	else {
	    if(strcmp(retval ,"enable") == 0) {
		sprintf(nWt.secType,"%s","WEP");
	    }
	    else {
		//WPA check
		ret = get_cfg_item_by_str(lcipcfg, group_name, "wpa.enabled", retval);
		if (ret == CIPCFG_SUCCESS) {
		    if(strncmp(retval ,"enable" ,6) == 0) {
			ret = get_cfg_item_by_str(lcipcfg, group_name, "wpa.enc", retval);
			if (ret == CIPCFG_SUCCESS) {
			    if(strncmp(retval ,"rc4-tkip" ,8) == 0) {
				sprintf(nWt.secType ,"%s", "TKIP");
			    }
			    else if (strncmp(retval , "aes-ccmp" ,8 ) == 0) {
				sprintf(nWt.secType ,"%s", "AES");
			    }
			}
		    }
		}
	    }
	}
	
	
	ret = get_cfg_item_by_str(lcipcfg, group_name, "state", retval);
	if (ret != CIPCFG_SUCCESS) {
	    return ;
	}
	if (strncmp(retval, "disable",7) == 0) {
	    nWt.haveStatus = TRUE;
	    sprintf(nWt.status, "Disabled");
	}
	/* Check if WDS link is disabled */
	if (!(ok_cnt > 0 && last_rx < 120)) {
	    nWt.haveStatus = TRUE;
	    sprintf(nWt.status, "Disconnected");
	}
	else {
	/* Check the STP status of WDS link via sysfs */
	    memset(retval,0,MAX_VALUE_LEN);
            sprintf(buf, "/sys/class/net/%s/brport/state", ifName);
            if ((fp = fopen(buf, "r")) != NULL) {
                int state;
                fgets(retval, MAX_VALUE_LEN, fp);
                fclose(fp);
                state = atoi(retval);
                switch (state) {
                    case 0:
			nWt.haveStatus = TRUE;
			printf(nWt.status, "Disabled");
			break;  // disabled
                    case 1:                                     // listening
                    case 2:                                     // learning
                    case 3:
			nWt.haveStatus = TRUE;
			sprintf(nWt.status, "Active");
			break;    // forwarding
                    case 4:
			nWt.haveStatus = TRUE;
			sprintf(nWt.status, "Backup");
			break;    // blocking
                }
            }

	/* Check the STP status of WDS link */
	    if (!nWt.haveStatus) {
		memset(retval,0,MAX_VALUE_LEN);
		sprintf(buf, "brctl showstat br0 %s",ifName);
		if ((fp = popen(buf, "r")) != NULL) {
		    fgets(retval, MAX_VALUE_LEN, fp);
		    pclose(fp);
		}

		if (strncmp(retval, "listening", 9) == 0 || strncmp(retval, "learning", 8) == 0
			|| strncmp(retval, "forwarding", 10) == 0) {
		    nWt.haveStatus = TRUE;
		    sprintf(nWt.status, "Active");
		} else if (strncmp(retval, "disabled", 8) == 0) {
		    nWt.haveStatus = TRUE;
		    sprintf(nWt.status, "Disabled");
		} else { // STP status is "blocking".
		    nWt.haveStatus = TRUE;
		    sprintf(nWt.status, "Backup");
		}
	    }
	}
    }
    printf("nWt.status:%s\n",nWt.status);
    if ( hasChanged (( char * ) &nWt, sizeof ( nWt ))) {
	nWt.haveLinkIndex = TRUE;
	nWt.linkIndex = link_idx;
	sprintf ( nWt.UID, "%02d%02d\0",nWt.rfIndex, nWt.linkIndex );
	addList (( char * ) &wtList, ( char * ) &nWt, sizeof ( nWt ));
    }
}

static void 
loadAclStructs(char *ifName)
{
    int ifIndex=0,i=0,j=0,len=0,ret=0,index=0;
    char rf_card[5];
    char group_name[14];
    char item_name[20];
    char tmp[10];
    CIPCFG *lcipcfg=NULL;
    lcipcfg = get_cipcfg();
    cipcfgIfName(ifName , rf_card,0);

    if(lcipcfg != NULL) {
	memset(retval,0 ,MAX_VALUE_LEN);
	ret =get_cfg_item_by_str(lcipcfg , rf_card ,"roles",retval); 
	if(ret<0) {
	    printf("cipcfg error\n");
	    return;
	}
	else {
	    if(strstr(retval,"ap")!=NULL) { //roles has "ap" 
		for (i=0 ; i < MAX_VAP ;i++) {	//rfX_vap1~ rfX_vap8
		    //check the vap is enabled or disabled
		    memset(retval,0 ,MAX_VALUE_LEN);
		    sprintf(group_name ,"%s_vap%d",rf_card ,i+1);
		    ret=get_cfg_item_by_str(lcipcfg, group_name, "state", retval);
		    if(ret<0)
			nAc.haveAccessControlConf = FALSE;
		    else {
			if(strncmp(retval,"enable",6)==0) {
			    sprintf(tmp,"ath%dap%d",atoi(group_name+2)-1,atoi(group_name+7)-1);
			    ifIndex = if_nametoindex (tmp);
			    if ( !ifIndex ) {
				syslog ( LOG_ERR, "SNMP %s - %s %s\n", 
					"loadVapStructs()", ifName, "has no ifIndex" );
				return;
			    }
			    memset(retval,0 ,MAX_VALUE_LEN);
			    sprintf(group_name ,"%s_vap%d_acl",rf_card ,i+1);
			    //init a data for nAc
			    initAcStructs();

			    nAc.haveAccessControlConf = TRUE;
			    memset(retval,0 ,MAX_VALUE_LEN);
			    ret=get_cfg_item_by_str(lcipcfg, group_name, "state", retval);
			    if(ret < 0)
				nAc.haveAccessControlConf = FALSE;
			    else {
				if(strncmp(retval ,"disable" ,7)==0)
				    nAc.accessControlConf =1;
				else {
				    memset(retval,0 ,MAX_VALUE_LEN);
				    ret=get_cfg_item_by_str(lcipcfg, group_name, "policy", retval);
				    if(ret < 0 )
					nAc.haveAccessControlConf = FALSE;
				    else {
					if(strncmp(retval ,"allow",5)==0)
					    nAc.accessControlConf =2;
					else if(strncmp(retval ,"deny",4)==0)
					    nAc.accessControlConf =3;
					else if(strncmp(retval ,"radius",6)==0)
					    nAc.accessControlConf =4;
					else
					    nAc.accessControlConf =5;
				    }
				}
			    }
			    //insert nAc into link list acList
			    if ( hasChanged (( char * ) &nAc, sizeof ( nAc ))) {
				nAc.haveAccessControlIndex = TRUE;
				nAc.index = ifIndex;
				sprintf ( nAc.UID, "%04d\0", nAc.index );
				addList (( char * ) &acList, ( char * ) &nAc, sizeof ( nAc ));
			    }
			    // load nCl list data
			    for(index = (i*10),j=0; index <(i*10)+10 ;index++,j++) {
				initClStructs();
				nCl.macAclIndex = j;	
				nCl.haveMacAclStatus = TRUE;
				sprintf(item_name ,"acl_entry:%d.enabled",j);
				ret=get_cfg_item_by_str(lcipcfg, group_name, item_name, retval);
				if(ret < 0)
				    nCl.haveMacAclStatus = FALSE;
				else {
				    if(strcmp(retval ,"enable")==0)
					nCl.macAclStatus = 2;
				    else
					nCl.macAclStatus = 1;
				}

				nCl.haveMac =TRUE;
				sprintf(item_name ,"acl_entry:%d.mac",j);
				ret=get_cfg_item_by_str(lcipcfg, group_name, item_name, retval);
				if(ret < 0)
				    nCl.haveMac =FALSE;
				else {
				    //if have data
				    if(len=strlen(retval)>0)
					strcpy(nCl.mac,retval);
				    //if no data , return var_len = 0
				}

				if ( hasChanged (( char * ) &nCl, sizeof ( nCl ))) {
				    nCl.haveMacAclIndex = TRUE;
				    nCl.vapIndex = ifIndex;
				    nCl.dataIndex = j;
				    sprintf ( nCl.UID, "%02d%02d\0",ifIndex, index );//prevent UID duplicated
				    addList (( char * ) &clList, ( char * ) &nCl, sizeof ( nCl ));
				}
			    }
			}
			else
			    nAc.haveAccessControlConf = FALSE;
		    }

		}
	    }
	    else //roles is wds only
		return;
	}
    }
}

#ifdef FUSION_GET_STA_LIST
static int
loadStStructs( int skfd , char *ifName ,int index)
{
    int record=0 , i,len; 
    char * s ,*t ,*pos=NULL;
    unsigned char buf[24*1024],*cp;
    int  ret=0;
    struct iwreq iwr;
    struct ieee80211req_sta_info *si;
    struct ieee80211req_sta_stats stats;
    const struct ieee80211_nodestats *ns = &stats.is_stats;

    (void) memset(&iwr, 0, sizeof(iwr));
    (void) strncpy(iwr.ifr_name, ifName, sizeof(iwr.ifr_name));
    iwr.u.data.pointer = (void *) buf;
    iwr.u.data.length = sizeof(buf);
    if (ioctl(skfd, IEEE80211_IOCTL_STA_INFO, &iwr) < 0) {
	return index;
    }
    len = iwr.u.data.length;
    printf("len:%d,sizeof sta_info:%d\n",len,sizeof(struct ieee80211req_sta_info));

    if (len >= sizeof(struct ieee80211req_sta_info)) {
	cp = buf;
	do {
	    si = (struct ieee80211req_sta_info *) cp;
	    

	    //load info of the mac
		initStStructs();
		nSs.haveMac = TRUE;
		sprintf(nSs.mac,"%02X:%02X:%02X:%02X:%02X:%02X",(UCHAR ) si->isi_macaddr[0],(UCHAR ) si->isi_macaddr[1],(UCHAR ) si->isi_macaddr[2],(UCHAR ) si->isi_macaddr[3],(UCHAR ) si->isi_macaddr[4],(UCHAR ) si->isi_macaddr[5] );
		ret = checkMacAddress(nSs.mac , 0);
		if( ret < 0 ) {
		    nSs.haveMac = FALSE;
		    return index;
		}
		printf("nSs.mac:%s\n",nSs.mac);
	    //rssi
		nSs.haveStSNR = TRUE;
		nSs.stSNR = si->isi_rssi;
		printf("nSs.stSNR:%d\n",nSs.stSNR);

	    //idle time
		nSs.haveLastRx = TRUE;
		nSs.lastRx = si->isi_inact;
		

		struct ether_addr *ea = ether_aton(nSs.mac);
		if( ea != NULL) {
	    
		    memset(&iwr, 0, sizeof(iwr));
		    strncpy(iwr.ifr_name, ifName, sizeof(iwr.ifr_name));
		    iwr.u.data.pointer = (void *) &stats;
		    iwr.u.data.length = sizeof(stats);
		    memcpy(stats.is_u.macaddr, ea->ether_addr_octet, IEEE80211_ADDR_LEN);
	    
		    if (ioctl(skfd, IEEE80211_IOCTL_STA_STATS, &iwr) < 0) {
			printf("unable to get station stats for %s\n",
			    ether_ntoa((const struct ether_addr*) ea->ether_addr_octet));
			nSs.havePksOfStaRx = FALSE;
			nSs.pksOfStaRx = 0;
			nSs.havePksOfStaTx = FALSE;
			nSs.pksOfStaTx =0;
			nSs.haveBytesOfStaRx = FALSE;
			nSs.bytesOfStaRx =0;
			nSs.haveBytesOfStaTx = FALSE;
			nSs.bytesOfStaTx =0;
		    }
		    else {
			nSs.havePksOfStaRx = TRUE;
			nSs.pksOfStaRx = ns->ns_tx_okcnt + ns->ns_tx_errcnt ;
			printf("nSs.pksOfStaRx:%ld\n",nSs.pksOfStaRx);

			nSs.havePksOfStaTx = TRUE;
			nSs.pksOfStaTx = ns->ns_rx_data + ns->ns_rx_mgmt + ns->ns_rx_ctrl;
			printf("nSs.pksOfStaTx:%ld\n",nSs.pksOfStaTx);


			nSs.haveBytesOfStaRx = TRUE;
			nSs.bytesOfStaRx =ns->ns_tx_bytes;
			printf("nSs.[bytes]OfStaRx:%ld\n",nSs.bytesOfStaRx);

			nSs.haveBytesOfStaTx = TRUE;
			nSs.bytesOfStaTx =ns->ns_rx_bytes;
			printf("nSs.[bytes]OfStaTx:%ld\n",nSs.bytesOfStaTx);


			nSs.haveOkPksOfStaRx = TRUE;
			nSs.okPksOfStaRx = ns->ns_tx_okcnt;

			nSs.haveErrPksOfStaRx = TRUE;
			nSs.errPksOfStaRx = ns->ns_tx_errcnt;
			
			/* TO DO 
			    nSs.okPksOfStaTx , nSs.errPksOfStaRx in A600
			*/

			printf("nx_rx_data:%u",ns->ns_rx_data);
			printf("nx_rx_mgmt:%u\t",ns->ns_rx_mgmt);
			printf("nx_rx_ctrl:%u\t",ns->ns_rx_ctrl);
			printf("nx_rx_bytes:%llu\t",ns->ns_rx_bytes);
			printf("nx_rx_dup:%u\t\n",ns->ns_rx_dup);


			printf("nx_tx_data:%u\t",ns->ns_tx_data);
			printf("nx_tx_mgmt:%u\t",ns->ns_tx_mgmt);
			printf("nx_tx_bytes:%llu\t\n",ns->ns_tx_bytes);

			printf("nx_tx_okcnt:%u\t",ns->ns_tx_okcnt);
			printf("nx_tx_errcnt:%u\t",ns->ns_tx_errcnt);
			/*TO DO 
			printf("nx_rx_okcnt:%u\t",ns->ns_rx_okcnt);
			printf("nx_rx_errcnt:%u\t",ns->ns_rx_errcnt);
			*/
			

			nSs.haveStStatVap = TRUE;
			nSs.stStatVap=atoi(ifName+6)+1;

			if ( hasChanged (( char * ) &nSs, sizeof ( nSs ))) {
			    nSs.haveIndex = TRUE;
			    nSs.stIndex = index;
			    nSs.rfIndex=atoi(ifName+3);
			    printf("nSs.rfIndex:%d\n",nSs.rfIndex);
			    sprintf ( nSs.UID, "%04d\0", nSs.stIndex );
			    printf("nSs.UID:%s\n",nSs.UID);	    
			    addList (( char * ) &ssList, ( char * ) &nSs, sizeof ( nSs ));

			}
			index++;
		    }
		}
	    
	    cp += si->isi_len, len -= si->isi_len;
	} while (len >= sizeof(struct ieee80211req_sta_info));
    }

    return index;
}
#else
static int
loadStStructs( int skfd , char *ifName ,int index)
{
    FILE *fp;
    int record=0 , i; 
    char * s ,*t ,*pos=NULL;
    char path[512];
    char brf[1024];
    char *delim=" \n";
    int  ret=0;
    struct iwreq iwr;
    struct ieee80211req_sta_info *si;
    struct ieee80211req_sta_stats stats;
    const struct ieee80211_nodestats *ns = &stats.is_stats;

    memset(path,0 ,32);
    /* station information */
    sprintf(path,"%s/%s/associated_sta",PROC_NET_MADWIFI,ifName);
    fp = fopen( path , "r");
    if(fp) {
    while ( fgets ( brf, sizeof ( brf ), fp )) { 
        if(strlen(brf)>1) { //prevent from the line is only with '\n' 
	    t =s =brf; 
	    t =s = strtok_r(brf,delim,&pos);
	    s= strtok_r(NULL ,delim,&pos);

	    if(strcmp(t,"macaddr:")==0) {
		/* Do init for each online user*/
		initStStructs();
		nSs.haveMac = TRUE;

		strncpy(nSs.mac,(s+1),17);
		ret=checkMacAddress(nSs.mac,0);
		if(ret < 0)
		printf("mac format error\n");

		//get data from madwifi
		const struct ether_addr *ea = ether_aton(nSs.mac);

		if (ea != NULL) {
		    memset(&iwr, 0, sizeof(iwr));
		    strncpy(iwr.ifr_name, ifName, sizeof(iwr.ifr_name));
		    iwr.u.data.pointer = (void *) &stats;
		    iwr.u.data.length = sizeof(stats);
		    memcpy(stats.is_u.macaddr, ea->ether_addr_octet, IEEE80211_ADDR_LEN);
		    printf("sta mac:%s\n",ether_ntoa((const struct ether_addr*) ea->ether_addr_octet));
		    if (ioctl(skfd, IEEE80211_IOCTL_STA_STATS, &iwr) < 0) {
			printf("unable to get station stats for %s\n",
			    ether_ntoa((const struct ether_addr*) ea->ether_addr_octet));
			nSs.havePksOfStaRx = TRUE;
			nSs.pksOfStaRx = 0;
			nSs.havePksOfStaTx = TRUE;
			nSs.pksOfStaTx =0;
			nSs.haveBytesOfStaRx = TRUE;
			nSs.bytesOfStaRx =0;
			nSs.haveBytesOfStaTx = TRUE;
			nSs.bytesOfStaTx =0;
		    }
		    else {
			nSs.havePksOfStaRx = TRUE;
			nSs.pksOfStaRx = ns->ns_tx_okcnt + ns->ns_tx_errcnt;
			printf("nSs.pksOfStaRx:%ld\n",nSs.pksOfStaRx);
			nSs.havePksOfStaTx = TRUE;
			nSs.pksOfStaTx =ns->ns_rx_data + ns->ns_rx_mgmt + ns->ns_rx_ctrl;
			printf("nSs.pksOfStaTx:%ld\n",nSs.pksOfStaTx);

			nSs.haveBytesOfStaRx = TRUE;
			nSs.bytesOfStaRx =ns->ns_tx_bytes;
			printf("nSs.[bytes]OfStaRx:%ld\n",nSs.bytesOfStaRx);

			nSs.haveBytesOfStaTx = TRUE;
			nSs.bytesOfStaTx =ns->ns_rx_bytes;
			printf("nSs.[bytes]OfStaTx:%ld\n",nSs.bytesOfStaTx);

			nSs.haveOkPksOfStaRx = TRUE;
			nSs.okPksOfStaRx = ns->ns_tx_okcnt;

			nSs.haveErrPksOfStaRx = TRUE;
			nSs.errPksOfStaRx = ns->ns_tx_errcnt;

			printf("nx_rx_data:%u",ns->ns_rx_data);
			printf("nx_rx_mgmt:%u\t",ns->ns_rx_mgmt);
			printf("nx_rx_bytes:%llu\t",ns->ns_rx_bytes);
			printf("nx_rx_dup:%u\t\n",ns->ns_rx_dup);

			printf("nx_tx_data:%u\t",ns->ns_tx_data);
			printf("nx_tx_mgmt:%u\t",ns->ns_tx_mgmt);
			printf("nx_tx_bytes:%llu\t\n",ns->ns_tx_bytes);

		    }

		}

	    }
	    else if(strcmp(t,"rssi")==0) {	//SNR
		nSs.haveStSNR = TRUE;
		nSs.stSNR = atoi(s);
	    }
	    else if(strcmp(t,"last_rx")==0) {
		nSs.haveLastRx = TRUE;
		nSs.lastRx = atol(s);
		nSs.haveStStatVap = TRUE;
		nSs.stStatVap=atoi(ifName+6)+1;
		record =1;
	    }
	    if(record == 1) {
		if ( hasChanged (( char * ) &nSs, sizeof ( nSs ))) {
		nSs.haveIndex = TRUE;
		nSs.stIndex = index;
		nSs.rfIndex=atoi(ifName+3);
		printf("nSs.rfIndex:%d\n",nSs.rfIndex);
		sprintf ( nSs.UID, "%04d\0", nSs.stIndex );
		printf("nSs.UID:%s\n",nSs.UID);	    
		addList (( char * ) &ssList, ( char * ) &nSs, sizeof ( nSs ));
		}	    
		index ++;
		record =0;
	    }
        }
    }
    fclose(fp);
    }
    return index;
}

#endif
/****************************************************************************
 *                                                                           *
 *                        Linked List Functions                              *
 *                                                                           *
 ****************************************************************************/
/****************************************************************************
 *                                                                           *
 *                addList() - add an entry to a linked list                  *
 *                                                                           *
 ****************************************************************************/
    static void 
addList ( char *l, char *data, int len  )
{
    char uid[256];
    LIST_HEAD ( , avNode ) *list;   

    // NOTE: this assumes the UID is at the begining of the
    //       data structure and that UIDs are strings
    
    list = ( LIST_HEAD ( , avNode ) * ) l;            // NOTE: don't know how to get 
    strcpy ( uid, data );                             //  rid of compiler warning on
    						      //  LISTHEAD typecast

    // create a new node and the data that goes in it
    newNode = malloc ( sizeof ( struct avNode ));
    newNode->data = malloc ( len );
    memcpy ( newNode->data, data, len );

    // this deals with an empty list
    if ( LIST_EMPTY ( list )) {
	LIST_INSERT_HEAD ( list, newNode, nodes );
	return;
    }
    // this deals with UIDs that match
    for ( np = LIST_FIRST ( list ); np != NULL; np = LIST_NEXT ( np, nodes )) {
	if ( strncmp ( uid, np->data, strlen ( uid )) == 0 ) {                      // found matching UID
	    LIST_INSERT_AFTER ( np, newNode, nodes );
	    if ( np->data )
		free ( np->data );
	    LIST_REMOVE ( np, nodes );
	    free ( np );
	    return;
	}
    }
    // this deals with inserting a new UID in the list
    for ( np = LIST_FIRST ( list ); np != NULL; np = LIST_NEXT ( np, nodes )) {
	lastNode = np;
	if ( strncmp ( np->data, uid, strlen ( uid )) > 0 ) {                       // old ID > new ID AND
	    LIST_INSERT_BEFORE ( np, newNode, nodes );
	    return;
	}
    }
    // this deals with a UID that needs to go on the end of the list
    LIST_INSERT_AFTER ( lastNode, newNode, nodes );

    return;
}
/****************************************************************************
 *                                                                           *
 *              initLists() - initialize all the linked lists                *
 *                                                                           *
 ****************************************************************************/
static void initLists()
{
    LIST_INIT ( &agList );  
    LIST_INIT ( &vcList );  
    LIST_INIT ( &asList );  
    LIST_INIT ( &adList );  
    LIST_INIT ( &acList );  
    LIST_INIT ( &clList );  
    LIST_INIT ( &wtList );  
    LIST_INIT ( &ssList );  
}
/****************************************************************************
 *                                                                           *
 *                 flushLists() - flush all linked lists                     *
 *                                                                           *
 ****************************************************************************/
static void flushLists()
{
    printf("do flushLists\n");
    flushList (( char * ) &agList ); 
    flushList (( char * ) &vcList ); 
    flushList (( char * ) &asList ); 
    flushList (( char * ) &adList ); 
    flushList (( char * ) &acList ); 
    flushList (( char * ) &clList ); 
    flushList (( char * ) &wtList ); 
    flushList (( char * ) &ssList ); 
}

/****************************************************************************
 *                                                                           *
 *                   flushList() - flush a linked list                       *
 *                                                                           *
 ****************************************************************************/
static void flushList ( char *l )
{
    LIST_HEAD ( , avNode ) *list;

    list = ( LIST_HEAD ( , avNode ) * ) l;    // NOTE: don't know how to get 
    while ( !LIST_EMPTY ( list )) {           //  rid of compiler warning on
	np = LIST_FIRST ( list );               //  LISTHEAD typecast
	if ( np->data )
	    free ( np->data );
	LIST_REMOVE ( np, nodes );
	free ( np );
    }
}


/****************************************************************************
 * Open a socket.
 * Depending on the protocol present, open the right socket. The socket
 * will allow us to talk to the driver.
 ****************************************************************************/
static int openSocket ( void )
{
  static const int families[] = {
    AF_INET, AF_IPX, AF_AX25, AF_APPLETALK
  };
  unsigned int  i;
  int   sock;

  /*
   * Now pick any (exisiting) useful socket family for generic queries
   * Note : don't open all the socket, only returns when one matches,
   * all protocols might not be valid.
   * Workaround by Jim Kaba <jkaba@sarnoff.com>
   * Note : in 99% of the case, we will just open the inet_sock.
   * The remaining 1% case are not fully correct...
   */

  /* Try all families we support */
  for(i = 0; i < sizeof(families)/sizeof(int); ++i) {
      /* Try to open the socket, if success returns it */
      sock = socket(families[i], SOCK_DGRAM, 0);
      if(sock >= 0)
  return sock;
  }

  return -1;
}

/****************************************************************************
 *                                                                           *
 *                 htob - converts hex string to binary                      *
 *			  string s should be uppercase			     *
 *                                                                           *
 ****************************************************************************/
static char *htob ( char *s )
{
    char nibl, *byt;
    static char bin[20];

    byt = bin;

    while ((nibl = *s++) && nibl != ' ') {    /* While not end of string. */
	nibl -= ( nibl > '9') ?  ('A' - 10): '0'; 
	*byt = nibl << 4;                              /* place high nibble */
	if((nibl = *s++) && nibl != ' ') {
	    nibl -= ( nibl > '9') ?  ('A' - 10): '0';
	    *byt |= nibl;                                /*  place low nibble */
	}
	else break;
	++byt;
    }
    *++byt = '\0';
    return ( bin );
}

/****************************************************************************
 *                                                                           *
 *           hasChanged() - see if area has been changed from NULLs          *
 *                                                                           *
 ****************************************************************************/
static int hasChanged ( char *loc, int len )
{
    char *wrk;
    int changed = TRUE;

    wrk = malloc ( len );
    memset ( wrk, 0, len );
    if ( memcmp ( loc, wrk, len ) == 0 )
	changed = FALSE;
    free ( wrk );

    return ( changed );
}


/****************************************************************************
 *                                                                           *
 *           cipcfgIfName() - convert vap name into interface name	     *
 *			      mode = 0  return rf number		     *
 *			      mode = 1  return rf and vap number	     *
 *			      mode = 2  return rf number		     *
 *                                                                           *
 ****************************************************************************/
void cipcfgIfName(char *ifName, char *group_name ,int mode)
{
    int rf_card=0;
    int vap=0;   
    if (mode == 0) {	//wifiX
	switch( atoi(ifName+4)) {
	    case 0:
		rf_card=1;	break;
	    case 1:
		rf_card=2;	break;
	    case 2:
		rf_card=3;	break;
	    case 3:
		rf_card=4;	break;
	}
	sprintf(group_name ,"rf%d",rf_card);
    }
    else if(mode ==1) {	//athXapX
	switch( atoi(ifName+3)) {
	    case 0:
		rf_card=1;	break;
	    case 1:
		rf_card=2;	break;
	    case 2:
		rf_card=3;	break;
	    case 3:
		rf_card=4;	break;
	}
	switch( atoi(ifName+6)) {
	    case 0:
		vap=1;  break;
	    case 1:
		vap=2;  break;
	    case 2:
		vap=3;  break;
	    case 3:
		vap=4;  break;
	    case 4:
		vap=5;  break;
	    case 5:
		vap=6;  break;
	    case 6:
		vap=7;  break;
	    case 7:
		vap=8;  break;
	}
    
	sprintf(group_name ,"rf%d_vap%d",rf_card,vap);
    }
    else if(mode ==2) {	//athXapX ,athXwdsX
	if(strlen(ifName) > 3) {
	    switch( atoi(ifName+3)) {
		case 0:
		    rf_card=1;	break;
		case 1:
		    rf_card=2;	break;
		case 2:
		    rf_card=3;	break;
		case 3:
		    rf_card=4;	break;
	    }
	    sprintf(group_name ,"rf%d",rf_card);
	}
	else
	    sprintf(group_name ,"rf5");
    }
    else if(mode ==3) {	//athXwdsX
	switch( atoi(ifName+3)) {
	    case 0:
		rf_card=1;	break;
	    case 1:
		rf_card=2;	break;
	    case 2:
		rf_card=3;	break;
	    case 3:
		rf_card=4;	break;
	}
	switch( atoi(ifName+7)) {
	    case 0:
		vap=1;  break;
	    case 1:
		vap=2;  break;
	    case 2:
		vap=3;  break;
	    case 3:
		vap=4;  break;
	    case 4:
		vap=5;  break;
	    case 5:
		vap=6;  break;
	    case 6:
		vap=7;  break;
	    case 7:
		vap=8;  break;
	}
	sprintf(group_name ,"rf%d_wds%d",rf_card,vap);
    }
    return;
}

/****************************************************************************
 *                                                                           *
 *           enabled_vap() - find out which vap is enabled		     *
 *			     if find mac , write interface name into iface   *
 *                                                                           *
 ****************************************************************************/

void enabled_vap(char * mac ,char *iface)
{
  FILE *fp ;
  char *s,*t;
  char bfr[1024],ifName[1024];
  int ret=-1,len=0;
  fp = fopen ( PROC_NET_DEV, "r" );
  if ( fp ) {
    while ( fgets ( bfr, sizeof ( bfr ), fp )) {
      if ( strstr ( bfr, ":" )) {
        s = bfr; t = ifName;
        while ( isspace ( *s ))                     // discard white space
          *s++;
        while ( *s != ':' )                         // get interface name
          *t++ = *s++;
        *t = '\0';
	if(strstr(ifName ,"ap")!=NULL)  {
	   printf("ifName:%s\n",ifName);
	   ret=search_mac_in_vap(mac,ifName);
	   if(ret > 0 ) {
		strcpy(iface,ifName);
		break;
	   }
	   printf("mac not in %s\n",ifName);
	}
      }
    }
    fclose ( fp );
  }
}

/*
    return 0 , not found mac
    return 1 , found mac
*/
int search_mac_in_vap(char *mac ,char *ifName)
{
    int ret=0;
    ASSOC_STA_LIST *sta_list = NULL, *sta = NULL;
    sta_list = get_sta_list(ifName);
    foreach_sta_get(sta, sta_list) {
	printf("client mac:%s\n",sta->mac);
	if(strcmp(mac , sta->mac)==0) {
	    printf("mac match!!,in %s\n",ifName);
	    ret =1 ;
	    break;
	}
    }
    free_sta_list(sta_list);
    
    return ret;
}

/****************************************************************************
 *									     *
 *	checkMacAddress() - check the format of MAC			     *
 *	    if format error ,return -1					     *
 *	    if format correct ,mode = 0 convert lowcase to uppercase         *
 *			      ,mode = 1 convert uppercase to lowcase	     *
 *                                                                           *
 ****************************************************************************/
int checkMacAddress(char *mac ,int mode)
{
    char tmp[18];
    int i;
    if((strlen(mac)==17)) {
	strcpy(tmp,mac);
	for(i=0;i<17;i++) {

	    if(mode ==0) {
		if(((tmp[i]>='0')&&(tmp[i]<='9')) || ((tmp[i]>='A')&&(tmp[i]<='F')))
		    continue;
		else if((tmp[i]>='a')&&(tmp[i]<='f')) {
		    *(mac+i) = tmp[i]-' '; // convert lowcase to uppercase , in order to write into configuration
		    continue;
		}
		else if ((i == 2 )||(i==5)|| (i==8)|| (i==11)|| (i==14))
		    continue;
		else
		    return -1;
	    }
	    else if(mode ==1) {
		if(((tmp[i]>='0')&&(tmp[i]<='9')) || ((tmp[i]>='a')&&(tmp[i]<='f')))
		    continue;
		else if((tmp[i]>='A')&&(tmp[i]<='F')) {
		    *(mac+i) = tmp[i]+' '; // convert uppercase to lowcase , in order to compare with other
		    continue;
		}
		else if ((i == 2 )||(i==5)|| (i==8)|| (i==11)|| (i==14))
		    continue;
		else
		    return -1;
	    }
	}
	return 0;
    }
    return -1;
}

/****************************************************************************
 *									     *
 *  chd_handler() - prevent the child process to become zombie		     *
 *                                                                           *
 ****************************************************************************/
void chd_handler(int signum, siginfo_t *info, void *context)
{
    pid_t pid;
    int status;
    pid = wait(&status);
    printf("Child process %d terminated\n", pid);
    if (info->si_code == CLD_DUMPED) {
        /* Segmentation fault */
        printf("Child process segmentation fault\n");
    } else if (info->si_code == CLD_EXITED && WEXITSTATUS(status) != 0) {
        /* Exit failure */
    } else {
        printf("Exit normally\n");
    }

}
/****************************************************************************
 *									     *
 * a300_conf_init_handler() - while getting  SIGUSR2 signal , set a flag     *
 *			      to remind doing cipcfg initialization	     *
 *                                                                           *
 ****************************************************************************/
void a300_conf_init_handler(int signum, siginfo_t *info, void *context)
{
    /* set reinit_cipcfg = 1 */
    reinit_cipcfg=1;
    printf("Get SIGUSR2!!reinit_cipcfg:%d\n",reinit_cipcfg);
}

/****************************************************************************
 *									     *
 * get_cipcfg() - check whether the flag is set , if the flag is set	     *
 *		  do init_cipcfg() for the new configuration		     *
 *                                                                           *
 ****************************************************************************/
CIPCFG * get_cipcfg()
{
    if(reinit_cipcfg) {
	printf("Start reinit cipcfg\n");
	close_cipcfg(cipcfg);
	cipcfg = init_cipcfg_f(current_config);
	reinit_cipcfg = 0;
    }
    return cipcfg;	//cipcfg is globe variable
}
