/*
 * Note: this file originally auto-generated by mib2c using
 *  : mib2c.iterate.conf 15999 2007-03-25 22:32:02Z dts12 $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "dot1dBridge.h"
#include <errno.h>
#include <sys/ioctl.h>
#include <linux/if_bridge.h>//BRCTL_GET_BRIDGES

#define MINLOADFREQ 3                       // min reload frequency in seconds      // for testing
#define NNN 64
#define FUNC_ENTER printf("Enter %s\n", __func__)
#define __libc_lock_define_initialized(a,b)
#define __libc_lock_lock(a)
#define __libc_lock_unlock(a)
#define __ioctl ioctl
#define __set_errno(a) {errno = (a);}
#define __socket socket

static unsigned long lastLoad = 0;
char *if_indextoname2(unsigned int ifindex, char *ifname);
static int br_get_version();

int br_socket_fd;

/** Initializes the dot1dBridge module */
void
init_dot1dBridge(void)
{
    /*
     * here we initialize all the tables we're planning on supporting 
     */
//    initialize_table_dot1dBasePortTable();
//    initialize_table_dot1dStpPortTable();
    initialize_table_dot1dTpFdbTable();
//    initialize_table_dot1dTpPortTable();
//    initialize_table_dot1dStaticTable();
}

//# Determine the first/last column names

/** Initialize the dot1dBasePortTable table by defining its contents and how it's structured */
#if 0
void
initialize_table_dot1dBasePortTable(void)
{
    static oid      dot1dBasePortTable_oid[] =
        { 1, 3, 6, 1, 2, 1, 17, 1, 4 };
    size_t          dot1dBasePortTable_oid_len =
        OID_LENGTH(dot1dBasePortTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;

    reg =
        netsnmp_create_handler_registration("dot1dBasePortTable",
                                            dot1dBasePortTable_handler,
                                            dot1dBasePortTable_oid,
                                            dot1dBasePortTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: dot1dBasePort */
                                     0);
    table_info->min_column = COLUMN_DOT1DBASEPORT;
    table_info->max_column = COLUMN_DOT1DBASEPORTMTUEXCEEDEDDISCARDS;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = dot1dBasePortTable_get_first_data_point;
    iinfo->get_next_data_point = dot1dBasePortTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */
}

    /*
     * Typical data structure for a row entry 
     */
struct dot1dBasePortTable_entry {
    /*
     * Index values 
     */
    long            dot1dBasePort;

    /*
     * Column values 
     */
    long            dot1dBasePortIfIndex;
    oid             dot1dBasePortCircuit[NNN];
    size_t          dot1dBasePortCircuit_len;
    u_long          dot1dBasePortDelayExceededDiscards;
    u_long          dot1dBasePortMtuExceededDiscards;

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct dot1dBasePortTable_entry *next;
};

struct dot1dBasePortTable_entry *dot1dBasePortTable_head;

/*
 * create a new row in the (unsorted) table 
 */
struct dot1dBasePortTable_entry *
dot1dBasePortTable_createEntry(long dot1dBasePort)
{
    struct dot1dBasePortTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(struct dot1dBasePortTable_entry);
    if (!entry)
        return NULL;

    entry->dot1dBasePort = dot1dBasePort;
    entry->next = dot1dBasePortTable_head;
    dot1dBasePortTable_head = entry;
    return entry;
}

/*
 * remove a row from the table 
 */
void
dot1dBasePortTable_removeEntry(struct dot1dBasePortTable_entry *entry)
{
    struct dot1dBasePortTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = dot1dBasePortTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        dot1dBasePortTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}


/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
dot1dBasePortTable_get_first_data_point(void **my_loop_context,
                                        void **my_data_context,
                                        netsnmp_variable_list *
                                        put_index_data,
                                        netsnmp_iterator_info *mydata)
{
    *my_loop_context = dot1dBasePortTable_head;
    return dot1dBasePortTable_get_next_data_point(my_loop_context,
                                                  my_data_context,
                                                  put_index_data, mydata);
}

netsnmp_variable_list *
dot1dBasePortTable_get_next_data_point(void **my_loop_context,
                                       void **my_data_context,
                                       netsnmp_variable_list *
                                       put_index_data,
                                       netsnmp_iterator_info *mydata)
{
    struct dot1dBasePortTable_entry *entry =
        (struct dot1dBasePortTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER, entry->dot1dBasePort);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the dot1dBasePortTable table */
int
dot1dBasePortTable_handler(netsnmp_mib_handler *handler,
                           netsnmp_handler_registration *reginfo,
                           netsnmp_agent_request_info *reqinfo,
                           netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct dot1dBasePortTable_entry *table_entry;

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct dot1dBasePortTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_DOT1DBASEPORT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->dot1dBasePort);
                break;
            case COLUMN_DOT1DBASEPORTIFINDEX:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           dot1dBasePortIfIndex);
                break;
            case COLUMN_DOT1DBASEPORTCIRCUIT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OBJECT_ID,
                                         (u_char *) table_entry->
                                         dot1dBasePortCircuit,
                                         table_entry->
                                         dot1dBasePortCircuit_len);
                break;
            case COLUMN_DOT1DBASEPORTDELAYEXCEEDEDDISCARDS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_COUNTER,
                                           table_entry->
                                           dot1dBasePortDelayExceededDiscards);
                break;
            case COLUMN_DOT1DBASEPORTMTUEXCEEDEDDISCARDS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_COUNTER,
                                           table_entry->
                                           dot1dBasePortMtuExceededDiscards);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}
#endif

//# Determine the first/last column names

/** Initialize the dot1dStpPortTable table by defining its contents and how it's structured */
#if 0
void
initialize_table_dot1dStpPortTable(void)
{
    static oid      dot1dStpPortTable_oid[] =
        { 1, 3, 6, 1, 2, 1, 17, 2, 15 };
    size_t          dot1dStpPortTable_oid_len =
        OID_LENGTH(dot1dStpPortTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;

    reg =
        netsnmp_create_handler_registration("dot1dStpPortTable",
                                            dot1dStpPortTable_handler,
                                            dot1dStpPortTable_oid,
                                            dot1dStpPortTable_oid_len,
                                            HANDLER_CAN_RWRITE);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: dot1dStpPort */
                                     0);
    table_info->min_column = COLUMN_DOT1DSTPPORT;
    table_info->max_column = COLUMN_DOT1DSTPPORTFORWARDTRANSITIONS;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = dot1dStpPortTable_get_first_data_point;
    iinfo->get_next_data_point = dot1dStpPortTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */
}

    /*
     * Typical data structure for a row entry 
     */
struct dot1dStpPortTable_entry {
    /*
     * Index values 
     */
//    long            dot1dStpPort;

    /*
     * Column values 
     */
    long            dot1dStpPort;
    long            dot1dStpPortPriority;
    long            old_dot1dStpPortPriority;
    long            dot1dStpPortState;
    long            dot1dStpPortEnable;
    long            old_dot1dStpPortEnable;
    long            dot1dStpPortPathCost;
    long            old_dot1dStpPortPathCost;
    char            dot1dStpPortDesignatedRoot[NNN];
    size_t          dot1dStpPortDesignatedRoot_len;
    long            dot1dStpPortDesignatedCost;
    char            dot1dStpPortDesignatedBridge[NNN];
    size_t          dot1dStpPortDesignatedBridge_len;
    char            dot1dStpPortDesignatedPort[NNN];
    size_t          dot1dStpPortDesignatedPort_len;
    u_long          dot1dStpPortForwardTransitions;

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct dot1dStpPortTable_entry *next;
};

struct dot1dStpPortTable_entry *dot1dStpPortTable_head;

/*
 * create a new row in the (unsorted) table 
 */
struct dot1dStpPortTable_entry *
dot1dStpPortTable_createEntry(long dot1dStpPort,)
{
    struct dot1dStpPortTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(struct dot1dStpPortTable_entry);
    if (!entry)
        return NULL;

    entry->dot1dStpPort = dot1dStpPort;
    entry->next = dot1dStpPortTable_head;
    dot1dStpPortTable_head = entry;
    return entry;
}

/*
 * remove a row from the table 
 */
void
dot1dStpPortTable_removeEntry(struct dot1dStpPortTable_entry *entry)
{
    struct dot1dStpPortTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = dot1dStpPortTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        dot1dStpPortTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}


/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
dot1dStpPortTable_get_first_data_point(void **my_loop_context,
                                       void **my_data_context,
                                       netsnmp_variable_list *
                                       put_index_data,
                                       netsnmp_iterator_info *mydata)
{
    *my_loop_context = dot1dStpPortTable_head;
    return dot1dStpPortTable_get_next_data_point(my_loop_context,
                                                 my_data_context,
                                                 put_index_data, mydata);
}

netsnmp_variable_list *
dot1dStpPortTable_get_next_data_point(void **my_loop_context,
                                      void **my_data_context,
                                      netsnmp_variable_list *
                                      put_index_data,
                                      netsnmp_iterator_info *mydata)
{
    struct dot1dStpPortTable_entry *entry =
        (struct dot1dStpPortTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER, entry->dot1dStpPort);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the dot1dStpPortTable table */
int
dot1dStpPortTable_handler(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info *reqinfo,
                          netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct dot1dStpPortTable_entry *table_entry;

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct dot1dStpPortTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_DOT1DSTPPORT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->dot1dStpPort);
                break;
            case COLUMN_DOT1DSTPPORTPRIORITY:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           dot1dStpPortPriority);
                break;
            case COLUMN_DOT1DSTPPORTSTATE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->dot1dStpPortState);
                break;
            case COLUMN_DOT1DSTPPORTENABLE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           dot1dStpPortEnable);
                break;
            case COLUMN_DOT1DSTPPORTPATHCOST:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           dot1dStpPortPathCost);
                break;
            case COLUMN_DOT1DSTPPORTDESIGNATEDROOT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         dot1dStpPortDesignatedRoot,
                                         table_entry->
                                         dot1dStpPortDesignatedRoot_len);
                break;
            case COLUMN_DOT1DSTPPORTDESIGNATEDCOST:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           dot1dStpPortDesignatedCost);
                break;
            case COLUMN_DOT1DSTPPORTDESIGNATEDBRIDGE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         dot1dStpPortDesignatedBridge,
                                         table_entry->
                                         dot1dStpPortDesignatedBridge_len);
                break;
            case COLUMN_DOT1DSTPPORTDESIGNATEDPORT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         dot1dStpPortDesignatedPort,
                                         table_entry->
                                         dot1dStpPortDesignatedPort_len);
                break;
            case COLUMN_DOT1DSTPPORTFORWARDTRANSITIONS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_COUNTER,
                                           table_entry->
                                           dot1dStpPortForwardTransitions);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

        /*
         * Write-support
         */
    case MODE_SET_RESERVE1:
        for (request = requests; request; request = request->next) {
            table_entry = (struct dot1dStpPortTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_DOT1DSTPPORTPRIORITY:
                /*
                 * or possibly 'netsnmp_check_vb_int_range' 
                 */
                ret = netsnmp_check_vb_int(request->requestvb);
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            case COLUMN_DOT1DSTPPORTENABLE:
                /*
                 * or possibly 'netsnmp_check_vb_int_range' 
                 */
                ret = netsnmp_check_vb_int(request->requestvb);
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            case COLUMN_DOT1DSTPPORTPATHCOST:
                /*
                 * or possibly 'netsnmp_check_vb_int_range' 
                 */
                ret = netsnmp_check_vb_int(request->requestvb);
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_ERR_NOTWRITABLE);
                return SNMP_ERR_NOERROR;
            }
        }
        break;

    case MODE_SET_RESERVE2:
        break;

    case MODE_SET_FREE:
        break;

    case MODE_SET_ACTION:
        for (request = requests; request; request = request->next) {
            table_entry = (struct dot1dStpPortTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_DOT1DSTPPORTPRIORITY:
                table_entry->old_dot1dStpPortPriority =
                    table_entry->dot1dStpPortPriority;
                table_entry->dot1dStpPortPriority =
                    *request->requestvb->val.integer;
                break;
            case COLUMN_DOT1DSTPPORTENABLE:
                table_entry->old_dot1dStpPortEnable =
                    table_entry->dot1dStpPortEnable;
                table_entry->dot1dStpPortEnable =
                    *request->requestvb->val.integer;
                break;
            case COLUMN_DOT1DSTPPORTPATHCOST:
                table_entry->old_dot1dStpPortPathCost =
                    table_entry->dot1dStpPortPathCost;
                table_entry->dot1dStpPortPathCost =
                    *request->requestvb->val.integer;
                break;
            }
        }
        break;

    case MODE_SET_UNDO:
        for (request = requests; request; request = request->next) {
            table_entry = (struct dot1dStpPortTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_DOT1DSTPPORTPRIORITY:
                table_entry->dot1dStpPortPriority =
                    table_entry->old_dot1dStpPortPriority;
                table_entry->old_dot1dStpPortPriority = 0;
                break;
            case COLUMN_DOT1DSTPPORTENABLE:
                table_entry->dot1dStpPortEnable =
                    table_entry->old_dot1dStpPortEnable;
                table_entry->old_dot1dStpPortEnable = 0;
                break;
            case COLUMN_DOT1DSTPPORTPATHCOST:
                table_entry->dot1dStpPortPathCost =
                    table_entry->old_dot1dStpPortPathCost;
                table_entry->old_dot1dStpPortPathCost = 0;
                break;
            }
        }
        break;

    case MODE_SET_COMMIT:
        break;
    }
    return SNMP_ERR_NOERROR;
}

# Determine the first/last column names
#endif
/** Initialize the dot1dTpFdbTable table by defining its contents and how it's structured */
void
initialize_table_dot1dTpFdbTable(void)
{
    static oid      dot1dTpFdbTable_oid[] = { 1, 3, 6, 1, 2, 1, 17, 4, 3 };
    size_t          dot1dTpFdbTable_oid_len =
        OID_LENGTH(dot1dTpFdbTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;
    reg =
        netsnmp_create_handler_registration("dot1dTpFdbTable",
                                            dot1dTpFdbTable_handler,
                                            dot1dTpFdbTable_oid,
                                            dot1dTpFdbTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_PRIV_IMPLIED_OCTET_STR, /* index: dot1dTpFdbAddress */
                                     0);
    table_info->min_column = COLUMN_DOT1DTPFDBADDRESS;
    table_info->max_column = COLUMN_DOT1DTPFDBSTATUS;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = dot1dTpFdbTable_get_first_data_point;
    iinfo->get_next_data_point = dot1dTpFdbTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */
    dot1dTpFdbTable_loadData();
}

    /*
     * Typical data structure for a row entry 
     */
struct dot1dTpFdbTable_entry {
    /*
     * Index values 
     */
    char            dot1dTpFdbAccIndex[7];

    /*
     * Column values 
     */
    char            dot1dTpFdbAddress[18];
    size_t          dot1dTpFdbAddress_len;
    long            dot1dTpFdbPort;
    long            dot1dTpFdbStatus;

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct dot1dTpFdbTable_entry *next;
};

struct dot1dTpFdbTable_entry *dot1dTpFdbTable_head;

int dot1dTpFdbTable_loadData(){
    int err;
    struct timeval et;
    FUNC_ENTER; 
    gettimeofday ( &et, ( struct timezone * ) 0 );  // get time-of-day

    if ( et.tv_sec < lastLoad + MINLOADFREQ ) {       // only reload so often
        printf("Time too close to reach the table.\n");
        return; // prevent from fileIndex setting to zero
    }
    lastLoad = et.tv_sec;

    dot1dTpFdbTable_flushLists();
    if ((br_socket_fd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
            return errno;

    if (br_get_version() != BRCTL_VERSION)
            return 12345;

    if ((err = br_make_fdb_list()) != 0)
            return err;
    close(br_socket_fd);

    return 0;

}

void calculateIndex2(char *checkmac, char *dot1dTpFdbAccIndex)
{
    char *strtmp1, *strtmp2;
    int i;

    strtmp1 = strtok_r(checkmac, ":", &strtmp2);
    for (i = 0;i < 6; i++) {
        if (isdigit(strtmp1[0]))
            dot1dTpFdbAccIndex[i] = (strtmp1[0] - '0') * 16;
        else
            dot1dTpFdbAccIndex[i] = ((toupper(strtmp1[0]) - 'A') +10) * 16;
        if (isdigit(strtmp1[1]))
            dot1dTpFdbAccIndex[i] += strtmp1[1] - '0';
        else
            dot1dTpFdbAccIndex[i] += toupper(strtmp1[1]) - 'A' + 10;
        strtmp1 = strtok_r(NULL, ":", &strtmp2);
    }
}


/*
 * create a new row in the (unsorted) table 
 */
struct dot1dTpFdbTable_entry *
dot1dTpFdbTable_createEntry(unsigned char *dot1dTpFdbAddress,
			    long dot1dTpFdbPort,
			    long dot1dTpFdbStatus)
{
    struct dot1dTpFdbTable_entry *entry;
    int i, j;
    char *checkmac,dot1dTpFdbAccIndex[7];
    /*
                printf("mac: %.2x:%.2x:%.2x:%.2x:%.2x:%.2x\t",
                       dot1dTpFdbAddress[0], dot1dTpFdbAddress[1], dot1dTpFdbAddress[2],
                       dot1dTpFdbAddress[3], dot1dTpFdbAddress[4], dot1dTpFdbAddress[5]);
                printf("status: %ld\t\t\n", dot1dTpFdbStatus);
    printf("port %d  status %d \n",dot1dTpFdbPort,dot1dTpFdbStatus); 
    */
    entry = SNMP_MALLOC_TYPEDEF(struct dot1dTpFdbTable_entry);
    if (!entry)
        return NULL;
    sprintf(entry->dot1dTpFdbAddress, "%02X:%02X:%02X:%02X:%02X:%02X",dot1dTpFdbAddress[0], dot1dTpFdbAddress[1], dot1dTpFdbAddress[2],
                       dot1dTpFdbAddress[3], dot1dTpFdbAddress[4], dot1dTpFdbAddress[5]);
    //printf("mac= %s \n", entry->dot1dTpFdbAddress);
    checkmac = strdup(entry->dot1dTpFdbAddress);
    //printf("checkmac:%s\n", checkmac);
    if (entry->dot1dTpFdbAddress[0] != 0) {
	calculateIndex2(checkmac, dot1dTpFdbAccIndex);
	/*
        printf("dot1dTpFdbAccIndex=");
        for (j = 0; j < 6; j++)
	    printf("%X ", dot1dTpFdbAccIndex[j]);
        printf("\n");
	*/
    }
    free(checkmac);
    memcpy(entry->dot1dTpFdbAccIndex, dot1dTpFdbAccIndex, 6);
    /*
    printf("entry->dot1dTpFdbAccIndex=");
    for (i = 0; i < 6; i++)
        printf("%x ", entry->dot1dTpFdbAccIndex[i]);
    printf("\n");
    */
    entry->dot1dTpFdbAddress_len = strlen(entry->dot1dTpFdbAddress);

    entry->dot1dTpFdbPort = dot1dTpFdbPort;
    entry->dot1dTpFdbStatus = dot1dTpFdbStatus;
    entry->next = dot1dTpFdbTable_head;
    dot1dTpFdbTable_head = entry;
    return entry;
}

/*
 * remove a row from the table 
 */
void
dot1dTpFdbTable_removeEntry(struct dot1dTpFdbTable_entry *entry)
{
    struct dot1dTpFdbTable_entry *ptr, *prev;
    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = dot1dTpFdbTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        dot1dTpFdbTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}


/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
dot1dTpFdbTable_get_first_data_point(void **my_loop_context,
                                     void **my_data_context,
                                     netsnmp_variable_list *
                                     put_index_data,
                                     netsnmp_iterator_info *mydata)
{
    dot1dTpFdbTable_loadData();
    *my_loop_context = dot1dTpFdbTable_head;
    return dot1dTpFdbTable_get_next_data_point(my_loop_context,
                                               my_data_context,
                                               put_index_data, mydata);
}

netsnmp_variable_list *
dot1dTpFdbTable_get_next_data_point(void **my_loop_context,
                                    void **my_data_context,
                                    netsnmp_variable_list * put_index_data,
                                    netsnmp_iterator_info *mydata)
{
    struct dot1dTpFdbTable_entry *entry =
        (struct dot1dTpFdbTable_entry *) *my_loop_context;

    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
	snmp_set_var_typed_value(idx, ASN_PRIV_IMPLIED_OCTET_STR, entry->dot1dTpFdbAccIndex, 6);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the dot1dTpFdbTable table */
int
dot1dTpFdbTable_handler(netsnmp_mib_handler *handler,
                        netsnmp_handler_registration *reginfo,
                        netsnmp_agent_request_info *reqinfo,
                        netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct dot1dTpFdbTable_entry *table_entry;
    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct dot1dTpFdbTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_DOT1DTPFDBADDRESS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         dot1dTpFdbAddress,
                                         table_entry->
                                         dot1dTpFdbAddress_len);
                break;
            case COLUMN_DOT1DTPFDBPORT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->dot1dTpFdbPort);
                break;
            case COLUMN_DOT1DTPFDBSTATUS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->dot1dTpFdbStatus);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

void dot1dTpFdbTable_flushLists()
{
    struct dot1dTpFdbTable_entry *next, *entry = dot1dTpFdbTable_head;
    while (entry) {
        next = entry->next;
        dot1dTpFdbTable_removeEntry(entry);
        entry = next;
    }
}

static int br_ioctl32(unsigned long arg0, unsigned long arg1, unsigned long arg2)
{
        unsigned long arg[3];

        arg[0] = arg0;
        arg[1] = arg1;
        arg[2] = arg2;

        return ioctl(br_socket_fd, SIOCGIFBR, arg);
}

static int br_ioctl(unsigned long arg0, unsigned long arg1, unsigned long arg2)
{

        return br_ioctl32(arg0, arg1, arg2);
}

static int br_device_ioctl32(struct bridge_info *br, unsigned long arg0,
                                          unsigned long arg1, unsigned long arg2,
                                          unsigned long arg3)
{
    unsigned long args[4];
    struct ifreq ifr;

    args[0] = arg0;
    args[1] = arg1;
    args[2] = arg2;
    args[3] = arg3;

    memcpy(ifr.ifr_name, br->ifName, IFNAMSIZ);
    ((unsigned long *) (&ifr.ifr_data))[0] = (unsigned long) args;

    return ioctl(br_socket_fd, SIOCDEVPRIVATE, &ifr);
}

int br_get_version()
{
    return br_ioctl(BRCTL_GET_VERSION, 0, 0);
}


#ifdef BRCTL_GET_FDB_ENTRIES2  // define in linux 2.6.27.41 if_bridge.h
int br_make_fdb_list()
{
    int err;
    int ifindices[32];
    int num;
    int i, n;
    struct fdb_userinfo *fdb = NULL;
    int offset, total_offset = 0;
    num = br_ioctl(BRCTL_GET_BRIDGES, (unsigned long) ifindices, 32);
    //printf("num:%d\n",num);
    if (num < 0)
        return errno;

    for (i = 0; i < num; i++) {
        initBrStructs();
        nBr.ifIndex = ifindices[i];

	if (if_indextoname2(br->ifIndex, br->ifName) == NULL){
	    printf("get name fail\n");
	    return 1;
	}
	//printf("get bridge name =%s\n",br->ifName);
#define CHUNK 128
        for(offset = 0;;) {
            fdb = realloc(fdb, (offset + CHUNK) * sizeof(struct fdb_userinfo));
            if (!fdb) {
                fprintf(stderr, "Out of memory\n");
                return 1;
            }

	    n = br_read_fdb(br->ifName, fdb+total_offset, offset, CHUNK);
            if (n == 0)
                break;

            if (n < 0) {
                fprintf(stderr, "read of forward table failed: %s\n",
                strerror(errno));
                return 1;
            }

            offset += n;
	    total_offset += offset;
        }
    }

    qsort(fdb, total_offset, sizeof(struct fdb_userinfo), compare_fdbs);

    for (i = 0; i < total_offset; i++) {
        const struct fdb_userinfo *f = fdb + i;
	if (f->is_local) continue;
	dot1dTpFdbTable_createEntry(f->mac_addr, f->vlan_id, f->is_local?4:3);
    }

    free(fdb);
    return 0;
error_out:

    return err;
}

#else

int br_make_fdb_list()
{
    int err;
    int ifindices[32];
    int num;
    int i, n;
    struct fdb_entry *fdb = NULL;
    int offset, total_offset = 0;
    num = br_ioctl(BRCTL_GET_BRIDGES, (unsigned long) ifindices, 32);
    if (num < 0)
        return errno;

    for (i = 0; i < num; i++) {
        initBrStructs();
        nBr.ifIndex = ifindices[i];

	if (if_indextoname2(br->ifIndex, br->ifName) == NULL){
	    printf("get name fail\n");
	    return 1;
	}
	//printf("get bridge name =%s\n",br->ifName);
#define CHUNK 128
	for(offset = 0;;) {
            fdb = realloc(fdb, (total_offset + CHUNK) * sizeof(struct fdb_entry));
            if (!fdb) {
                fprintf(stderr, "Out of memory\n");
                return 1;
            }

            n = br_read_fdb(br->ifName, fdb+total_offset, offset, CHUNK);
            if (n == 0)
                break;

            if (n < 0) {
		fprintf(stderr, "read of forward table failed: %s\n",
                strerror(errno));
                return 1;
            }

            offset += n;
	    total_offset += offset;
	}
    }
	
    qsort(fdb, total_offset, sizeof(struct fdb_entry), compare_fdbs);

    for (i = 0; i < total_offset; i++) {
	const struct fdb_entry *f = fdb + i;
	if (f->is_local) continue;
	dot1dTpFdbTable_createEntry(f->mac_addr, 0, f->is_local?4:3);
    }
    free(fdb);
    return 0;

error_out:

    return err;
}


#endif

/****************************************************************************
 *                                                                           *
 *                     initStructs() - initialize structures                 *
 *                                                                           *
 ****************************************************************************/
static void initBrStructs()
{
    memset (( char * ) &nBr, 0, sizeof ( nBr ));
}

/* Try to get a socket to talk to the kernel.  */
#if defined SIOCGIFINDEX || defined SIOCGIFNAME
static int opensock(void)
{
        /* Cache the last AF that worked, to avoid many redundant calls to
           socket().  */
        static int sock_af = -1;
        int fd = -1;
        __libc_lock_define_initialized(static, lock);

        if (sock_af != -1) {
                fd = __socket(sock_af, SOCK_DGRAM, 0);
                if (fd != -1)
                        return fd;
        }

        __libc_lock_lock(lock);

        if (sock_af != -1)
                fd = __socket(sock_af, SOCK_DGRAM, 0);

        if (fd == -1) {
                fd = __socket(sock_af = AF_INET6, SOCK_DGRAM, 0);
                if (fd < 0)
                        fd = __socket(sock_af = AF_INET, SOCK_DGRAM, 0);
                if (fd < 0)
                        fd = __socket(sock_af = AF_IPX, SOCK_DGRAM, 0);
                if (fd < 0)
                        fd = __socket(sock_af = AF_AX25, SOCK_DGRAM, 0);
                if (fd < 0)
                        fd = __socket(sock_af = AF_APPLETALK, SOCK_DGRAM, 0);
        }

        __libc_lock_unlock(lock);
        return fd;
}
#endif

/*****************************************************************************
 *                                                                           *
 *                   if_indextoname2() - convert index of the interface to    *
 *                                      the name of the interface            *
 *                                                                           *
 ****************************************************************************/
char *if_indextoname2(unsigned int ifindex, char *ifname)
{
#ifndef SIOCGIFINDEX
        __set_errno(ENOSYS);
        return NULL;
#else
        struct if_nameindex *idx;
        struct if_nameindex *p;
        char *result = NULL;

#ifdef SIOCGIFNAME
        /* We may be able to do the conversion directly, rather than searching a
           list.  This ioctl is not present in kernels before version 2.1.50.  */
        struct ifreq ifr;
        int fd;
        static int siocgifname_works_not;

        if (!siocgifname_works_not) {
                int serrno = errno;

                fd = opensock();

                if (fd < 0)
                        return NULL;

                ifr.ifr_ifindex = ifindex;
                if (__ioctl(fd, SIOCGIFNAME, &ifr) < 0) {
                        if (errno == EINVAL)
                                siocgifname_works_not = 1;      /* Don't make the same mistake twice. */
                } else {
                        close(fd);
                        return strncpy(ifname, ifr.ifr_name, IFNAMSIZ);
                }

                close(fd);

                __set_errno(serrno);
        }
#endif

        idx = if_nameindex();

        if (idx != NULL) {
                for (p = idx; p->if_index || p->if_name; ++p)
                        if (p->if_index == ifindex) {
                                result = strncpy(ifname, p->if_name, IFNAMSIZ);
                                break;
                        }

                if_freenameindex(idx);
        }
        return result;
#endif
}

static int compare_fdbs(const void *_f0, const void *_f1)
{
    const struct fdb_entry *f0 = _f0;
    const struct fdb_entry *f1 = _f1;

    return memcmp(f0->mac_addr, f1->mac_addr, 6);
}

#ifdef BRCTL_GET_FDB_ENTRIES2
static inline void __copy_fdb(struct fdb_userinfo *ent,
                              const  struct fdb_userinfo *f)
{
    memcpy(ent->mac_addr, f->mac_addr, 6);
    memcpy(ent->ifname, f->ifname, 16);
    ent->port_no = f->port_no;
    ent->is_local = f->is_local;
    ent->vlan_id = f->vlan_id;
    ent->ageing_timer_value = f->ageing_timer_value;
}

int br_read_fdb(const char *bridge, struct fdb_userinfo *fdbs,
                unsigned long offset, int num)
{
        int i, fd = -1, n;
        struct fdb_userinfo fe1[num];
        {
                /* old kernel, use ioctl */
                unsigned long args[4] = { BRCTL_GET_FDB_ENTRIES2,
                                          (unsigned long) fe1,
                                          num, offset };
                struct ifreq ifr;
                int retries = 0;

                strncpy(ifr.ifr_name, bridge, IFNAMSIZ);
                ifr.ifr_data = (char *) args;

        retry:
                n = ioctl(br_socket_fd, SIOCDEVPRIVATE, &ifr);

                /* table can change during ioctl processing */
                if (n < 0 && errno == EAGAIN && ++retries < 10) {
                        sleep(0);
                        goto retry;
                }
        }


        for (i = 0; i < n; i++){
                __copy_fdb(fdbs+i, fe1+i);
        }


        if (fd > 0)
                close(fd);

        return n;
}

#else

static inline void __copy_fdb(struct fdb_entry *ent,
                              const struct __fdb_entry *f)
{
        memcpy(ent->mac_addr, f->mac_addr, sizeof(struct fdb_entry));
    //    __jiffies_to_tv(&ent->ageing_timer_value, f->ageing_timer_value);
}

int br_read_fdb(const char *bridge, struct fdb_entry *fdbs,
                unsigned long offset, int num)
{
        int i, fd = -1, n;
        struct __fdb_entry fe[num];
#ifdef HAVE_LIBSYSFS
        struct sysfs_class_device *dev;
	
        /* open /sys/class/net/brXXX/brforward */
        if (br_class_net &&
            (dev = sysfs_get_class_device(br_class_net, (char *) bridge))) {
                char path[SYSFS_PATH_MAX];

                snprintf(path, SYSFS_PATH_MAX, "%s/%s", dev->path,
                         SYSFS_BRIDGE_FDB);
                fd = open(path, O_RDONLY, 0);
        }

        if (fd != -1) {
                /* read records from file */
                lseek(fd, offset*sizeof(struct __fdb_entry), SEEK_SET);
                n = read(fd, fe, num*sizeof(struct __fdb_entry));
                if (n > 0)
                        n /= sizeof(struct __fdb_entry);
        } else
#endif
        {
                /* old kernel, use ioctl */
                unsigned long args[4] = { BRCTL_GET_FDB_ENTRIES,
                                          (unsigned long) fe,
                                          num, offset };
                struct ifreq ifr;
                int retries = 0;

                strncpy(ifr.ifr_name, bridge, IFNAMSIZ);
                ifr.ifr_data = (char *) args;

        retry:
                n = ioctl(br_socket_fd, SIOCDEVPRIVATE, &ifr);

                /* table can change during ioctl processing */
                if (n < 0 && errno == EAGAIN && ++retries < 10) {
                        sleep(0);
                        goto retry;
                }
        }

        for (i = 0; i < n; i++)
                __copy_fdb(fdbs+i, fe+i);

        if (fd > 0)
                close(fd);

        return n;
}
#endif

//# Determine the first/last column names
#if 0
/** Initialize the dot1dTpPortTable table by defining its contents and how it's structured */
void
initialize_table_dot1dTpPortTable(void)
{
    static oid      dot1dTpPortTable_oid[] =
        { 1, 3, 6, 1, 2, 1, 17, 4, 4 };
    size_t          dot1dTpPortTable_oid_len =
        OID_LENGTH(dot1dTpPortTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;

    reg =
        netsnmp_create_handler_registration("dot1dTpPortTable",
                                            dot1dTpPortTable_handler,
                                            dot1dTpPortTable_oid,
                                            dot1dTpPortTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: dot1dTpPort */
                                     0);
    table_info->min_column = COLUMN_DOT1DTPPORT;
    table_info->max_column = COLUMN_DOT1DTPPORTINDISCARDS;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = dot1dTpPortTable_get_first_data_point;
    iinfo->get_next_data_point = dot1dTpPortTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */
}

    /*
     * Typical data structure for a row entry 
     */
struct dot1dTpPortTable_entry {
    /*
     * Index values 
     */
//    long            dot1dTpPort;

    /*
     * Column values 
     */
    long            dot1dTpPort;
    long            dot1dTpPortMaxInfo;
    u_long          dot1dTpPortInFrames;
    u_long          dot1dTpPortOutFrames;
    u_long          dot1dTpPortInDiscards;

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct dot1dTpPortTable_entry *next;
};

struct dot1dTpPortTable_entry *dot1dTpPortTable_head;

/*
 * create a new row in the (unsorted) table 
 */
struct dot1dTpPortTable_entry *
dot1dTpPortTable_createEntry(long dot1dTpPort)
{
    struct dot1dTpPortTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(struct dot1dTpPortTable_entry);
    if (!entry)
        return NULL;

    entry->dot1dTpPort = dot1dTpPort;
    entry->next = dot1dTpPortTable_head;
    dot1dTpPortTable_head = entry;
    return entry;
}

/*
 * remove a row from the table 
 */
void
dot1dTpPortTable_removeEntry(struct dot1dTpPortTable_entry *entry)
{
    struct dot1dTpPortTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = dot1dTpPortTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        dot1dTpPortTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}


/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
dot1dTpPortTable_get_first_data_point(void **my_loop_context,
                                      void **my_data_context,
                                      netsnmp_variable_list *
                                      put_index_data,
                                      netsnmp_iterator_info *mydata)
{
    *my_loop_context = dot1dTpPortTable_head;
    return dot1dTpPortTable_get_next_data_point(my_loop_context,
                                                my_data_context,
                                                put_index_data, mydata);
}

netsnmp_variable_list *
dot1dTpPortTable_get_next_data_point(void **my_loop_context,
                                     void **my_data_context,
                                     netsnmp_variable_list *
                                     put_index_data,
                                     netsnmp_iterator_info *mydata)
{
    struct dot1dTpPortTable_entry *entry =
        (struct dot1dTpPortTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_typed_integer(idx, ASN_INTEGER, entry->dot1dTpPort);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the dot1dTpPortTable table */
int
dot1dTpPortTable_handler(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct dot1dTpPortTable_entry *table_entry;

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct dot1dTpPortTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_DOT1DTPPORT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->dot1dTpPort);
                break;
            case COLUMN_DOT1DTPPORTMAXINFO:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           dot1dTpPortMaxInfo);
                break;
            case COLUMN_DOT1DTPPORTINFRAMES:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_COUNTER,
                                           table_entry->
                                           dot1dTpPortInFrames);
                break;
            case COLUMN_DOT1DTPPORTOUTFRAMES:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_COUNTER,
                                           table_entry->
                                           dot1dTpPortOutFrames);
                break;
            case COLUMN_DOT1DTPPORTINDISCARDS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_COUNTER,
                                           table_entry->
                                           dot1dTpPortInDiscards);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

//# Determine the first/last column names

/** Initialize the dot1dStaticTable table by defining its contents and how it's structured */
void
initialize_table_dot1dStaticTable(void)
{
    static oid      dot1dStaticTable_oid[] =
        { 1, 3, 6, 1, 2, 1, 17, 5, 1 };
    size_t          dot1dStaticTable_oid_len =
        OID_LENGTH(dot1dStaticTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_iterator_info *iinfo;
    netsnmp_table_registration_info *table_info;

    reg =
        netsnmp_create_handler_registration("dot1dStaticTable",
                                            dot1dStaticTable_handler,
                                            dot1dStaticTable_oid,
                                            dot1dStaticTable_oid_len,
                                            HANDLER_CAN_RWRITE);

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    netsnmp_table_helper_add_indexes(table_info, ASN_OCTET_STR, /* index: dot1dStaticAddress */
                                     ASN_INTEGER,       /* index: dot1dStaticReceivePort */
                                     0);
    table_info->min_column = COLUMN_DOT1DSTATICADDRESS;
    table_info->max_column = COLUMN_DOT1DSTATICSTATUS;

    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);
    iinfo->get_first_data_point = dot1dStaticTable_get_first_data_point;
    iinfo->get_next_data_point = dot1dStaticTable_get_next_data_point;
    iinfo->table_reginfo = table_info;

    netsnmp_register_table_iterator(reg, iinfo);

    /*
     * Initialise the contents of the table here 
     */
}

    /*
     * Typical data structure for a row entry 
     */
struct dot1dStaticTable_entry {
    /*
     * Index values 
     */
//    char            dot1dStaticAddress[NNN];
//    size_t          dot1dStaticAddress_len;
//    long            dot1dStaticReceivePort;

    /*
     * Column values 
     */
    char            dot1dStaticAddress[NNN];
    size_t          dot1dStaticAddress_len;
    char            old_dot1dStaticAddress[NNN];
    size_t          old_dot1dStaticAddress_len;
    long            dot1dStaticReceivePort;
    long            old_dot1dStaticReceivePort;
    char            dot1dStaticAllowedToGoTo[NNN];
    size_t          dot1dStaticAllowedToGoTo_len;
    char            old_dot1dStaticAllowedToGoTo[NNN];
    size_t          old_dot1dStaticAllowedToGoTo_len;
    long            dot1dStaticStatus;
    long            old_dot1dStaticStatus;

    /*
     * Illustrate using a simple linked list 
     */
    int             valid;
    struct dot1dStaticTable_entry *next;
};

struct dot1dStaticTable_entry *dot1dStaticTable_head;

/*
 * create a new row in the (unsorted) table 
 */
struct dot1dStaticTable_entry *
dot1dStaticTable_createEntry(char *dot1dStaticAddress,
                             size_t dot1dStaticAddress_len,
                             long dot1dStaticReceivePort)
{
    struct dot1dStaticTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(struct dot1dStaticTable_entry);
    if (!entry)
        return NULL;

    memcpy(entry->dot1dStaticAddress, dot1dStaticAddress,
           dot1dStaticAddress_len);
    entry->dot1dStaticAddress_len = dot1dStaticAddress_len;
    entry->dot1dStaticReceivePort = dot1dStaticReceivePort;
    entry->next = dot1dStaticTable_head;
    dot1dStaticTable_head = entry;
    return entry;
}

/*
 * remove a row from the table 
 */
void
dot1dStaticTable_removeEntry(struct dot1dStaticTable_entry *entry)
{
    struct dot1dStaticTable_entry *ptr, *prev;

    if (!entry)
        return;                 /* Nothing to remove */

    for (ptr = dot1dStaticTable_head, prev = NULL;
         ptr != NULL; prev = ptr, ptr = ptr->next) {
        if (ptr == entry)
            break;
    }
    if (!ptr)
        return;                 /* Can't find it */

    if (prev == NULL)
        dot1dStaticTable_head = ptr->next;
    else
        prev->next = ptr->next;

    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}


/*
 * Example iterator hook routines - using 'get_next' to do most of the work 
 */
netsnmp_variable_list *
dot1dStaticTable_get_first_data_point(void **my_loop_context,
                                      void **my_data_context,
                                      netsnmp_variable_list *
                                      put_index_data,
                                      netsnmp_iterator_info *mydata)
{
    *my_loop_context = dot1dStaticTable_head;
    return dot1dStaticTable_get_next_data_point(my_loop_context,
                                                my_data_context,
                                                put_index_data, mydata);
}

netsnmp_variable_list *
dot1dStaticTable_get_next_data_point(void **my_loop_context,
                                     void **my_data_context,
                                     netsnmp_variable_list *
                                     put_index_data,
                                     netsnmp_iterator_info *mydata)
{
    struct dot1dStaticTable_entry *entry =
        (struct dot1dStaticTable_entry *) *my_loop_context;
    netsnmp_variable_list *idx = put_index_data;

    if (entry) {
        snmp_set_var_value(idx, entry->dot1dStaticAddress,
                           sizeof(entry->dot1dStaticAddress));
        idx = idx->next_variable;
        snmp_set_var_typed_integer(idx, ASN_INTEGER,
                                   entry->dot1dStaticReceivePort);
        idx = idx->next_variable;
        *my_data_context = (void *) entry;
        *my_loop_context = (void *) entry->next;
        return put_index_data;
    } else {
        return NULL;
    }
}


/** handles requests for the dot1dStaticTable table */
int
dot1dStaticTable_handler(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct dot1dStaticTable_entry *table_entry;
    int ret;
    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct dot1dStaticTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_DOT1DSTATICADDRESS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         dot1dStaticAddress,
                                         table_entry->
                                         dot1dStaticAddress_len);
                break;
            case COLUMN_DOT1DSTATICRECEIVEPORT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           dot1dStaticReceivePort);
                break;
            case COLUMN_DOT1DSTATICALLOWEDTOGOTO:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         (u_char *) table_entry->
                                         dot1dStaticAllowedToGoTo,
                                         table_entry->
                                         dot1dStaticAllowedToGoTo_len);
                break;
            case COLUMN_DOT1DSTATICSTATUS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->dot1dStaticStatus);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

        /*
         * Write-support
         */
    case MODE_SET_RESERVE1:
        for (request = requests; request; request = request->next) {
            table_entry = (struct dot1dStaticTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_DOT1DSTATICADDRESS:
                /*
                 * or possiblc 'netsnmp_check_vb_type_and_size' 
                 */
                ret =
                    netsnmp_check_vb_type_and_max_size(request->requestvb,
                                                       ASN_OCTET_STR,
                                                       sizeof(table_entry->
                                                              dot1dStaticAddress));
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            case COLUMN_DOT1DSTATICRECEIVEPORT:
                /*
                 * or possibly 'netsnmp_check_vb_int_range' 
                 */
                ret = netsnmp_check_vb_int(request->requestvb);
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            case COLUMN_DOT1DSTATICALLOWEDTOGOTO:
                /*
                 * or possiblc 'netsnmp_check_vb_type_and_size' 
                 */
                ret =
                    netsnmp_check_vb_type_and_max_size(request->requestvb,
                                                       ASN_OCTET_STR,
                                                       sizeof(table_entry->
                                                              dot1dStaticAllowedToGoTo));
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            case COLUMN_DOT1DSTATICSTATUS:
                /*
                 * or possibly 'netsnmp_check_vb_int_range' 
                 */
                ret = netsnmp_check_vb_int(request->requestvb);
                if (ret != SNMP_ERR_NOERROR) {
                    netsnmp_set_request_error(reqinfo, request, ret);
                    return SNMP_ERR_NOERROR;
                }
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_ERR_NOTWRITABLE);
                return SNMP_ERR_NOERROR;
            }
        }
        break;

    case MODE_SET_RESERVE2:
        break;

    case MODE_SET_FREE:
        break;

    case MODE_SET_ACTION:
        for (request = requests; request; request = request->next) {
            table_entry = (struct dot1dStaticTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_DOT1DSTATICADDRESS:
                memcpy(table_entry->old_dot1dStaticAddress,
                       table_entry->dot1dStaticAddress,
                       sizeof(table_entry->dot1dStaticAddress));
                table_entry->old_dot1dStaticAddress_len =
                    table_entry->dot1dStaticAddress_len;
                memset(table_entry->dot1dStaticAddress, 0,
                       sizeof(table_entry->dot1dStaticAddress));
                memcpy(table_entry->dot1dStaticAddress,
                       request->requestvb->val.string,
                       request->requestvb->val_len);
                table_entry->dot1dStaticAddress_len =
                    request->requestvb->val_len;
                break;
            case COLUMN_DOT1DSTATICRECEIVEPORT:
                table_entry->old_dot1dStaticReceivePort =
                    table_entry->dot1dStaticReceivePort;
                table_entry->dot1dStaticReceivePort =
                    *request->requestvb->val.integer;
                break;
            case COLUMN_DOT1DSTATICALLOWEDTOGOTO:
                memcpy(table_entry->old_dot1dStaticAllowedToGoTo,
                       table_entry->dot1dStaticAllowedToGoTo,
                       sizeof(table_entry->dot1dStaticAllowedToGoTo));
                table_entry->old_dot1dStaticAllowedToGoTo_len =
                    table_entry->dot1dStaticAllowedToGoTo_len;
                memset(table_entry->dot1dStaticAllowedToGoTo, 0,
                       sizeof(table_entry->dot1dStaticAllowedToGoTo));
                memcpy(table_entry->dot1dStaticAllowedToGoTo,
                       request->requestvb->val.string,
                       request->requestvb->val_len);
                table_entry->dot1dStaticAllowedToGoTo_len =
                    request->requestvb->val_len;
                break;
            case COLUMN_DOT1DSTATICSTATUS:
                table_entry->old_dot1dStaticStatus =
                    table_entry->dot1dStaticStatus;
                table_entry->dot1dStaticStatus =
                    *request->requestvb->val.integer;
                break;
            }
        }
        break;

    case MODE_SET_UNDO:
        for (request = requests; request; request = request->next) {
            table_entry = (struct dot1dStaticTable_entry *)
                netsnmp_extract_iterator_context(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_DOT1DSTATICADDRESS:
                memcpy(table_entry->dot1dStaticAddress,
                       table_entry->old_dot1dStaticAddress,
                       sizeof(table_entry->dot1dStaticAddress));
                memset(table_entry->old_dot1dStaticAddress, 0,
                       sizeof(table_entry->dot1dStaticAddress));
                table_entry->dot1dStaticAddress_len =
                    table_entry->old_dot1dStaticAddress_len;
                break;
            case COLUMN_DOT1DSTATICRECEIVEPORT:
                table_entry->dot1dStaticReceivePort =
                    table_entry->old_dot1dStaticReceivePort;
                table_entry->old_dot1dStaticReceivePort = 0;
                break;
            case COLUMN_DOT1DSTATICALLOWEDTOGOTO:
                memcpy(table_entry->dot1dStaticAllowedToGoTo,
                       table_entry->old_dot1dStaticAllowedToGoTo,
                       sizeof(table_entry->dot1dStaticAllowedToGoTo));
                memset(table_entry->old_dot1dStaticAllowedToGoTo, 0,
                       sizeof(table_entry->dot1dStaticAllowedToGoTo));
                table_entry->dot1dStaticAllowedToGoTo_len =
                    table_entry->old_dot1dStaticAllowedToGoTo_len;
                break;
            case COLUMN_DOT1DSTATICSTATUS:
                table_entry->dot1dStaticStatus =
                    table_entry->old_dot1dStaticStatus;
                table_entry->old_dot1dStaticStatus = 0;
                break;
            }
        }
        break;

    case MODE_SET_COMMIT:
        break;
    }
    return SNMP_ERR_NOERROR;
}
#endif
