/*
 * Note: this file originally auto-generated by mib2c using
 *  : mib2c.iterate.conf 15999 2007-03-25 22:32:02Z dts12 $
 */
#ifndef DOT1DBRIDGE_H
#define DOT1DBRIDGE_H
#include <net/if.h>
#include <linux/if_bridge.h>
/*
 * function declarations 
 */
void            init_dot1dBridge(void);
void            initialize_table_dot1dBasePortTable(void);
Netsnmp_Node_Handler dot1dBasePortTable_handler;
Netsnmp_First_Data_Point dot1dBasePortTable_get_first_data_point;
Netsnmp_Next_Data_Point dot1dBasePortTable_get_next_data_point;
void            initialize_table_dot1dStpPortTable(void);
Netsnmp_Node_Handler dot1dStpPortTable_handler;
Netsnmp_First_Data_Point dot1dStpPortTable_get_first_data_point;
Netsnmp_Next_Data_Point dot1dStpPortTable_get_next_data_point;
void            initialize_table_dot1dTpFdbTable(void);
Netsnmp_Node_Handler dot1dTpFdbTable_handler;
Netsnmp_First_Data_Point dot1dTpFdbTable_get_first_data_point;
Netsnmp_Next_Data_Point dot1dTpFdbTable_get_next_data_point;
void            initialize_table_dot1dTpPortTable(void);
Netsnmp_Node_Handler dot1dTpPortTable_handler;
Netsnmp_First_Data_Point dot1dTpPortTable_get_first_data_point;
Netsnmp_Next_Data_Point dot1dTpPortTable_get_next_data_point;
void            initialize_table_dot1dStaticTable(void);
Netsnmp_Node_Handler dot1dStaticTable_handler;
Netsnmp_First_Data_Point dot1dStaticTable_get_first_data_point;
Netsnmp_Next_Data_Point dot1dStaticTable_get_next_data_point;

/*
 * column number definitions for table dot1dBasePortTable 
 */
#define COLUMN_DOT1DBASEPORT		1
#define COLUMN_DOT1DBASEPORTIFINDEX		2
#define COLUMN_DOT1DBASEPORTCIRCUIT		3
#define COLUMN_DOT1DBASEPORTDELAYEXCEEDEDDISCARDS		4
#define COLUMN_DOT1DBASEPORTMTUEXCEEDEDDISCARDS		5

/*
 * column number definitions for table dot1dStpPortTable 
 */
#define COLUMN_DOT1DSTPPORT		1
#define COLUMN_DOT1DSTPPORTPRIORITY		2
#define COLUMN_DOT1DSTPPORTSTATE		3
#define COLUMN_DOT1DSTPPORTENABLE		4
#define COLUMN_DOT1DSTPPORTPATHCOST		5
#define COLUMN_DOT1DSTPPORTDESIGNATEDROOT		6
#define COLUMN_DOT1DSTPPORTDESIGNATEDCOST		7
#define COLUMN_DOT1DSTPPORTDESIGNATEDBRIDGE		8
#define COLUMN_DOT1DSTPPORTDESIGNATEDPORT		9
#define COLUMN_DOT1DSTPPORTFORWARDTRANSITIONS		10

/*
 * column number definitions for table dot1dTpFdbTable 
 */
#define COLUMN_DOT1DTPFDBADDRESS		1
#define COLUMN_DOT1DTPFDBPORT		2
#define COLUMN_DOT1DTPFDBSTATUS		3

/*
 * column number definitions for table dot1dTpPortTable 
 */
#define COLUMN_DOT1DTPPORT		1
#define COLUMN_DOT1DTPPORTMAXINFO		2
#define COLUMN_DOT1DTPPORTINFRAMES		3
#define COLUMN_DOT1DTPPORTOUTFRAMES		4
#define COLUMN_DOT1DTPPORTINDISCARDS		5

/*
 * column number definitions for table dot1dStaticTable 
 */
#define COLUMN_DOT1DSTATICADDRESS		1
#define COLUMN_DOT1DSTATICRECEIVEPORT		2
#define COLUMN_DOT1DSTATICALLOWEDTOGOTO		3
#define COLUMN_DOT1DSTATICSTATUS		4

#define IFINDEX_LEN                          4
#define BR_UID_LEN IFINDEX_LEN

struct fdb_entry
{
        u_int8_t mac_addr[6];
        u_int16_t port_no;
        unsigned char is_local;
        struct timeval ageing_timer_value;
};
#ifndef BRIDGE_INFO
#define BRIDGE_INFO

struct bridge_id {
        unsigned char prio[2];
        unsigned char addr[6];
};

static struct bridge_info {

        char  UID       [ BR_UID_LEN + 1 ];               // unique ID
        char  ifName[IFNAMSIZ];
        long  ifIndex;

        long  stpSpecification;
        long  priority;
        struct bridge_id designated_root;
        struct bridge_id bridge_id;
        int root_path_cost;
        struct timeval max_age;
        struct timeval hello_time;
        int hold_time;
        struct timeval forward_delay;
        struct timeval bridge_max_age;
        struct timeval bridge_hello_time;
        struct timeval bridge_forward_delay;
        unsigned topology_change:1;
        unsigned topology_change_detected:1;
        int root_port;
        unsigned stp_enabled:1;
        struct timeval ageing_time;
        struct timeval gc_interval;
        struct timeval hello_timer_value;
        struct timeval tcn_timer_value;
        struct timeval topology_change_timer_value;
        struct timeval gc_timer_value;

        long  haveStpSpecification;
        long  havePriority;
        long  haveTopologyChangeTimer;
        long  haveTopologyChange;
        long  haveDesignatedRoot;
        long  haveRootCost;
        long  haveRootPort;
        long  haveMaxAge;
        long  haveHelloTime;
        long  haveHoldTime;
        long  haveForwardDelay;
        long  haveBridgeMaxAge;
        long  haveBridgeHelloTime;
        long  haveBridgeForwardDelay;
}nBr,*br = &nBr;

#endif

#if ! defined(LINUX_VERSION_CODE)
#include <linux/version.h>
#endif
#if ( LINUX_VERSION_CODE == KERNEL_VERSION(2,6,27) )
#define BRCTL_GET_FDB_ENTRIES2 25

struct fdb_userinfo
{
        __u8 mac_addr[6];
        __u16 port_no;
        __u8 is_local;
        __u32 ageing_timer_value;
        __u16 vlan_id;
        char ifname[16];
};
#endif



#ifdef BRCTL_GET_FDB_ENTRIES2 // define in linux 2.6.27.41 if_bridge.h 
int br_read_fdb(const char *bridge, struct fdb_userinfo *fdbs,
                unsigned long offset, int num);
static inline void __copy_fdb(struct fdb_userinfo *ent,
                              const struct fdb_userinfo *f);
#else

int br_read_fdb(const char *bridge, struct fdb_entry *fdbs,
                unsigned long offset, int num);
static inline void __copy_fdb(struct fdb_entry *ent,
                              const struct __fdb_entry *f);

#endif
static void initBrStructs();
int br_make_fdb_list();
void dot1dTpFdbTable_flushLists();
static int compare_fdbs(const void *_f0, const void *_f1);
int dot1dTpFdbTable_loadData();


#endif                          /* DOT1DBRIDGE_H */
