/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf 14476 2006-04-18 17:36:51Z hardaker $
 */
#ifndef DOT1DSTP_H
#define DOT1DSTP_H

/* function declarations */
void init_dot1dStp(void);

FindVarMethod var_dot1dStp;
FindVarMethod var_dot1dStpPortTable;
    WriteMethod write_dot1dStpPriority;
    WriteMethod write_dot1dStpBridgeMaxAge;
    WriteMethod write_dot1dStpBridgeHelloTime;
    WriteMethod write_dot1dStpBridgeForwardDelay;
    WriteMethod write_dot1dStpPortPriority;
    WriteMethod write_dot1dStpPortEnable;
    WriteMethod write_dot1dStpPortPathCost;

/****************************************************************************
 *                               Includes                                    *
 ****************************************************************************/
#include <sys/queue.h>


/****************************************************************************
 *                             Linked List Defines                           *
 ****************************************************************************/
#ifndef LIST_EMPTY
#define       LIST_EMPTY(head)        ((head)->lh_first == NULL)
#endif

#ifndef LIST_NEXT
#define       LIST_NEXT(elm, field)   ((elm)->field.le_next)
#endif

#ifndef LIST_INSERT_BEFORE
#define       LIST_INSERT_BEFORE(listelm, elm, field) do {                    \
    (elm)->field.le_prev = (listelm)->field.le_prev;              \
    LIST_NEXT((elm), field) = (listelm);                          \
    *(listelm)->field.le_prev = (elm);                            \
    (listelm)->field.le_prev = &LIST_NEXT((elm), field);          \
} while (0)
#endif

#ifndef LIST_FIRST
#define       LIST_FIRST(head)        ((head)->lh_first)
#endif

/****************************************************************************
 *                              Defines                                     *
 ****************************************************************************/

#define IFINDEX_LEN                          4
#define IFNAME_LEN                          16

#define BR_UID_LEN  IFINDEX_LEN
#define PI_UID_LEN  IFINDEX_LEN

#define IEEE80211_ADDR_LEN              6               /* size of 802.11 address */
#define     IEEE80211_RATE_MAXSIZE  15			/* max rates we'll handle */
#define ETHER_ADDR_LEN          6       /* length of an Ethernet address */

/****************************************************************************
 *                           Linked List Structure                           *
 ****************************************************************************/
#ifndef _MIBGROUP_IEEE802DOT11_H
#define _MIBGROUP_IEEE802DOT11_H
static struct avNode {
    LIST_ENTRY ( avNode ) nodes;
    char *data;                                 // pointer to data
};
#endif

typedef LIST_HEAD ( , avNode ) stpList_t;

#ifndef _LIBBRIDGE_H
#define _LIBBRIDGE_H

#include <net/if.h>
#include <linux/if_bridge.h>


struct bridge_id {
        unsigned char prio[2];
        unsigned char addr[6];
};

static struct bridge_info {
	
	char  UID       [ BR_UID_LEN + 1 ];               // unique ID
        char  ifName[IFNAMSIZ];
	long  ifIndex;
	
	long  stpSpecification;
	long  priority;
        struct bridge_id designated_root;
        struct bridge_id bridge_id;
        int root_path_cost;
        struct timeval max_age;
        struct timeval hello_time;
	int hold_time;
        struct timeval forward_delay;
        struct timeval bridge_max_age;
        struct timeval bridge_hello_time;
        struct timeval bridge_forward_delay;
        unsigned topology_change:1;
        unsigned topology_change_detected:1;
        int root_port;
        unsigned stp_enabled:1;
        struct timeval ageing_time;
        struct timeval gc_interval;
        struct timeval hello_timer_value;
        struct timeval tcn_timer_value;
        struct timeval topology_change_timer_value;
        struct timeval gc_timer_value;
	
	long  haveStpSpecification;
	long  havePriority;
	long  haveTopologyChangeTimer;
	long  haveTopologyChange;
	long  haveDesignatedRoot;
	long  haveRootCost;
	long  haveRootPort;
	long  haveMaxAge;
	long  haveHelloTime;
	long  haveHoldTime;
	long  haveForwardDelay;
	long  haveBridgeMaxAge;
	long  haveBridgeHelloTime;
	long  haveBridgeForwardDelay;
}nBr,*br = &nBr;

static stpList_t brList;

static struct port_info {
	char  UID       [ PI_UID_LEN + 1 ];               // unique ID
	char  ifName    [ IFNAME_LEN + 1 ];               // ifName of card
	long  brIndex;
	long  ifIndex;
	long  index;

        struct bridge_info *parent;
        struct bridge_id designated_root;
        struct bridge_id designated_bridge;
        u_int16_t port_id;
	unsigned char stpPort;
	unsigned char portPriority;
        u_int16_t designated_port;
        int path_cost;
        int designated_cost;
        int state;
	int portEnable;
        unsigned top_change_ack:1;
        unsigned config_pending:1;
        struct timeval message_age_timer_value;
        struct timeval forward_delay_timer_value;
        struct timeval hold_timer_value;
        unsigned stp_enabled:1;
	
	long  havePort;
	long  havePortPriority;
	long  havePortState;
	long  havePortEnable;
	long  havePortPathCost;
	long  havePortDesignatedRoot;
	long  havePortDesignatedCost;
	long  havePortDesignatedBridge;
	long  havePortDesignatedPort;
	long  havePortForwardTransitions;
}bPo,*bp = &bPo;

static stpList_t bpList;


extern struct bridge *bridge_list;

int br_loadData(void);
int br_ioctl(unsigned long arg0, unsigned long arg1, unsigned long arg2);
int br_device_ioctl32(struct bridge_info *br, unsigned long arg0, unsigned long arg1, unsigned long arg2, unsigned long arg3);
int br_device_ioctl(struct bridge_info *br, unsigned long arg0, unsigned long arg1, unsigned long arg2, unsigned long arg3);
int br_get_version();
void br_nuke_bridge(struct bridge *b);
int br_make_bridge_list();

static int opensock(void);
int br_read_info(struct bridge_info *br);
char *if_indextoname(unsigned int ifindex, char *ifname);
//print information of bridge 
void br_dump_info(struct bridge_info *br);
//print information of port
void br_dump_port_info(struct port_info *p);
void br_dump_bridge_id(unsigned char *x);
void br_show_timer(struct timeval *tv);
void br_dump_info(struct bridge_info *br);

#endif /*_LIBBRIDGE_H*/
config_require(util_funcs)
#endif /* DOT1DSTP_H */
