#ifndef _AGENT_H_
#define _AGENT_H_

enum report_type {
    ALL_TYPE = 0, SYSINFO_TYPE, RFLIST_TYPE, VAPLIST_TYPE, WDSLIST_TYPE,
    SCANLIST_TYPE, STALIST_TYPE, IFSTAT_TYPE
};

#define MAX_UID_LEN	256
struct repreq {
    enum report_type rep_type;
    int rep_format;
#define REP_JSON_FORMAT	1
#define REP_XML_FORMAT	2
    char rep_uid[MAX_UID_LEN];
    int rep_method;
#define REP_METHOD_ACTIVE 1
#define REP_METHOD_PASSIVE 2
    /* 
     * This is the pointer of output string, the memory of this pointer is
     * allocated by strdup()/strndup(), so you have to release the it by free()
     * if you don't need it anymore.
     */
    char *rep_output;
};

/** 
 * @brief Get report agent data
 * 
 * @param type listed above
 * @param format counld be JSON_FORMAT or XML_FORMAT
 * @param *output the pointer of output string, it should be free by manual 
 * 
 * @return 0 for successful, otherwise error.
 */
int report_agent_get(struct repreq *);
int getReportType(char *);

#endif
