#ifndef _COMMON_H_
#define _COMMON_H_

#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <net/if.h>
#include <dirent.h>
#include <arpa/inet.h>

#define MACLEN	6
#define SSIDLEN	32

#ifndef IFNAMSIZ
#define IFNAMSIZ 16
#endif

#define REPENT_SUCCESS		0
#define REPENT_ERR_COMMON	-1

#define PROCNET_DEV	"/proc/net/dev"

struct agent_data {
    struct platform_ops *platform;
    unsigned int 
	has_sysinfo:1,
	has_rflist:1,
	has_vaplist:1,
	has_wdslist:1,
	has_scanlist:1,
	has_stalist:1,
	has_ifstat:1;
    unsigned short max_rf;
    unsigned short max_vap;
    unsigned short max_wds;
};

#include "wireless.h"
#include "cipcfg.h"
#include "syscall.h"
#include "wlan.h"
#include "json.h"

int get_stat_by_name(char *, void *);
int getIfInfo(char *, struct ifreq *);
int get_ifstat_by_ifname(char *, struct ifstat *);
int getUidFromMac(char *);

static inline char *mac2str(unsigned char mac[6], char *value)
{
    sprintf(value, "%.2X:%.2X:%.2X:%.2X:%.2X:%.2X",
	    (unsigned char)mac[0], 
	    (unsigned char)mac[1], 
	    (unsigned char)mac[2],
	    (unsigned char)mac[3], 
	    (unsigned char)mac[4], 
	    (unsigned char)mac[5]);
    return value;
}
#endif
