#ifndef _IFSTAT_H_
#define _IFSTAT_H_

#include "common.h"

typedef struct ifstat_t {
    char ifname[IFNAMSIZ + 1];
    unsigned char hwaddr[MACLEN];
    struct sockaddr_in ipv4addr;
    struct sockaddr_in6 ipv6addr;
    unsigned short flags;
#define IFSTAT_FLAG_UP		0x01
#define IFSTAT_FLAG_RUNNING	0x02
    struct ifstat stat;
    struct ifstat_t *next;
} IFSTAT;

IFSTAT *ifstat_new(void);
void ifstat_free(IFSTAT *);
void ifstat_free_list(IFSTAT **);
int get_iflist(struct agent_data *, IFSTAT *);
struct json_object *iflist_to_json(struct agent_data *, IFSTAT *);
#endif
