#ifndef _RFLIST_H_
#define _RFLIST_H_

#include "common.h"

typedef struct rflist_t {
    unsigned short rfid;
    unsigned char hwaddr[MACLEN];
    char ifname[IFNAMSIZ + 1];
    short txpower;
    unsigned short channel;
    unsigned short roles;
#define RFLIST_ROLES_AP		0x01
#define RFLIST_ROLES_STA	0x02
#define RFLIST_ROLES_WDS	0x04
#define RFLIST_ROLES_REP	0x08
    unsigned short n_vap;
    unsigned short n_wds;
    struct rflist_t *next;
} RFLIST;

RFLIST *rflist_new(void);
void rflist_free(RFLIST *);
void rflist_free_list(RFLIST **);
int get_rflist(struct agent_data *, RFLIST *);
struct json_object *rflist_to_json(struct agent_data *, RFLIST *);
#endif
