#ifndef _SYSINFO_H_
#define _SYSINFO_H_

#include "common.h"

enum HEALTH_T {
    HEALTH_NORMAL = 0
};

typedef struct sysinfo_t {
    char *vendor;
    char *model;
    char *version;
    char *sysname;
    char *location;
    char *desc;
    unsigned short nphyif;
    unsigned short nrfif;
    unsigned short nethif;
    enum HEALTH_T health;
} SYSINFO;

SYSINFO *sysinfo_init(void);
void sysinfo_free(SYSINFO *);
int get_sysinfo(struct agent_data *, SYSINFO *);
struct json_object *sysinfo_to_json(struct agent_data *, SYSINFO *);
#endif
