#include <stdio.h>
#include "agent.h"

int main(int argc, char *argv[])
{
    struct repreq req;
    char *type;

    if (argc < 2) {
	fprintf(stderr, "usage: test [all|sysinfo|rflist|vaplist|wdslist|scanlist|stalist|ifstat]\n");
	return 1;
    }
    type = argv[1];

    if (strcmp(type, "all") == 0)
	req.rep_type = ALL_TYPE;
    else if (strcmp(type, "sysinfo") == 0)
	req.rep_type = SYSINFO_TYPE;
    else if (strcmp(type, "rflist") == 0)
	req.rep_type = RFLIST_TYPE;
    else if (strcmp(type, "vaplist") == 0)
	req.rep_type = VAPLIST_TYPE;
    else if (strcmp(type, "wdslist") == 0)
	req.rep_type = WDSLIST_TYPE;
    else if (strcmp(type, "scanlist") == 0)
	req.rep_type = SCANLIST_TYPE;
    else if (strcmp(type, "stalist") == 0)
	req.rep_type = STALIST_TYPE;
    else if (strcmp(type, "ifstat") == 0)
	req.rep_type = IFSTAT_TYPE;
    else {
	fprintf(stderr, "Unkonwn report type\n");
	return 1;
    }

    req.rep_format = REP_JSON_FORMAT;
    sprintf(req.rep_uid, "abcdefg");
    req.rep_method = REP_METHOD_ACTIVE;

    report_agent_get(&req);

    printf("%s\n", req.rep_output);
    free(req.rep_output);

    return 0;
}
