#ifndef _VAPLIST_H_
#define _VAPLIST_H_

#include "common.h"

typedef struct vaplist_t {
    unsigned short rfid;
    unsigned short vapid;
    char ifname[IFNAMSIZ + 1];
    unsigned char bssid[MACLEN];
    char essid[SSIDLEN + 1];
    char *desc;
    unsigned short nsta;
    struct ifstat stat;
    struct vaplist_t *next;
} VAPLIST;

VAPLIST *vaplist_new(void);
void vaplist_free(VAPLIST *);
void vaplist_free_list(VAPLIST **);
int get_vaplist(struct agent_data *, VAPLIST *);
struct json_object *vaplist_to_json(struct agent_data *, VAPLIST *);
#endif
