#ifndef _WDSLIST_H_
#define _WDSLIST_H_

#include "common.h"

typedef struct wdslist_t {
    unsigned short rfid;
    unsigned short wdsid;
    unsigned char peermac[MACLEN];
    char ifname[IFNAMSIZ + 1];
    unsigned short security;
#define WDSLIST_SECURITY_NONE	0x00
#define WDSLIST_SECURITY_WEP	0x01
#define WDSLIST_SECURITY_AES	0x02
#define WDSLIST_SECURITY_TKIP	0x03
    unsigned short conn;
#define WDSLIST_CONN_DISABLED	0x00
#define WDSLIST_CONN_CONNECTED	0x01
#define WDSLIST_CONN_DISCONN	0x02
#define WDSLIST_CONN_BLOCKED	0x03
    short snr;
    double txrate;
    double rxrate;
    struct ifstat stat;
    unsigned int idletime;
    struct wdslist_t *next;
} WDSLIST;

WDSLIST *wdslist_new(void);
void wdslist_free(WDSLIST *);
void wdslist_free_list(WDSLIST **);
int get_wdslist(struct agent_data *, WDSLIST *);
struct json_object *wdslist_to_json(struct agent_data *, WDSLIST *);
#endif
