#ifndef _WIRELESS_H_
#define _WIRELESS_H_

struct ifstat {
    unsigned long long txbyte;
    unsigned long long txcount;
    unsigned long long txerror;
    unsigned long long rxbyte;
    unsigned long long rxcount;
    unsigned long long rxerror;
};

#define		IF_TYPE_MASTER	0x01
#define    	IF_TYPE_AP	0x02
#define    	IF_TYPE_STA 	0x04
#define    	IF_TYPE_WDS 	0x08
#define    	IF_TYPE_REP	0x10
#define    	IF_TYPE_ETH	0x20

struct iflist {
    unsigned manjor_id;	/* rf id */
    unsigned minor_id; 	/* vap id */
    char if_name[IFNAMSIZ + 1];
    char if_hwaddr[MACLEN];
    unsigned short if_type;
    struct iflist *next;
};

struct wlan_if_data {
    char bssid[MACLEN];
    char essid[SSIDLEN + 1];
    char peermac[MACLEN];
    unsigned short security;
#define WLAN_SEC_NONE		0x00
#define WLAN_SEC_WEP		0x01
#define WLAN_SEC_WEP64		0x02
#define WLAN_SEC_WEP128		0x04
#define WLAN_SEC_WEP152		0x08
#define WLAN_SEC_WPA		0x10
#define WLAN_SEC_WPA_PSK	0x20
#define WLAN_SEC_WPA_RADIUS	0x40
    unsigned short conn;
#define WLAN_CONN_DISCONNECTED	0x01
#define WLAN_CONN_CONNECTED	0x02
#define WLAN_CONN_BLOCKED	0x04
    unsigned short channel;
    unsigned short txrate;
    unsigned short rxrate;
    unsigned int idletime;
    unsigned int nsta;
    short txpower;
    short snr;
    struct ifstat stat;
    struct wlan_if_data *next;
};

#endif
