#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <cipcfg.h>
#include <wlan.h>
#include "wdschk.h"

extern const int gid_wds_link[][MAX_WDS_LINK];

struct wds_data *backend_get_wds_list(int *count)
{
    CIPCFG *cipcfg = NULL;
    struct wds_data *wds_list = NULL, *wds = NULL;
    char value[MAX_VALUE_LEN];
    int i, rfidx = 0;

    *count = 0;

    if ((cipcfg = init_cipcfg()) < 0) {
	dbg_printf("Can't open cipcfg.\n");
	return NULL;
    }

    for (i = 0; i < MAX_WDS_LINK; i++) {
	/* Find enabled WDS link */
	memset(value, 0, MAX_VALUE_LEN);
	get_cfg_item(cipcfg, gid_wds_link[rfidx][i], "state", value);
	if (strcmp("enable", value) == 0) {
	    /* Get the MAC of enabled WDS link */
	    memset(value, 0, MAX_VALUE_LEN);
	    get_cfg_item(cipcfg, gid_wds_link[rfidx][i], "mac", value);
	    if (strlen(value) > 0) {
		wds_list = realloc(wds_list, 
			sizeof(struct wds_data) * (++(*count)));
		wds = wds_list + (*count - 1);
		sscanf(value, "%02hhX:%02hhX:%02hhX:%02hhX:%02hhX:%02hhX", 
			&wds->mac[0], &wds->mac[1], &wds->mac[2],
			&wds->mac[3], &wds->mac[4], &wds->mac[5]);
		get_wds_ifname_by_idx(rfidx, i, wds->ifname);
		wds->status = WDS_LINK_DOWN;
		wds->l2 = NULL;
		time(&wds->timestamp);
		dbg_printf("Found enabled WDS peer %s (%s).\n", 
			wds->ifname, value);
	    } else {
		dbg_printf("Found enabled WDS peer w/o MAC, ignore it.\n");
	    }
	}
    }
    close_cipcfg(cipcfg);
    return wds_list;
}
