#ifndef _COMMON_H_
#define _COMMON_H_

#include <stdio.h>

extern int enable_debug;

#define dbg_printf(format, args...) 				\
    do { 							\
	if (enable_debug) { 					\
	    fprintf(stderr, "<DEBUG:%s:%d> " format, 		\
		    __FILE__, __LINE__, ##args); 		\
	} 							\
    } while(0)

typedef unsigned long long u64;
typedef unsigned int u32;
typedef unsigned short u16;
typedef unsigned char u8;

#ifndef os_memcpy
#define os_memcpy(d, s, n) memcpy((d), (s), (n))
#endif
#ifndef os_memmove
#define os_memmove(d, s, n) memmove((d), (s), (n))
#endif
#ifndef os_memset
#define os_memset(s, c, n) memset((s), (c), (n))
#endif
#ifndef os_memcmp
#define os_memcmp(s1, s2, n) memcmp((s1), (s2), (n))
#endif
#ifndef os_zalloc
#define os_zalloc(n) malloc(n)
#endif
#ifndef os_strlcpy
#define os_strlcpy(d, s, n) strncpy((d), (s), (n))
#endif
#ifndef os_free
#define os_free(p) free((p))
#endif

#endif /* _COMMON_H_ */
