#ifndef _WDSCHK_H_
#define _WDSCHK_H_

#include <time.h>
#include <net/if.h>
#include <linux/if_ether.h>
#include <event.h>
#include "common.h"
#include "l2_packet.h"

#define ETH_P_WDSCHK	0xdead

#define DEF_WDSCHK_INT_IN_SEC	15

#define evtimer_once(cb, arg, tv) \
    event_once(-1, EV_TIMEOUT, (cb), (arg), (tv))

struct wds_data {
    unsigned char mac[ETH_ALEN];
    char ifname[IFNAMSIZ + 1];
    enum { WDS_LINK_DOWN = 0, WDS_LINK_ACTIVE } status;
#define IS_WDS_ALIVE(wds)	((wds)->status == WDS_LINK_ACTIVE)
    struct l2_packet_data *l2;
    time_t timestamp;
};

#define MAX_BRIDGE	16

struct wdschk_data {
    struct l2_packet_data *br_l2[MAX_BRIDGE];
    struct wds_data *wds_list;
    int wds_num;
    struct event ev_ping;
    struct timeval interval;
    struct event ev_unix;
};

typedef enum { WDSCHK_PING = 0, WDSCHK_PONG = 1 } wdschk_t;

struct wdschk_data *wdschk_init(char *bridge_ifs[], int br_num, 
		struct timeval *tv);
void wdschk_deinit(struct wdschk_data *wdschk);

#endif /* _WDSCHK_H_ */
// vim:ts=8:sw=4:noet
