/* wdsdm.c
 *
 * WDS Discovery Master deamon
 * 
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>

#include "wdsd.h"

char ifname[16];

void usage(void)
{
    printf("Usage: wdsdm [-s sceret key] [-o output file] [-i rfno] [-I interface name ] [-c channel] [-m mode]\n");
}

void exit_wdsdm(int sig)
{
    char buf[256];

    sprintf(buf, "ifconfig %s down", ifname);
    system(buf);

#if 0
    sprintf(buf, "wlanconfig %s destroy", ifname);
    system(buf);
#endif

    printf("Terminal wdsdm for %s\n", ifname);
    exit(-1);
}

int main(int argc, char **argv)
{
    struct wdsd_data wds_m;
    char buf[256];
    char output[256];
    char mac[18];
    int i;
    struct sigaction act; 
    
    wds_m.master=1; //master
    wds_m.mode=0; //auto
    wds_m.channel=0; //auto
    wds_m.rfno=1; //default is wifi1
    wds_m.secret[0]='\0';
    wds_m.ssid[0]='\0';
    wds_m.wep[0]='\0';
    wds_m.output_file=NULL;
    memset(ifname, 0, 16);
    /* parse the input parameter */
    for (i=1; i<argc; i++) {
        if (!strcmp(argv[i], "-s")) {
            strncpy(wds_m.secret, argv[i+1], sizeof(wds_m.secret) - 1);
	    wds_m.secret[31] = '\0';
            i++;
            continue;
        }
        else if (!strcmp(argv[i], "-o")) {
            wds_m.output_file=argv[i+1];
            i++;
            continue;  
        }
        else if (!strcmp(argv[i], "-i")) {
            wds_m.rfno=atoi(argv[i+1]);
            if (wds_m.rfno < 0 || wds_m.rfno > 3) {
                printf("Error: rfno must be 0-3\n");
                return -1;
            }
            i++;
            continue;
        }
        else if (!strcmp(argv[i], "-I")) {
            if((argv[i+1] == '-') || (strlen(argv[i+1]) > 16)){
                printf("Error: Interface name is not correct./n");
                return -2;
            }
            strncpy(ifname, argv[i+1], strlen(argv[i+1]));
            i++;
            continue;
        }
        if (!strcmp(argv[i], "-c")) {
            wds_m.channel=atoi(argv[i+1]);
            i++;
            continue;
        }
        else if (!strcmp(argv[i], "-m")) {
            wds_m.mode=atoi(argv[i+1]);
            if (wds_m.mode < 0 || wds_m.mode > 3) {
                printf("Error, wrong mode, it must be 0-3\n");
                return -1;
            }
            i++;
            continue;
        }
        /*
        else if (!strcmp(argv[i], "-r")) {
            wds_m.rate=argv[i+1];
            i++;
            continue;
        }
        */
        else {
            usage();
            return -1;
        }
    }

//    sprintf(ifname, "wdsdm%d", wds_m.rfno);
    if(strlen(ifname) == 0){
        printf("Please specify interface name.\n");
        return -3;
    }

    if (wds_m.secret == NULL || wds_m.output_file == NULL) {
        printf("Error, no secret key or output file name\n");
        usage();
        return -1;
    }
    
    /* create WDS master interface */
    if (!isIfExist(ifname)) {
/*
        sprintf(buf, "wlanconfig %s create wlandev wifi%d wlanmode ap",
        ifname, wds_m.rfno);
        system(buf);
*/
        printf("The interface is not exist!!");
        return -4;
    }
    
    sprintf(buf, "ifconfig %s up", ifname);
    system(buf);

    /* Generate SSID, WEP Key and set it */
    //gen_master_key(&wds_m);
    if (get_mac(ifname, mac) != 0) {
        printf("Can't get MAC address of %s\n", ifname);
        return -1;
    }
    gen_ssid(&wds_m, mac);
    gen_wep_key(&wds_m, mac);

    // Must down interface berofre set wep key
    sprintf(buf, "ifconfig %s down", ifname);
    system(buf);

    sprintf(buf, "iwconfig %s essid %s", ifname, wds_m.ssid);
    system(buf);
    
    sprintf(buf, "iwconfig %s key %s", ifname, wds_m.wep);
    system(buf);
    sprintf(buf, "iwpriv %s authmode 2", ifname);
    system(buf);

    sprintf(buf, "iwpriv %s mode %d", ifname, wds_m.mode);
    system(buf);
    
    sprintf(buf, "iwconfig %s channel %d", ifname, wds_m.channel);
    system(buf);

    sprintf(buf, "iwconfig %s rate auto", ifname);
    system(buf);

    sprintf(buf, "ifconfig %s up", ifname);
    system(buf);
    
    sigemptyset (&act.sa_mask); 
    act.sa_flags = 0; 
    act.sa_handler = (void *) exit_wdsdm; 
    sigaction(SIGINT, &act, NULL); 
    sigaction(SIGHUP, &act, NULL); 
    sigaction(SIGTERM, &act, NULL); 

    while(1) {
        FILE *ifp = NULL, *ofp = NULL;

        /* if the associate STA just down, not de-associate. 
         * the associate_sta will keep info at last 2min.
         * Therefore, we can polling the associate_sta every 1min.
         * And refresh the output every 1min
         */
        sprintf(buf, "/proc/net/madwifi/%s/associated_sta", ifname);
        if ((ifp=fopen(buf, "r")) == NULL) {
            printf("Can't open file %s \n", buf);
            break;
        }
        else {
            while(fgets(buf, sizeof(buf), ifp) != NULL) {
                if (strstr(buf, "macaddr")) {
                    /* the string format is "macaddr: <00:0b:6b:4e:99:3e>" */
                    if (ofp == NULL) {
                        ofp=fopen(wds_m.output_file, "w");
                    }

                    buf[10+17]='\0';
                    sprintf(output, "MAC: %s\n", &buf[10]);
                    if (ofp != NULL) {
                        fputs(output, ofp);
                    }
                    //printf("New WDS peer added %s\n", &buf[10]);
                    /* Get signal quality */
                    if (fgets(buf, sizeof(buf), ifp) != NULL) {
                        if ((strstr(buf, "rssi")) && ofp) {
                            sprintf(output, "RSSI: %s", &buf[6]);
                            fputs(output, ofp);
                        }
                    }
                }
            }
            if (ofp != NULL) {
                fclose(ofp);
                ofp=NULL;
            }
            fclose(ifp);
        }
        sleep(5); //5 sec
    }

    return 0;
}

