/* wdsds.c
 *
 * WDS Discovery Slaver
 * 
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "wdsd.h"

char ifname[16];
char peer_mac[18];
char tmp_file[32];

void usage(void)
{
    printf("Usage: wdsds scan [-s sceret key] [-o output file] [-i rfno] [-I interface name ] [-c channel] [-m mode]\n");
    printf("            add [-a remote mac] [-s sceret key] [-i rfno] [-c channel] [-m mode]\n");
}


int scan_peer(struct wdsd_data wds_s)
{
    FILE *ifp, *ofp;
    char buf[256];


    if (!isIfExist(ifname)) {
/*
        sprintf(buf, 
        "wlanconfig %s create wlandev wifi%d wlanmode sta nosbeacon",
        ifname, wds_s.rfno);
        system(buf);
*/
        printf("The interface is not exist!!");
        return -4;
    }

#if 0
    /* Russell: leave these parameters alone for now */
    sprintf(buf, "iwpriv %s mode %d", ifname, wds_s.mode);
    system(buf);
    
    /* When up the STA will change the channel number. 
     * We need reset the channel on AP interface to recover correctly channel
     * Notice!! When AP mode exist, we must set the channel on AP mode interface
     */
    sprintf(buf, "iwconfig %s channel %d", ifname, wds_s.channel);
    system(buf);

    sprintf(buf, "iwconfig %s rate auto", ifname);
    system(buf);
#endif

    sprintf(buf, "/sbin/iwpriv %s bgscan 0 > /dev/null", ifname);
    system(buf);

    sprintf(buf, "/sbin/ifconfig %s up", ifname);
    system(buf);

    sprintf(buf, "/sbin/iwlist %s scanning > /dev/null", ifname);
    system(buf);

    sleep(3) ;

    sprintf(buf, "/sbin/wlanconfig %s list ap > %s", ifname, tmp_file);
    system(buf);

    sprintf(buf, "/sbin/iwpriv %s bgscan 0 > /dev/null", ifname);
    system(buf);

    sprintf(buf, "/sbin/ifconfig %s down", ifname);
    system(buf);

#if 0
    // Do not destroy the interface
    sprintf(buf, "wlanconfig %s destroy", ifname);
    system(buf);
#endif

    bzero(buf, 256);

    if ((ifp=fopen(tmp_file, "r")) == NULL ||
        (ofp=fopen(wds_s.output_file, "w")) == NULL) {
        printf("Can't open file %s or %s\n", tmp_file, wds_s.output_file);
        return -1;
    }
    // skip parse first line, always put in output
    fgets(buf, sizeof(buf), ifp);
    fputs(buf, ofp);

    while(fgets(buf, sizeof(buf), ifp) != NULL) {
        char *mac, *ssid, tmp[256];

        strncpy(tmp, buf, sizeof(tmp));

        ssid=strtok(tmp, " ");
        /* The MAC address must be upper alphabet */
        mac=strtok(NULL, " ");
        gen_ssid(&wds_s, mac);
        if (!strcmp(wds_s.ssid, ssid)) {
            fputs(buf, ofp);
        }
    }

    fclose(ifp);
    fclose(ofp);

    return 0;
}

int add_peer(struct wdsd_data wds_s)
{
#if 0
    // Add_peer function is unstable, disabled for now
    char buf[256];
    int i, count=0, ret=-1;
    FILE *fp;

    sprintf(buf, "wlanconfig %s create wlandev wifi%d wlanmode sta nosbeacon",
        ifname, wds_s.rfno);
    system(buf);

    sprintf(buf, "iwconfig %s essid %s", ifname, wds_s.ssid);
    system(buf);

    /* WEP key */
    sprintf(buf, "iwconfig %s key %s", ifname, wds_s.wep);
    system(buf);    

    /* WEP Shared key */
    sprintf(buf, "iwpriv %s authmode 2", ifname);
    system(buf);

    sprintf(buf, "iwpriv %s mode %d", ifname, wds_s.mode);
    system(buf);
    
    sprintf(buf, "iwconfig %s channel %d", ifname, wds_s.channel);
    system(buf);

    sprintf(buf, "iwconfig %s rate auto", ifname);
    system(buf);

    sprintf(buf, "ifconfig %s up", ifname);
    system(buf);

    for (i=0; i<10; i++) {
        sprintf(buf, "iwconfig %s  > %s", ifname, tmp_file);
        system(buf);

        if ((fp=fopen(tmp_file, "r")) != NULL) {
            // skip first line "wdss_ ....."
            fgets(buf, sizeof(buf), fp);

            fgets(buf, sizeof(buf), fp);
            if (strstr(buf, peer_mac)) {
                puts(buf);
                count++;
                if (count > 1) {
                    printf("WDS %d, connect siid %s success!!\n", wds_s.rfno, wds_s.ssid);
                    ret=0; //success
                }
            }
        }
        sleep(2);
    }
    if (ret != 0) {
        printf("WDS %d, connect siid %s failure!!\n", wds_s.rfno, wds_s.ssid);
    }

    sprintf(buf, "ifconfig %s down", ifname);
    system(buf);

    sprintf(buf, "wlanconfig %s destroy", ifname);
    system(buf);
#else
    int ret = 0 ;

#endif
    return ret;

}

int main(int argc, char **argv)
{
    struct wdsd_data wds_s;
    int i, ret;

    wds_s.master=0; //slaver
    wds_s.mode=0; //auto
    wds_s.channel=0; //auto
    wds_s.rfno=1; //default is wifi1
    wds_s.secret[0]='\0';
    wds_s.ssid[0]='\0';
    wds_s.wep[0]='\0';
    wds_s.output_file=NULL;

    memset(ifname, 0, sizeof(ifname));
    if (argc < 4 || argc > 14) { 
        usage();
        return -1;
    }

    /* parse the input parameter */
    for (i=2; i<argc; i++) {
        if (!strcmp(argv[i], "-a")) { //add peer
            strncpy(peer_mac, argv[i+1], (sizeof(peer_mac)-1));
            peer_mac[17]='\0';
            i++;
            continue;
        }
        else if (!strcmp(argv[i], "-s")) { //secret key
            strncpy(wds_s.secret, argv[i+1], sizeof(wds_s.secret));
            i++;
            continue;
        }
        else if (!strcmp(argv[i], "-o")) { //output file
            wds_s.output_file=argv[i+1];
            i++;
            continue;  
        }
        else if (!strcmp(argv[i], "-i")) { //interface number
            wds_s.rfno=atoi(argv[i+1]);
            i++;
            if (wds_s.rfno < 0 || wds_s.rfno > 3) {
                printf("Error: rfno must be 0-3\n");
                return -2;
            }
            continue;
        } 
        else if (!strcmp(argv[i], "-I")) { //interface name
            if((argv[i+1] == '-') || (strlen(argv[i+1]) > 16)){
                printf("Error: Interface name is not correct./n");
                return -2;
            }
            strncpy(ifname, argv[i+1], strlen(argv[i+1]));
            i++;
            continue;
        } 
        else if (!strcmp(argv[i], "-m")) {
            wds_s.mode=atoi(argv[i+1]);
            if (wds_s.mode < 0 || wds_s.mode > 3) {
                printf("Error, wrong mode, it must be 0-3\n");
                return -1;
            }
            i++;
            continue; 
        }
        else if (!strcmp(argv[i], "-c")) { //chaneel
            wds_s.channel=atoi(argv[i+1]);
            i++;
            continue;
        }
        else {
            usage();
            return -1;
        }
    }
    
    if (strlen(wds_s.secret) < 1 || wds_s.channel == 0) {
        printf("Error: No secret key, channel!!\n");
        usage();
        return -3;
    }

//    sprintf(ifname, "wdsds%d", wds_s.rfno);
    if(strlen(ifname) == 0){
        printf("Please specify interface name.\n");
        return -3;
    }
    sprintf(tmp_file, "/tmp/tmp_wdsds%d", wds_s.rfno);

    if (!strcmp(argv[1], "add") && peer_mac) {
        gen_ssid(&wds_s, peer_mac);
        gen_wep_key(&wds_s, peer_mac);

        ret=add_peer(wds_s);
    }
    else if (!strcmp(argv[1], "scan") && wds_s.output_file) {
        scan_peer(wds_s);
    }
    else 
        usage();

}

